var wpvmachine_global_postid = 0;
var wpvmachine_global_video = '';
var wpvmachine_global_title = '';
// var wpblmachine_post_url = 0;
jQuery( document ).ready(function( $ ) {

    var opciones = {
        // Podemos declarar un color por defecto aquí
        // o en el atributo del input data-default-color
        defaultColor: false,
        // llamada que se lanzará cuando el input tenga un color válido
        change: function(event, ui){},
        // llamada que se lanzará cuando el input tenga un color no válido
        clear: function() {},
        // esconde los controles del Color Picker al cargar
        hide: true,
        // muestra un grupo de colores comunes debajo del selector
        // o suministra de una gama de colores para poder personalizar más aun.
        palettes: true
    };

    $('.wpvmach_color').wpColorPicker( opciones );
    $('.wpvmach_tags').tagEditor({
        clickDelete: true,
        placeholder: 'Enter tags ...'
    });

    $('#wpvmachine-tabs a.nav-tab').click(function(e){
        e.preventDefault();
        $(this).addClass("nav-tab-active");
        $(this).siblings().removeClass("nav-tab-active");
        var tab = $(this).attr("href");
        $(".tab-inner").not(tab).css("display", "none");
        $(tab).fadeIn();
    });

    $('#wpvmachine-tabs a.nav-tab-inner').click(function(e){
        e.preventDefault();
        var tab = $(this).attr("href");
        current_tab = $('body').find('a[href='+tab+']');
        current_tab.addClass("nav-tab-active");
        current_tab.siblings().removeClass("nav-tab-active");
        $(".tab-inner").not(tab).css("display", "none");
        $(tab).fadeIn();
    });


    $('#wpvmachine-auth-youtube').click(function(e){
        e.preventDefault();
        jQuery('#wpvmachine_yt_auth').val(1);
        jQuery('#wpvmachine-settings-form').submit();
        // wpvmachine_voice();
    });

    $('.do-auth-youtube-acc').click(function(e){
        e.preventDefault();
        var num = $(this).attr('data-account-num');
        jQuery('#wpvmachine_yt_auth').val(1);
        jQuery('#auth_youtube_num').val(num);
        jQuery('#wpvmachine-settings-form').submit();
        // wpvmachine_voice();
    });

    $('.wpvmachine_tts').change(function(e){
        e.preventDefault();
        var $this = $(this);
        if( $this.is(':checked' ) )
            jQuery('.wpvmachine_tts_row').show();
        else
            jQuery('.wpvmachine_tts_row').hide();
    });

    $('.wpvmachine_audio').change(function(e){
        e.preventDefault();
        var $this = $(this);
        if( $this.is(':checked' ) )
            jQuery('.wpvmachine_audio_row').show();
        else
            jQuery('.wpvmachine_audio_row').hide();
    });

    $('#video_language').change(function(e) {
      e.preventDefault();
      var val = $(this).val();
      // both
      if( val == 'en-us' || val == 'es-es' || val == 'de-de' ) {
        $('#voice_sex').find( 'option' ).attr( 'disabled' , '' );
        $('#voice_sex').find( 'option' ).removeAttr( 'disabled' );
      }
      /*else if( val == 'en-us' || val == 'es-es' || val == 'de-de' ) {
        // male only
      }*/
      else {
        // female only
        $('#voice_sex').val(1);
        $('#voice_sex').find( 'option[value=0]' ).attr( 'disabled' , 'disabled' );
      }
    });

    $('.wpvmachine_overlay').change(function(e){
        e.preventDefault();
        var $this = $(this);
        if( $this.is(':checked' ) )
            jQuery('.wpvmachine_overlay_row').show();
        else
            jQuery('.wpvmachine_overlay_row').hide();
    });

    $('#wpvmachine_name').blur(function(e) {
        e.preventDefault();
        var len = $.trim($('#wpvmachine_youtube_title').val()).length;
        // console.log(len)
        if(!len) {
          $('#wpvmachine_youtube_title').val($('#wpvmachine_name').val());
        }
    });

    $('#wpvmachine_content').blur(function(e) {
        e.preventDefault();
        var len = $.trim($('#wpvmachine_youtube_description').val()).length;
        // console.log(len)
        if(!len) {
          $('#wpvmachine_youtube_description').val($('#wpvmachine_content').val());
        }
    });

    jQuery( '#search-tags-auto' ).click(function(e) {
        e.preventDefault();
        $this = jQuery(this)
        var orig_html = $this.html();
        $this.html('<i class="fas fa-spinner fa-spin"></i> Searching...');
        var yt_description = jQuery.trim( jQuery('#wpvmachine_youtube_description').val() );
        if( yt_description == '' ) {
            yt_description = jQuery.trim( jQuery('#wpvmachine_content').val() );
            if( yt_description == '' ) {
                $this.html(orig_html);
                alert( 'Please enter a few words in the Youtube description so the plugin can search for automatic tags');
                return;
            }
        }
        var data = {
            action: 'wpvmachine_get_tags',
            content : yt_description
        };

        jQuery.post(ajaxurl, data, function( response ) {
            // jQuery('#wpbl-keywords').val(response);
            $this.html(orig_html);
            var ret = jQuery.parseJSON(response);
            if( ret.result == 1 ) {
                var tags = ret.tags;
                var n_tags = tags.length;
                for( i= 0; i< n_tags; i++ )
                    jQuery('#wpvmachine_youtube_tags').tagEditor( 'addTag', tags[i] );
            }
        });
    });

    jQuery( '#wpvm-do-create-video' ).click(function(e) {
        jQuery( '#wpvm-createvid' ).click();
    });

    jQuery( '#wpvm-createvid' ).click(function(e) {
        e.preventDefault();
        if( $.trim($('#wpvmachine_name').val()) == '' ){
            alert('Video Name cannot be empty');
            return;
        }

        if( $.trim($('#wpvmachine_content').val()) == '' ){
            alert('Video Content cannot be empty');
            return;
        }

        var img_num = jQuery('.image_link' ).length;
        if( !img_num ){
            alert('Please select at least one image');
            return;
        }
        jQuery('#vmsubmitv-form').submit();
    });


    // Pro

    jQuery( '.btn-close-vmmodal' ).click(function(e) {
        e.preventDefault();
        $.bmmodal.close();
    });

    jQuery( '#wpvm-spin' ).click(function(e) {
        e.preventDefault();

        if( $.trim($('#wpvmachine_content').val()) == '' ){
            alert('Video Content cannot be empty');
            return;
        }

        $('#avmspin-modal').bmmodal();
    });

    jQuery( '#btn-do-spin-text' ).click(function(e) {
        e.preventDefault();
        var $this = $(this)
        var orig_html = $this.html();
        $this.html('<i class="fas fa-spinner fa-spin"></i> Spinning...');

        var text = jQuery( '#wpvmachine_content' ).val();
        var spinner = jQuery( '#spinner' ).val();
        var data = {
            action: 'wpvmachine_spin_text',
            spinner : spinner,
            text : text,
        };

        jQuery.post(ajaxurl, data, function(response) {
            $this.html( orig_html );
            $.bmmodal.close();
            jQuery('#spin-original').val(text);
            jQuery('#spin-spun').val(response);
            $('#avmspin-modal2').bmmodal();
        });

    });

    jQuery( '#btn-use-spun-text' ).click(function(e) {
        e.preventDefault();
        var text = jQuery('#spin-spun').val();
        jQuery( '#wpvmachine_content' ).val( text );
        jQuery('#spin-original').val('');
        jQuery('#spin-spun').val('');
        $.bmmodal.close();
    });

    jQuery( '#wpvm-affiliate' ).click(function(e) {
        e.preventDefault();
        $('#avmaffiliate-modal').bmmodal();
    });

    jQuery( '#btn-search-aff-link' ).click(function(e) {
        e.preventDefault();
        var $this = $(this)
        var orig_html = $this.html();
        $this.html('<i class="fas fa-spinner fa-spin"></i> Searching...');

        var keyword = jQuery( '#wpvm-aff-keyword' ).val();
        var network = 'clickbank';
        wpvmachine_search_aff( network, keyword );
    });


    $('.tab-affiliate').click(function(e){
        e.preventDefault();
        var $this = $(this);
        var network = $this.attr( 'data-network' );
        var keyword = jQuery( '#wpvm-aff-keyword' ).val();
        wpvmachine_search_aff( network, keyword );
    });

    jQuery(document).on('click', '.btn-insert-aff-link', function(e) {
        e.preventDefault();
        var $this = $(this);
        var box = jQuery( '#wpvmachine_youtube_description' );
        var val = box.val();
        var url = $this.attr( 'data-url' );
        url = 'More info at '+url;
        box.val( url+"\r\n\r\n"+val );
        $.bmmodal.close();
    });


    jQuery( '#wpvm-translate' ).click(function(e) {
        e.preventDefault();

        if( $.trim($('#wpvmachine_content').val()) == '' ){
            alert('Video Content cannot be empty');
            return;
        }

        $('#avmtranslate-modal').bmmodal();
    });

    jQuery( '#btn-do-translate-text' ).click(function(e) {
        e.preventDefault();
        var $this = $(this)
        var orig_html = $this.html();
        $this.html('<i class="fas fa-spinner fa-spin"></i> Translating...');

        var text = jQuery( '#wpvmachine_content' ).val();
        var from = jQuery( '#wpvm_lang_from' ).val();
        var to = jQuery( '#wpvm_lang_to' ).val();

        var data = {
            action: 'wpvmachine_translate_text',
            from : from,
            to : to,
            text : text,
        };

        jQuery.post(ajaxurl, data, function(response) {
            // console.log(response);
            $this.html( orig_html );
            if( response != '0' ) {
                jQuery( '#wpvmachine_content' ).val( response );
            }
            $.bmmodal.close();
        });
    });

    jQuery( '#search-tags-manual' ).click(function(e) {
        e.preventDefault();
        $('#avmtags-modal').bmmodal();
    });

    jQuery( '#btn-search-tag' ).click(function(e) {
        e.preventDefault();
        var $this = $(this)
        var orig_html = $this.html();
        $this.html('<i class="fas fa-spinner fa-spin"></i> Searching Tags...');

        var keyword = jQuery( '#wpvm-tag-keyword' ).val();
        var network = 'google';
        wpvmachine_search_tag( network, keyword );
    });

    $('.tab-tags').click(function(e){
        e.preventDefault();
        var $this = $(this);
        var network = $this.attr( 'data-network' );
        var keyword = jQuery( '#wpvm-tag-keyword' ).val();
        wpvmachine_search_tag( network, keyword );
    });


    jQuery( '#btn-do-insert-tags' ).click(function(e) {
        e.preventDefault();
        jQuery("input.key_list_check:checked").each(function () {
            var tag = $(this).attr("value");
            jQuery('#wpvmachine_youtube_tags').tagEditor( 'addTag', tag );
        });
        $.bmmodal.close();
    });

    // Contenido

    jQuery( '#wpvm-content' ).click(function(e) {
        e.preventDefault();
        $('#avmcontent-modal').bmmodal();
    });

    jQuery( '#btn-search-content' ).click(function(e) {
        e.preventDefault();
        var $this = $(this)
        var orig_html = $this.html();
        $this.html('<i class="fas fa-spinner fa-spin"></i> Searching...');

        var keyword = jQuery( '#wpvmachine_content_keyword' ).val();
        var service = jQuery( '#wpvmachine_content_service' ).val();

        var data = {
            action: 'wpvmachine_search_content',
            keyword : keyword,
            service : service
        };

        jQuery.post(ajaxurl, data, function(response) {
            // console.log(response);
            $this.html( orig_html );
            if( response != '0' ) {
                jQuery( '#wpvmachine_content_list' ).html( response );
                jQuery( '#wpvmachine_content_list' ).show();
            }
            // $.bmmodal.close();
            // jQuery('#spin-original').val(text);
            // jQuery('#spin-spun').val(response);
            // $('#avmspin-modal2').bmmodal();
        });

    });

    jQuery(document).on('click', '.btn-view-content', function(e) {
        e.preventDefault();
        var $this = $(this);
        $this.closest( 'tr' ).find( '.wpvmachine_cont_text' ).show();
    });

    jQuery(document).on('click', '.btn-insert-content', function(e) {
        e.preventDefault();
        var $this = $(this);
        var text = $this.closest( 'tr' ).find( '.wpvmachine_cont_text textarea' ).val();
        jQuery('#wpvmachine_content').val( text );
        var img = $this.closest( 'tr' ).find( '.article_image' ).val();
        if( img != '' )
            wpvmachine_append_img( img );
        $.bmmodal.close();
    });


    // Trends

    jQuery( '#wpvm-trends' ).click(function(e) {
        e.preventDefault();
        $('#avmtrends-modal').bmmodal();
    });

    jQuery( '#btn-do-search-trends' ).click(function(e) {
        e.preventDefault();
        var $this = $(this)
        var orig_html = $this.html();
        $this.html('<i class="fas fa-spinner fa-spin"></i> Searching...');

        var data = {
            action: 'wpvmachine_search_trends',
            lang : 'en-US',
            geo : 'US'
        };

        jQuery.post(ajaxurl, data, function(response) {
            // console.log(response);
            $this.html( orig_html );
            if( response != '0' ) {
                jQuery( '#wpvmachine_trends_list' ).html( response );
                jQuery( '#wpvmachine_trends_list' ).show();
            }
            // $.bmmodal.close();
            // jQuery('#spin-original').val(text);
            // jQuery('#spin-spun').val(response);
            // $('#avmspin-modal2').bmmodal();
        });

    });

    jQuery(document).on('click', '.btn-create-video-trend', function(e) {
        e.preventDefault();
        var $this = $(this);
        var row = $this.closest( 'tr' );
        var text = '';
        var images = new Array();
        row.find( '.wpvm-article-c'  ).each(function( index ) {
            var article = jQuery(this);
            // console.log(article);
            article.find( '.article_topic' ).val()
            text += wpvmachine_strip( article.find( '.article_topic' ).val() )+ "\r\n"+wpvmachine_strip( article.find( '.article_content' ).val() )+"\r\n";
            // images.push( article.find( '.article_image' ) );
            var img = article.find( '.article_image' ).val();
            if( img != '' )
                wpvmachine_append_img( img );
        });

        jQuery('#wpvmachine_content').val( $.trim( text ) );
        var vid_name = $.trim( jQuery('#wpvmachine_name').val( ) );
        if( vid_name == '' ) {
            jQuery('#wpvmachine_name').val( row.find('.ttopic').html() );
        }
        $.bmmodal.close();
    });


    jQuery( '#btn-show-youtubes' ).click(function(e) {
        e.preventDefault();
        if( jQuery( '#wpvmcollapseYoutube').is(':visible') )
            jQuery( '#wpvmcollapseYoutube').slideUp();
        else
            jQuery( '#wpvmcollapseYoutube').slideDown();
    });

    // $("span.feat-url").on("click", function () {
    //    $(this).select();
    // });

    // lista videos
    $('.btn-share-video').click(function(e){
        e.preventDefault();
        var video_id = jQuery(this).attr( 'data-video-id' );
        wpvmachine_global_postid = video_id;
        var youtube_url = jQuery(this).attr( 'data-youtube-url' );
        wpvmachine_global_video = youtube_url;
        var video_title = jQuery(this).closest( 'tr' ).find('td.vname').html();
        wpvmachine_global_title = video_title;
        $('#avmshare-modal').bmmodal();
    });

    $('.btn-del-video').click(function(e){
        e.preventDefault();
        if( confirm( "Are you sure?\n\nYour video will be deleted.\nThis action cannot be undone")) {
            var video_id = jQuery(this).attr( 'data-video-id' );
            var data = {
                action: 'wpvmachine_delete_video',
                video_id : video_id
            };

            jQuery.post(ajaxurl, data, function(response) {
                document.location = document.location;
            });
        }
        // wpvmachine_global_postid = post_id;
        // $('#avmshare-modal').bmmodal();
    });
    
    $('#btn-do-share-video').click(function(e){
        e.preventDefault();
           // $.bmmodal.close();
           // return;
       // var link = jQuery('#custom-aff-link').val();
       var $this = $(this);
       var orig_html = $this.html();
       $this.html('<i class="fas fa-spinner fa-spin"></i> Submitting...');
       var networks = new Array();
       $( ".wpvmachine_share_nw" ).each(function( index ) {
        var nw = jQuery(this);
        if ( nw.is(':checked') )
            networks.push( 1 );
        else
            networks.push( 0 );
         // console.log( index + ": " + $( this ).text() );
       });
       // console.log(networks)
       var data = {
           action: 'wpvmachine_share_link',
           title : wpvmachine_global_title,
           url : wpvmachine_global_video,
           networks : networks
       };

       jQuery.post(ajaxurl, data, function(response) {
            $this.html( orig_html );
        
           $.bmmodal.close();
       });
    });

    $('.btn-syndicate-video').click(function(e){
        e.preventDefault();
        var video_id = jQuery(this).attr( 'data-video-id' );
        wpvmachine_global_postid = video_id;
        var youtube_url = jQuery(this).attr( 'data-youtube-url' );
        wpvmachine_global_video = youtube_url;
        var video_title = jQuery(this).closest( 'tr' ).find('td.vname').html();
        wpvmachine_global_title = video_title;
        $('#avmsyndicate-modal').bmmodal();
    });

    $('#btn-do-syndicate-video').click(function(e){
        e.preventDefault();
           // $.bmmodal.close();
           // return;
       // var link = jQuery('#custom-aff-link').val();
       var $this = $(this);
       var orig_html = $this.html();
       $this.html('<i class="fas fa-spinner fa-spin"></i> Submitting...');
       var networks = new Array();
       $( ".wpvmachine_syndicate_nw" ).each(function( index ) {
        var nw = jQuery(this);
        if ( nw.is(':checked') )
            networks.push( 1 );
        else
            networks.push( 0 );
         // console.log( index + ": " + $( this ).text() );
       });
       // console.log(networks)
       var data = {
           action: 'wpvmachine_syndicate_link',
           title : wpvmachine_global_title,
           url : wpvmachine_global_video,
           networks : networks
       };

       jQuery.post(ajaxurl, data, function(response) {
            $this.html( orig_html );
           $.bmmodal.close();
            $('#avmsyndicate-success-modal').bmmodal();
       });
    });

    $('.btn-create-video-post').click(function(e){
        e.preventDefault();
        var video_id = jQuery(this).attr( 'data-video-id' );
        wpvmachine_global_postid = video_id;
        var youtube_url = jQuery(this).attr( 'data-youtube-url' );
        wpvmachine_global_video = youtube_url;
        var video_title = jQuery(this).closest( 'tr' ).find('td.vname').html();
        wpvmachine_global_title = video_title;
        $('#newpost_name').val( video_title );
        $('#avmcreatepost-modal').bmmodal();
    });

    $('#btn-do-create-video-post').click(function(e){
        e.preventDefault();
       var $this = $(this);
       var orig_html = $this.html();
       $this.html('<i class="fas fa-spinner fa-spin"></i> Creating Post...');

       var data = {
           action: 'wpvmachine_create_post',
           title : $('#newpost_name').val(),
           url : wpvmachine_global_video
       };

       jQuery.post(ajaxurl, data, function(response) {
            var ret = jQuery.parseJSON(response);
            $('#btn-edit-new-post').attr( 'href', ret.edit );
            $('#btn-view-new-post').attr( 'href', ret.link );
            $this.html( orig_html );
           $.bmmodal.close();
            $('#avmcreatepost-success-modal').bmmodal();
       });
    });

    $('.btn-add-video-post').click(function(e){
        e.preventDefault();
        var video_id = jQuery(this).attr( 'data-post-id' );
        wpvmachine_global_postid = video_id;
        var youtube_url = jQuery(this).attr( 'data-youtube-url' );
        wpvmachine_global_video = youtube_url;
        var video_title = jQuery(this).closest( 'tr' ).find('td.vname').html();
        wpvmachine_global_title = video_title;
        // $('#newpost_name').val( video_title );
        $('#avmaddtopost-modal').bmmodal();
    });

    $('#btn-do-addvideo-post').click(function(e){
        e.preventDefault();
       var $this = $(this);
       var orig_html = $this.html();
       $this.html('<i class="fas fa-spinner fa-spin"></i> Creating Post...');

       var data = {
           action: 'wpvmachine_addto_post',
           post_id : wpvmachine_global_postid,
           url : wpvmachine_global_video,
           position : jQuery( '#wherepost' ).val()
       };

       jQuery.post(ajaxurl, data, function(response) {
            var ret = jQuery.parseJSON(response);
            $('#btn-edit-new-post2').attr( 'href', ret.edit );
            $('#btn-view-new-post2').attr( 'href', ret.link );
            $this.html( orig_html );
           $.bmmodal.close();
            $('#avmaddtopost-success-modal').bmmodal();
       });
    });

	/*jQuery( '.button-get-backlinks' ).click(function(e) {
		e.preventDefault();
		$this = jQuery( this );
		wpblmachine_post_id = $this.closest( 'tr' ).find( '.post_id' ).html();
		// alert(wpblmachine_post_id)
		// wpblmachine_post_url = $this.closest( 'tr' ).find( '.post_url' ).attr( 'href' );
		jQuery( '#wpbl-post-name' ).html( $this.closest( 'tr' ).find( '.post_name' ).html() );
		jQuery( '#wpbl-backlinks-num' ).val( 10 );
		jQuery( '#wpbl-keywords' ).val( '' );
		jQuery( '#get-backlinks-table' ).show();
		jQuery( '#wpblmachine-results' ).hide();
        jQuery( '#bl-notags' ).hide();
 		jQuery( '#wpblmodal' ).bmmodal();
	});

	jQuery( '#do-get-backlinks' ).click(function(e) {
		e.preventDefault();
		$this = jQuery( this );
		if( jQuery( '#wpbl-keywords' ).val() == '' ) {
			alert( 'Error: the keywords field cannot be empty' );
			return false;
		}
		wplmachine_request_backlinks( $this )
		//jQuery( '#wpblmodal' ).modal( 'close' );
	});

    jQuery( '#blm-import-from-tags' ).click(function(e) {
        e.preventDefault();
        $this = jQuery(this)
        var orig_html = $this.html();
        $this.html( 'Working...' );
        jQuery('#bl-notags').hide();

        var data = {
            action: 'wpblmachine_get_tags',
            post_id : wpblmachine_post_id
        };

        jQuery.post(ajaxurl, data, function( response ) {
            jQuery('#wpbl-keywords').val(response);
            if( response == '' )
                jQuery('#bl-notags').show();
            // jQuery( '#wpblmachine-results' ).html( response );
            // jQuery( '#get-backlinks-table' ).hide();
            // jQuery( '#wpblmachine-results' ).show();
            $this.html( orig_html );
        });
    });

    jQuery( '#wpblmachine_auto' ).change(function(e) {
        e.preventDefault();
        $this = jQuery( this );
        if( $this.is(':checked') ) {
            jQuery('#num-backlinks-row').show();
            jQuery('#standard-kw-row').show();
            jQuery('#kw-tags-row').show();
        }
        else {
            jQuery('#num-backlinks-row').hide();
            jQuery('#standard-kw-row').hide();
            jQuery('#kw-tags-row').hide();
        }
    });
*/
    jQuery( '#wpvm-post-types' ).change(function(e) {
        e.preventDefault();
        $this = jQuery( this );
        var val = $this.val();
        if( !val )
            val = 'post';
        // console.log(wpvmachine_vars)
        // return;
        document.location = wpvmachine_vars.log_url+'&posttype='+val;
        return;
    });

    jQuery( '#do-reset-term' ).click(function(e) {
        e.preventDefault();
        val = jQuery('#wpblm-post-types').val();
        if( !val )
            val = 'post';

        document.location = wpvmachine_vars.log_url+'&posttype='+val;
        return;
    });

    jQuery( '#upload_youtube' ).change(function(e) {
        e.preventDefault();
        var is_checked = jQuery(this).is(':checked');
        if( is_checked )
            jQuery('.yt-settings').show();
        else
            jQuery('.yt-settings').hide();

        return;
    });
    
    /* 1.2. WP Image Selector */
    var _custom_media = true,
    _orig_send_attachment = wp.media.editor.send.attachment;

    jQuery(document).on('click', '.wpvmachine_img_upload', function(e) {
        e.preventDefault();
        try {
        var send_attachment_bkp = wp.media.editor.send.attachment;
        var button = jQuery(this);
        _custom_media = true;
        wp.media.editor.send.attachment = function(props, attachment){
            // console.log('a')
            if ( _custom_media ) {
            // console.log('b')

                // console.log(attachment)
                 // parent = button.closest('.file-upload-parent');
                // parent.find('.file-upload-url').val('aaa')
                // parent.find('.file-upload-url').val(attachment.url)
                // jQuery('.file-upload-url').trigger('change');
                // parent.find('.file-upload-img').attr('src', attachment.url)
                // parent.find('.file-upload-img').show();
                wpvmachine_append_img( attachment.url )
                // wp.media.editor.send.attachment = send_attachment_bkp;
                // return true;
            } else {
                // console.log('c')
                return _orig_send_attachment.apply( this, [props, attachment] );
            };
        }
          // document.getElementById("demo").innerHTML = err.message;
        wp.media.editor.open(button);
        return false;
        }
        catch(err) {
// console.log('d')
// console.log('e')
        }
    });

    $("ul.reorder-photos-list").sortable({ tolerance: 'pointer' });

    jQuery(document).on('click', '.gallery1 .btn-delete-img', function(e) {
      e.preventDefault();
      var $this = $(this);
      $this.closest('li').remove();
    });

});
/*
function wplmachine_request_backlinks( button ) {
	button.html( 'Working...' );

	var data = {
		action: 'wpblmachine_get_backlinks',
		post_id : wpblmachine_post_id,
		num : jQuery( '#wpbl-backlinks-num' ).val(),
		keywords : jQuery( '#wpbl-keywords' ).val()
	};

	jQuery.post(ajaxurl, data, function( response ) {
		jQuery( '#wpblmachine-results' ).html( response );
		jQuery( '#get-backlinks-table' ).hide();
		jQuery( '#wpblmachine-results' ).show();
		button.html( 'Get backlinks!' );
	});
}

function wplmachine_addparameter( url, parameterName, parameterValue, atStart ){
    replaceDuplicates = true;
    if(url.indexOf('#') > 0){
        var cl = url.indexOf('#');
        urlhash = url.substring(url.indexOf('#'),url.length);
    } else {
        urlhash = '';
        cl = url.length;
    }
    sourceUrl = url.substring(0,cl);

    var urlParts = sourceUrl.split("?");
    var newQueryString = "";

    if (urlParts.length > 1)
    {
        var parameters = urlParts[1].split("&");
        for (var i=0; (i < parameters.length); i++)
        {
            var parameterParts = parameters[i].split("=");
            if (!(replaceDuplicates && parameterParts[0] == parameterName))
            {
                if (newQueryString == "")
                    newQueryString = "?";
                else
                    newQueryString += "&";
                newQueryString += parameterParts[0] + "=" + (parameterParts[1]?parameterParts[1]:'');
            }
        }
    }
    if (newQueryString == "")
        newQueryString = "?";

    if(atStart){
        newQueryString = '?'+ parameterName + "=" + parameterValue + (newQueryString.length>1?'&'+newQueryString.substring(1):'');
    } else {
        if (newQueryString !== "" && newQueryString != '?')
            newQueryString += "&";
        newQueryString += parameterName + "=" + (parameterValue?parameterValue:'');
    }
    return urlParts[0] + newQueryString + urlhash;
};
*/
function wpvmachine_append_img( src ) {
    var img_num = jQuery('.image_link' ).length;
    html = '<li id="image_li_'+img_num+'" class="ui-sortable-handle image_link"><button class="btn btn-danger btn-delete-img"><i class="fa fa-times"></i></button>'+
      '<img src="'+src+'" alt=""><input type="hidden" name="vimages['+img_num+']" value="'+src+'" /></li>';
    jQuery('.reorder-photos-list').append( html );
}

function wpvmachine_search_aff( network, keyword ) {
    jQuery('#wpvmachine-aff-'+network).html( '<i class="fas fa-spinner fa-spin"></i> Searching...' );
    jQuery('#wpvmachine-aff-'+network).show();
    var data = {
        action: 'wpvmachine_aff_links',
        network : network,
        keyword : keyword
    };

    jQuery.post(ajaxurl, data, function( response ) {
        jQuery('#btn-search-aff-link').html('<i class="fas fa-search"></i> Search');
        jQuery('#affiliate-tab-list').show();
        jQuery('.wpvmachine-aff-tab').hide();
        jQuery('#wpvmachine-aff-'+network).html( response );
        jQuery('#wpvmachine-aff-'+network).show();

        // console.log(response);
        // $.bmmodal.close();
        // jQuery('#spin-original').val(text);
        // jQuery('#spin-spun').val(response);
    });
}

function wpvmachine_search_tag( network, keyword ) {
    $('#wpvmachine-tags-'+network).html( '<i class="fas fa-spinner fa-spin"></i> Searching...' );
    $('#wpvmachine-tags-'+network).show();
    var data = {
        action: 'wpvmachine_search_tags',
        domain : network,
        keyword : keyword
    };

    jQuery.post(ajaxurl, data, function( response ) {
        jQuery('#btn-do-insert-tags').show();
        $('#btn-search-tag').html('<i class="fas fa-search"></i> Search');
        $('#tags-tab-list').show();
        $('.wpvmachine-tag-tab').hide();
        $('#wpvmachine-tags-'+network).html( response );
        $('#wpvmachine-tags-'+network).show();

        // console.log(response);
        // $.bmmodal.close();
        // jQuery('#spin-original').val(text);
        // jQuery('#spin-spun').val(response);
    });
}

function wpvmachine_strip( html )
{
   var tmp = document.createElement("DIV");
   tmp.innerHTML = html;
   return tmp.textContent || tmp.innerText || "";
}
/*
function wpvmachine_voice() {
    var IAM_access_token = '_RI85f098_9hq_hk-hEorwr75oXtiH_6LNbLBJ-LTRGj';
    var wsURI = 'wss://stream.watsonplatform.net/text-to-speech/api/v1/synthesize'
      + '?watson-token=' + IAM_access_token
      + '&voice=en-US_AllisonVoice';

    function onOpen(evt) {
      var message = {
        text: 'Hello world',
        accept: 'audio/ogg;codecs=opus'
      };
      // The service currently accepts a single message per WebSocket connection.
      websocket.send(JSON.stringify(message));
    }

    var audioParts = [];
    var finalAudio;

    function onMessage(evt) {
      if (typeof evt.data === 'string') {
        console.log('Received string message: ', evt.data)
      } else {
        console.log('Received ' + evt.data.size + ' binary bytes', evt.data.type);
        audioParts.push(evt.data);
      }
    }

    function onClose(evt) {
      console.log('WebSocket closed', evt.code, evt.reason);
      finalAudio = new Blob(audioParts, {type: 'format'});
      console.log('final audio: ', finalAudio);
    }

    function onError(evt) {
      console.log('WebSocket error', evt);
    }

    var websocket = new WebSocket(wsURI);
    websocket.onopen = onOpen;
    websocket.onclose = onClose;
    websocket.onmessage = onMessage;
    websocket.onerror = onError;
}
*/

// jQuery tagEditor v1.0.21
// https://github.com/Pixabay/jQuery-tagEditor
!function(t){t.fn.tagEditorInput=function(){var e=" ",i=t(this),a=parseInt(i.css("fontSize")),r=t("<span/>").css({position:"absolute",top:-9999,left:-9999,width:"auto",fontSize:i.css("fontSize"),fontFamily:i.css("fontFamily"),fontWeight:i.css("fontWeight"),letterSpacing:i.css("letterSpacing"),whiteSpace:"nowrap"}),l=function(){if(e!==(e=i.val())){r.text(e);var t=r.width()+a;20>t&&(t=20),t!=i.width()&&i.width(t)}};return r.insertAfter(i),i.bind("keyup keydown focus",l)},t.fn.tagEditor=function(e,a,r){function l(t){return t.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;")}var n,o=t.extend({},t.fn.tagEditor.defaults,e),c=this;if(o.dregex=new RegExp("["+o.delimiter.replace("-","-")+"]","g"),"string"==typeof e){var s=[];return c.each(function(){var i=t(this),l=i.data("options"),n=i.next(".tag-editor");if("getTags"==e)s.push({field:i[0],editor:n,tags:n.data("tags")});else if("addTag"==e){if(l.maxTags&&n.data("tags").length>=l.maxTags)return!1;t('<li><div class="tag-editor-spacer">&nbsp;'+l.delimiter[0]+'</div><div class="tag-editor-tag"></div><div class="tag-editor-delete"><i></i></div></li>').appendTo(n).find(".tag-editor-tag").html('<input type="text" maxlength="'+l.maxLength+'">').addClass("active").find("input").val(a).blur(),r?t(".placeholder",n).remove():n.click()}else"removeTag"==e?(t(".tag-editor-tag",n).filter(function(){return t(this).text()==a}).closest("li").find(".tag-editor-delete").click(),r||n.click()):"destroy"==e&&i.removeClass("tag-editor-hidden-src").removeData("options").off("focus.tag-editor").next(".tag-editor").remove()}),"getTags"==e?s:this}return window.getSelection&&t(document).off("keydown.tag-editor").on("keydown.tag-editor",function(e){if(8==e.which||46==e.which||e.ctrlKey&&88==e.which){try{var a=getSelection(),r="INPUT"!=document.activeElement.tagName?t(a.getRangeAt(0).startContainer.parentNode).closest(".tag-editor"):0}catch(e){r=0}if(a.rangeCount>0&&r&&r.length){var l=[],n=a.toString().split(r.prev().data("options").dregex);for(i=0;i<n.length;i++){var o=t.trim(n[i]);o&&l.push(o)}return t(".tag-editor-tag",r).each(function(){~t.inArray(t(this).text(),l)&&t(this).closest("li").find(".tag-editor-delete").click()}),!1}}}),c.each(function(){function e(){!o.placeholder||c.length||t(".deleted, .placeholder, input",s).length||s.append('<li class="placeholder"><div>'+o.placeholder+"</div></li>")}function i(i){var a=c.toString();c=t(".tag-editor-tag:not(.deleted)",s).map(function(e,i){var a=t.trim(t(this).hasClass("active")?t(this).find("input").val():t(i).text());return a?a:void 0}).get(),s.data("tags",c),r.val(c.join(o.delimiter[0])),i||a!=c.toString()&&o.onChange(r,s,c),e()}function a(e){for(var a,n=e.closest("li"),d=e.val().replace(/ +/," ").split(o.dregex),g=e.data("old_tag"),f=c.slice(0),h=!1,u=0;u<d.length;u++)if(v=t.trim(d[u]).slice(0,o.maxLength),o.forceLowercase&&(v=v.toLowerCase()),a=o.beforeTagSave(r,s,f,g,v),v=a||v,a!==!1&&v&&(o.removeDuplicates&&~t.inArray(v,f)&&t(".tag-editor-tag",s).each(function(){t(this).text()==v&&t(this).closest("li").remove()}),f.push(v),n.before('<li><div class="tag-editor-spacer">&nbsp;'+o.delimiter[0]+'</div><div class="tag-editor-tag">'+l(v)+'</div><div class="tag-editor-delete"><i></i></div></li>'),o.maxTags&&f.length>=o.maxTags)){h=!0;break}e.attr("maxlength",o.maxLength).removeData("old_tag").val(""),h?e.blur():e.focus(),i()}var r=t(this),c=[],s=t("<ul "+(o.clickDelete?'oncontextmenu="return false;" ':"")+'class="tag-editor"></ul>').insertAfter(r);r.addClass("tag-editor-hidden-src").data("options",o).on("focus.tag-editor",function(){s.click()}),s.append('<li style="width:1px">&nbsp;</li>');var d='<li><div class="tag-editor-spacer">&nbsp;'+o.delimiter[0]+'</div><div class="tag-editor-tag"></div><div class="tag-editor-delete"><i></i></div></li>';s.click(function(e,i){var a,r,l=99999;if(!window.getSelection||""==getSelection())return o.maxTags&&s.data("tags").length>=o.maxTags?(s.find("input").blur(),!1):(n=!0,t("input:focus",s).blur(),n?(n=!0,t(".placeholder",s).remove(),i&&i.length?r="before":t(".tag-editor-tag",s).each(function(){var n=t(this),o=n.offset(),c=o.left,s=o.top;e.pageY>=s&&e.pageY<=s+n.height()&&(e.pageX<c?(r="before",a=c-e.pageX):(r="after",a=e.pageX-c-n.width()),l>a&&(l=a,i=n))}),"before"==r?t(d).insertBefore(i.closest("li")).find(".tag-editor-tag").click():"after"==r?t(d).insertAfter(i.closest("li")).find(".tag-editor-tag").click():t(d).appendTo(s).find(".tag-editor-tag").click(),!1):!1)}),s.on("click",".tag-editor-delete",function(){if(t(this).prev().hasClass("active"))return t(this).closest("li").find("input").caret(-1),!1;var a=t(this).closest("li"),l=a.find(".tag-editor-tag");return o.beforeTagDelete(r,s,c,l.text())===!1?!1:(l.addClass("deleted").animate({width:0},o.animateDelete,function(){a.remove(),e()}),i(),!1)}),o.clickDelete&&s.on("mousedown",".tag-editor-tag",function(a){if(a.ctrlKey||a.which>1){var l=t(this).closest("li"),n=l.find(".tag-editor-tag");return o.beforeTagDelete(r,s,c,n.text())===!1?!1:(n.addClass("deleted").animate({width:0},o.animateDelete,function(){l.remove(),e()}),i(),!1)}}),s.on("click",".tag-editor-tag",function(e){if(o.clickDelete&&(e.ctrlKey||e.which>1))return!1;if(!t(this).hasClass("active")){var i=t(this).text(),a=Math.abs((t(this).offset().left-e.pageX)/t(this).width()),r=parseInt(i.length*a),n=t(this).html('<input type="text" maxlength="'+o.maxLength+'" value="'+l(i)+'">').addClass("active").find("input");if(n.data("old_tag",i).tagEditorInput().focus().caret(r),o.autocomplete){var c=t.extend({},o.autocomplete),d="select"in c?o.autocomplete.select:"";c.select=function(e,i){d&&d(e,i),setTimeout(function(){s.trigger("click",[t(".active",s).find("input").closest("li").next("li").find(".tag-editor-tag")])},20)},n.autocomplete(c)}}return!1}),s.on("blur","input",function(d){d.stopPropagation();var g=t(this),f=g.data("old_tag"),h=t.trim(g.val().replace(/ +/," ").replace(o.dregex,o.delimiter[0]));if(h){if(h.indexOf(o.delimiter[0])>=0)return void a(g);if(h!=f)if(o.forceLowercase&&(h=h.toLowerCase()),cb_val=o.beforeTagSave(r,s,c,f,h),h=cb_val||h,cb_val===!1){if(f)return g.val(f).focus(),n=!1,void i();try{g.closest("li").remove()}catch(d){}f&&i()}else o.removeDuplicates&&t(".tag-editor-tag:not(.active)",s).each(function(){t(this).text()==h&&t(this).closest("li").remove()})}else{if(f&&o.beforeTagDelete(r,s,c,f)===!1)return g.val(f).focus(),n=!1,void i();try{g.closest("li").remove()}catch(d){}f&&i()}g.parent().html(l(h)).removeClass("active"),h!=f&&i(),e()});var g;s.on("paste","input",function(){t(this).removeAttr("maxlength"),g=t(this),setTimeout(function(){a(g)},30)});var f;s.on("keypress","input",function(e){o.delimiter.indexOf(String.fromCharCode(e.which))>=0&&(f=t(this),setTimeout(function(){a(f)},20))}),s.on("keydown","input",function(e){var i=t(this);if((37==e.which||!o.autocomplete&&38==e.which)&&!i.caret()||8==e.which&&!i.val()){var a=i.closest("li").prev("li").find(".tag-editor-tag");return a.length?a.click().find("input").caret(-1):!i.val()||o.maxTags&&s.data("tags").length>=o.maxTags||t(d).insertBefore(i.closest("li")).find(".tag-editor-tag").click(),!1}if((39==e.which||!o.autocomplete&&40==e.which)&&i.caret()==i.val().length){var l=i.closest("li").next("li").find(".tag-editor-tag");return l.length?l.click().find("input").caret(0):i.val()&&s.click(),!1}if(9==e.which){if(e.shiftKey){var a=i.closest("li").prev("li").find(".tag-editor-tag");if(a.length)a.click().find("input").caret(0);else{if(!i.val()||o.maxTags&&s.data("tags").length>=o.maxTags)return r.attr("disabled","disabled"),void setTimeout(function(){r.removeAttr("disabled")},30);t(d).insertBefore(i.closest("li")).find(".tag-editor-tag").click()}return!1}var l=i.closest("li").next("li").find(".tag-editor-tag");if(l.length)l.click().find("input").caret(0);else{if(!i.val())return;s.click()}return!1}if(!(46!=e.which||t.trim(i.val())&&i.caret()!=i.val().length)){var l=i.closest("li").next("li").find(".tag-editor-tag");return l.length?l.click().find("input").caret(0):i.val()&&s.click(),!1}if(13==e.which)return s.trigger("click",[i.closest("li").next("li").find(".tag-editor-tag")]),o.maxTags&&s.data("tags").length>=o.maxTags&&s.find("input").blur(),!1;if(36!=e.which||i.caret()){if(35==e.which&&i.caret()==i.val().length)s.find(".tag-editor-tag").last().click();else if(27==e.which)return i.val(i.data("old_tag")?i.data("old_tag"):"").blur(),!1}else s.find(".tag-editor-tag").first().click()});for(var h=o.initialTags.length?o.initialTags:r.val().split(o.dregex),u=0;u<h.length&&!(o.maxTags&&u>=o.maxTags);u++){var v=t.trim(h[u].replace(/ +/," "));v&&(o.forceLowercase&&(v=v.toLowerCase()),c.push(v),s.append('<li><div class="tag-editor-spacer">&nbsp;'+o.delimiter[0]+'</div><div class="tag-editor-tag">'+l(v)+'</div><div class="tag-editor-delete"><i></i></div></li>'))}i(!0),o.sortable&&t.fn.sortable&&s.sortable({distance:5,cancel:".tag-editor-spacer, input",helper:"clone",update:function(){i()}})})},t.fn.tagEditor.defaults={initialTags:[],maxTags:0,maxLength:50,delimiter:",;",placeholder:"",forceLowercase:!0,removeDuplicates:!0,clickDelete:!1,animateDelete:175,sortable:!0,autocomplete:null,onChange:function(){},beforeTagSave:function(){},beforeTagDelete:function(){}}}(jQuery);

// http://code.accursoft.com/caret - 1.3.3
!function(e){e.fn.caret=function(e){var t=this[0],n="true"===t.contentEditable;if(0==arguments.length){if(window.getSelection){if(n){t.focus();var o=window.getSelection().getRangeAt(0),r=o.cloneRange();return r.selectNodeContents(t),r.setEnd(o.endContainer,o.endOffset),r.toString().length}return t.selectionStart}if(document.selection){if(t.focus(),n){var o=document.selection.createRange(),r=document.body.createTextRange();return r.moveToElementText(t),r.setEndPoint("EndToEnd",o),r.text.length}var e=0,c=t.createTextRange(),r=document.selection.createRange().duplicate(),a=r.getBookmark();for(c.moveToBookmark(a);0!==c.moveStart("character",-1);)e++;return e}return t.selectionStart?t.selectionStart:0}if(-1==e&&(e=this[n?"text":"val"]().length),window.getSelection)n?(t.focus(),window.getSelection().collapse(t.firstChild,e)):t.setSelectionRange(e,e);else if(document.body.createTextRange)if(n){var c=document.body.createTextRange();c.moveToElementText(t),c.moveStart("character",e),c.collapse(!0),c.select()}else{var c=t.createTextRange();c.move("character",e),c.select()}return n||t.focus(),e}}(jQuery);


