<?php

function wpvmachine_aff_links_ajax() {
	include_once WPVMACHINE_DIR.'/lib/monetize/monetize.php';
	$network = trim( $_POST['network'] );
	$keyword = trim( $_POST['keyword'] );
	$max_prods = 12;
	if( !$keyword )
	    exit();
	$products = array();
	switch( $network ) {
		case 'clickbank':
			$products = wpvmachine_do_get_cb_products( $keyword );
			break;
		case 'amazon':
			$products = wpvmachine_do_get_amazon_products( $keyword );
			break;
		case 'ebay':
			$products = wpvmachine_do_get_ebay_products( $keyword );
			break;
		case 'aliexpress':
			$products = wpvmachine_do_get_aliexpress_products( $keyword );
			break;
		case 'walmart':
			$products = wpvmachine_do_get_walmart_products( $keyword );
			break;
		case 'envato':
			$products = wpvmachine_do_get_envato_products( $keyword );
			break;
		default:
			break;
	}
	if( !empty( $products ) ) {
		$str_ret = '<table class="wp-list-table widefat fixed striped aff-table"><tr><th scope="row"></th><th scope="row">Product</th><th scope="row">Price</th><th scope="row"></th>';
		foreach( $products as $num => $product ) {
			$str_ret .= wpvmachine_aff_row( $product );
			if( $num > $max_prods )
				break;
		}
		$str_ret.='</table>';
	}
	else {
		$str_ret .= '<p>No Products Found</p>';
	}
	echo $str_ret;
	// echo wpvmachine_spin_text( $text, $spinner );
	exit();
}

function wpvmachine_aff_row( $product ) {
	$str = '<tr>
		<th scope="row"><a href="'.$product['url'].'" target="_blank"><img src="'.$product['image'].'" class="wpvm-prod-img" /></a></th>
		<th scope="row"><a href="'.$product['url'].'" target="_blank">'.$product['title'].'</a></th>
		<td>'.$product['price'].'</td>
		<td><button type="button" class="button button-secondary btn-insert-aff-link" data-url="'.$product['url'].'"><i class="fas fa-plus"></i> Insert</button></td>
		</tr>';
	return $str;
}
function wpvmachine_aff_tabs( $selected = 'clickbank' ) {
?>
	<div id="wpvmachine-tabs" >
	    <h2 class="nav-tab-wrapper">
	        <a href="#wpvmachine-aff-clickbank" class="nav-tab tab-affiliate <?php if( $selected == 'clickbank') echo 'nav-tab-active';?>" data-network="clickbank"><i class="fas fa-bell"></i> Clickbank</a>
	        <a href="#wpvmachine-aff-amazon" class="nav-tab tab-affiliate <?php if( $selected == 'amazon') echo 'nav-tab-active';?>" data-network="amazon"><i class="fab fa-amazon"></i> Amazon</a>
	        <a href="#wpvmachine-aff-ebay" class="nav-tab tab-affiliate <?php if( $selected == 'ebay') echo 'nav-tab-active';?>" data-network="ebay"><i class="fab fa-ebay"></i> Ebay</a>
	        <a href="#wpvmachine-aff-aliexpress" class="nav-tab tab-affiliate <?php if( $selected == 'aliexpress') echo 'nav-tab-active';?>" data-network="aliexpress"><i class="fab fa-alipay"></i> Aliexpress</a>
	        <a href="#wpvmachine-aff-walmart" class="nav-tab tab-affiliate <?php if( $selected == 'walmart') echo 'nav-tab-active';?>" data-network="walmart"><i class="fas fa-wallet"></i> Walmart</a>
	        <a href="#wpvmachine-aff-envato" class="nav-tab tab-affiliate <?php if( $selected == 'envato') echo 'nav-tab-active';?>" data-network="envato"><i class="fas fa-leaf"></i> Envato</a>
	    </h2>
	    <div style="clear:both"></div>
    	<div id="wpvmachine-aff-clickbank" class="tab-inner wpvmachine-aff-tab"></div>
    	<div id="wpvmachine-aff-amazon" class="tab-inner wpvmachine-aff-tab" style="display:none"></div>
    	<div id="wpvmachine-aff-ebay" class="tab-inner wpvmachine-aff-tab" style="display:none"></div>
    	<div id="wpvmachine-aff-aliexpress" class="tab-inner wpvmachine-aff-tab" style="display:none"></div>
    	<div id="wpvmachine-aff-walmart" class="tab-inner wpvmachine-aff-tab" style="display:none"></div>
    	<div id="wpvmachine-aff-envato" class="tab-inner wpvmachine-aff-tab" style="display:none"></div>
	</div>
<?php
}
/* Amazon */

function wpvmachine_get_amazon_cats() {
	return array(
		array( 'label' => 'All', 'value' => 'All'),
		array( 'label' => 'Apparel & Accessories', 'value' => 'Apparel'),
		// array( 'label' => 'Appstore for Android', 'value' => 'Appstore for Android'),
		array( 'label' => 'Arts, Crafts & Sewing', 'value' => 'ArtsAndCrafts'),
		array( 'label' => 'Automotive', 'value' => 'Automotive'),
		array( 'label' => 'Baby', 'value' => 'Baby'),
		array( 'label' => 'Beauty', 'value' => 'Beauty'),
		// array( 'label' => 'Black Friday Sales', 'value' => 'Black Friday Sales'),
		array( 'label' => 'Books', 'value' => 'Books'),
		array( 'label' => 'Camera & Photo', 'value' => 'Photo'),
		// array( 'label' => 'Car Toys', 'value' => 'Car Toys'),
		array( 'label' => 'Cell Phones & Accessories', 'value' => 'Wireless'),
		array( 'label' => 'Computer & Video Games', 'value' => 'VideoGames'),
		// array( 'label' => 'Computers', 'value' => 'Computers'),
		array( 'label' => 'Electronics', 'value' => 'Electronics'),
		array( 'label' => 'Grocery & Gourmet Food', 'value' => 'Grocery'),
		array( 'label' => 'Health & Personal Care', 'value' => 'HealthPersonalCare'),
		array( 'label' => 'Home & Garden', 'value' => 'Garden'),
		array( 'label' => 'Industrial & Scientific', 'value' => 'Industrial'),
		array( 'label' => 'Jewelry', 'value' => 'Jewelry'),
		array( 'label' => 'Kindle Store', 'value' => 'KindleStore'),
		array( 'label' => 'Kitchen & Housewares', 'value' => 'Kitchen'),
		array( 'label' => 'Magazine Subscriptions', 'value' => 'Magazines'),
		array( 'label' => 'Miscellaneous', 'value' => 'Miscellaneous'),
		array( 'label' => 'Movies & TV', 'value' => 'Movies'),
		array( 'label' => 'MP3 Downloads', 'value' => 'MP3Downloads'),
		array( 'label' => 'Music', 'value' => 'Music'),
		array( 'label' => 'Musical Instruments', 'value' => 'MusicalInstruments'),
		array( 'label' => 'Office Products', 'value' => 'OfficeProducts'),
		array( 'label' => 'Outdoor Living', 'value' => 'OutdoorLiving'),
		// array( 'label' => 'Pet Supplies', 'value' => 'PetSupplies'),
		array( 'label' => 'Pet Supplies', 'value' => 'PetSupplies'),
		array( 'label' => 'PC Hardware', 'value' => 'PCHardware'),
		array( 'label' => 'Shoes', 'value' => 'Shoes'),
		array( 'label' => 'Software', 'value' => 'Software'),
		// array( 'label' => 'Specialty Stores', 'value' => 'Specialty Stores'),
		array( 'label' => 'Sports & Outdoors', 'value' => 'SportingGoods'),
		array( 'label' => 'Tools & Hardware', 'value' => 'Tools'),
		array( 'label' => 'Toys and Games', 'value' => 'Toys'),
		array( 'label' => 'Wine', 'value' => 'Wine')
		// array( 'label' => 'Warehouse Deals', 'value' => 'Warehouse Deals')
	);
}

function wpvmachine_get_amazon_countries() {
	// private $LOCATIONS = array ('ca','com','cn', 'co.jp', 'co.uk','fr',
	//                             'it','cn');
	return array(
		array( 'label' => 'USA', 'value' => 'com'),
		array( 'label' => 'Canada', 'value' => 'ca'),
		array( 'label' => 'UK', 'value' => 'co.uk'),
		array( 'label' => 'Germany', 'value' => 'de'),
		array( 'label' => 'France', 'value' => 'fr'),
		array( 'label' => 'Italy', 'value' => 'it'),
		array( 'label' => 'Spain', 'value' => 'es'),
		array( 'label' => 'Japan', 'value' => 'co.jp'),
		array( 'label' => 'India', 'value' => 'in'),
		array( 'label' => 'Brazil', 'value' => 'com.br')
	);
}

/* Ebay */

function wpvmachine_get_ebay_cats() {
	return array(
		array( 'label' => 'Any', 'value' => 0),
		array( 'value' => '20081', 'label' => 'Antiques' ),
		array( 'value' => '550', 'label' => 'Art' ),
		array( 'value' => '2984', 'label' => 'Baby' ),
		array( 'value' => '267', 'label' => 'Books, Comics & Magazines' ),
		array( 'value' => '12576', 'label' => 'Business, Office & Industrial' ),
		array( 'value' => '625', 'label' => 'Cameras & Photography' ),
		array( 'value' => '9800', 'label' => 'Cars, Motorcycles & Vehicles' ),
		array( 'value' => '11450', 'label' => 'Clothes, Shoes & Accessories' ),
		array( 'value' => '11116', 'label' => 'Coins' ),
		array( 'value' => '1', 'label' => 'Collectables' ),
		array( 'value' => '58058', 'label' => 'Computers/Tablets & Networking' ),
		array( 'value' => '14339', 'label' => 'Crafts' ),
		array( 'value' => '237', 'label' => 'Dolls & Bears' ),
		array( 'value' => '11232', 'label' => 'DVDs, Films & TV' ),
		array( 'value' => '1305', 'label' => 'Events Tickets' ),
		array( 'value' => '159912', 'label' => 'Garden & Patio' ),
		array( 'value' => '26395', 'label' => 'Health & Beauty' ),
		array( 'value' => '3252', 'label' => 'Holidays & Travel' ),
		array( 'value' => '11700', 'label' => 'Home, Furniture & DIY' ),
		array( 'value' => '281', 'label' => 'Jewellery & Watches' ),
		array( 'value' => '15032', 'label' => 'Mobile Phones & Communication' ),
		array( 'value' => '11233', 'label' => 'Music' ),
		array( 'value' => '619', 'label' => 'Musical Instruments' ),
		array( 'value' => '1281', 'label' => 'Pet Supplies' ),
		array( 'value' => '870', 'label' => 'Pottery, Porcelain & Glass' ),
		array( 'value' => '10542', 'label' => 'Property' ),
		array( 'value' => '293', 'label' => 'Sound & Vision' ),
		array( 'value' => '888', 'label' => 'Sporting Goods' ),
		array( 'value' => '64482', 'label' => 'Sports Memorabilia' ),
		array( 'value' => '260', 'label' => 'Stamps' ),
		array( 'value' => '220', 'label' => 'Toys & Games' ),
		array( 'value' => '131090', 'label' => 'Vehicle Parts & Accessories' ),
		array( 'value' => '1249', 'label' => 'Video Games & Consoles' ),
		array( 'value' => '40005', 'label' => 'Wholesale & Job Lots' )
	);
}

function wpvmachine_get_ebay_countries() {
	return array(
		array( 'label' => 'USA', 'value' => 'US'),
		array( 'label' => 'Canada', 'value' => 'CA'),
		array( 'label' => 'UK', 'value' => 'UK'),
		array( 'label' => 'Australia', 'value' => 'AU'),
		array( 'label' => 'Germany', 'value' => 'DE'),
		array( 'label' => 'France', 'value' => 'FR'),
		array( 'label' => 'Italy', 'value' => 'IT'),
		array( 'label' => 'Spain', 'value' => 'ES'),
		array( 'label' => 'Netherlands', 'value' => 'NL'),
		array( 'label' => 'Belgium', 'value' => 'BE'),
		array( 'label' => 'Ireland', 'value' => 'IE'),
		array( 'label' => 'Austria', 'value' => 'AT'),
		array( 'label' => 'Switzerland', 'value' => 'CH'),
	);
}
?>