<?php
	// define( 'WPVMACHINE_API_URL', 'https://wpvideomachine.com/app/apiv4.php' );
	// define( 'WPVMACHINE_API_URL', 'http://localhost/wpvideomachine/apiv4.php' );
	// // define( 'WPVMACHINE_REPORTS_URL', 'https://wpvideomachine.com/app/report.php' );
	// define( 'WPVMACHINE_REPORTS_URL', 'http://localhost/wpvideomachine/request2.php' );
	// define( 'WPVMACHINE_DOWNLOAD_URL', 'http://localhost/wpvideomachine/dl-video.php' );
	define( 'WPVMACHINE_LOCAL', 0 );
	define( 'WPVMACHINE_TXT_MAX_CHARS', 7950 );

	if( WPVMACHINE_LOCAL ) {
		define( 'WPVMACHINE_API_URL', 'http://localhost/wpvideomachine/apiv4.php' );
		define( 'WPVMACHINE_REPORTS_URL', 'http://localhost/wpvideomachine/request2.php' );
		define( 'WPVMACHINE_DOWNLOAD_URL', 'http://localhost/wpvideomachine/dl-video.php' );
	}
	else {
		define( 'WPVMACHINE_API_URL', 'https://wpvideomachine.com/app/apiv4.php' );
		define( 'WPVMACHINE_REPORTS_URL', 'https://wpvideomachine.com/app/request2.php' );
		define( 'WPVMACHINE_DOWNLOAD_URL', 'https://wpvideomachine.com/app/dl-video.php' );
	}

	function wpvmachine_do_request( $url, $action = 'video', $args = false, $override_email = false ) {
		set_time_limit( 600 );
		if( !empty( $override_email ) ) {
			$user_email = $override_email;
		}
		else {
			$settings = wpvmachine_get_plugin_settings();
			// var_dump($settings);
			if ( ! isset( $settings['email'] ) || empty( $settings['email'] ) )
				return false;
			$user_email = $settings['email'];
		}

		$params = array(
			'key' => wpvmachine_generate_api_key( $user_email ),
			'email' => $user_email,
			'action' => $action
		);

		$url = add_query_arg( $params, $url );
// echo $url;
		// curl_setopt($ch, CURLOPT_POSTFIELDS, $data);

		$req_args = array(
			'method' 	  => 'POST',
		    'timeout'     => 100,
		    /*'redirection' => 5,
		    'httpversion' => '1.0',
		    'user-agent'  => 'WordPress/' . $wp_version . '; ' . home_url(),
		    'blocking'    => true,
		    'headers'     => array(),
		    'cookies'     => array(),
		    'body'        => null,
		    'compress'    => false,
		    'decompress'  => true,*/
		    'sslverify'   => false/*,
		    'stream'      => false,
		    'filename'    => null*/
		);
		if( $args ) {
			$req_args['body'] = $args;
		}

		$response = wp_remote_post( $url, $req_args );
		// var_dump($response);
		// die();
		if( is_array($response) ) {
		  $header = $response['headers']; // array of http header lines
		  $body = $response['body']; // use the content
		  // var_dump($url);
		  // echo($body);
		  // die();
		  return $body;
		}
		else {
		    $ch = curl_init();
		    curl_setopt($ch,CURLOPT_URL, $url);
    		curl_setopt($ch,CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)");
    		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
    		curl_setopt($ch,CURLOPT_FOLLOWLOCATION, 1);
    		if( $args ) {
				curl_setopt($ch, CURLOPT_POSTFIELDS, $args);
    		}
		    $data = curl_exec($ch);
		    curl_close($ch);
		    return $data;
		}
		return false;
	}

	/* Keywords is an array of keywords */
	function wpvmachine_submit_job( $title, $content, $images, $tts, $language, $voice_sex, $bg_music, $bg_track, $disable_animation, $video_quality, $overlay, $font, $text_color, $bg_color, $upload_youtube, $youtube_title, $youtube_description, $youtube_privacy, $youtube_cat, $youtube_tags, $youtube_account = 0 ) {
		// return 2136866;
		$ytClientId = $ytClientSecret = $ytAccessToken = $ytRefreshToken = '';
		if( $upload_youtube ) {
			// get info from settings
            $youtube_settings = wpvmachine_get_settings( array( 'youtube') );
            // var_dump( $youtube_settings );
            if( !empty( $youtube_settings ) ) {
            	if( !empty( $youtube_account ) ) {
            		$ytClientId = isset( $youtube_settings[$youtube_account]['client_id'] ) ? trim( $youtube_settings[$youtube_account]['client_id'] ) : '';
            		$ytClientSecret = isset( $youtube_settings[$youtube_account]['client_secret'] ) ? trim( $youtube_settings[$youtube_account]['client_secret'] ) : '';
            		$ytAccessToken = isset( $youtube_settings[$youtube_account]['token'] ) ? trim( $youtube_settings[$youtube_account]['token'] ) : '';
            		$ytRefreshToken = isset( $youtube_settings[$youtube_account]['refresh_token'] ) ? trim( $youtube_settings[$youtube_account]['refresh_token'] ) : '';
            	}
            	else {
				// var_dump($youtube_settings);
					$ytClientId = isset( $youtube_settings['client_id'] ) ? trim( $youtube_settings['client_id'] ) : '';
					$ytClientSecret = isset( $youtube_settings['client_secret'] ) ? trim( $youtube_settings['client_secret'] ) : '';
					$ytAccessToken = isset( $youtube_settings['token'] ) ? trim( $youtube_settings['token'] ) : '';
					$ytRefreshToken = isset( $youtube_settings['refresh_token'] ) ? trim( $youtube_settings['refresh_token'] ) : '';
				}
			}
		}
		$params = array(
			// 'action' => 'video',
			'name' => $title,
			'text' => wpvmachine_shorten_text( $content, WPVMACHINE_TXT_MAX_CHARS ),
			'images' => /*json_encode(*/ $images /*)*/ ,
			'tts' => $tts,
			'voiceLanguage' => $language,
			'voiceSex' => $voice_sex,
			'bgMusic' => $bg_music,
			'bgTrack' => $bg_track,
			'disableAnimation' => $disable_animation,
			'videoSize' => $video_quality,
			'overlay' => $overlay,
			'fontFamily' => $font,
			'textColor' => $text_color,
			'bgColor' => $bg_color,
			'videoTitle' => $youtube_title,
			'videoDescription' => $youtube_description,
			'videoPrivacyStatus' => $youtube_privacy,
			'videoCategoryId' => $youtube_cat,
			'videoTags' => $youtube_tags,
			'ytUploadEnabled' => $upload_youtube,
			'ytClientId' => $ytClientId,
			'ytClientSecret' => $ytClientSecret,
			'ytAccessToken' => $ytAccessToken,
			'ytRefreshToken' => $ytRefreshToken,
		);
		// var_dump($params);
		// var_dump($params);die();
		wpvmachine_did_request( 1 );
		// $url = add_query_arg( $params, WPVMACHINE_API_URL );
		$url = WPVMACHINE_API_URL;
		// die($url);
		if( WPVMACHINE_DEBUG_MODE ) {
			return array( 1, 1 );
		}
		$result = wpvmachine_do_request( $url, 'video', $params );
		// var_dump($result);
		$result = json_decode( $result );
		if( $result && $result->result )
			return array( 1, $result->text );
		return array( 0, $result->text );
	}

	// function wpvmachine_get_remaining_links( $force_read = 0 ) {
	// 	// rmi353, transient
	// 	// delete_transient( 'wpvmachine_rem_links' );
	// 	$wpvmachine_rem_links = 0;
	// 	if ( ( get_wpvmachine_did_request() == 1  ) || (false === ( $wpvmachine_rem_links = get_transient( 'wpvmachine_rem_links' ) ) ) ) {
	// 	    // It wasn't there, so regenerate the data and save the transient
	// 	    $url = add_query_arg( 'action', 'credits', WPVMACHINE_API_URL );
	// 	    $result = wpvmachine_do_request( $url );
	// 	    $result = json_decode( $result );
	// 	    // var_dump($result);
	// 	    if( !$result || !isset( $result->result ) )
	// 	    	return 0;
	// 	    if( $result->result )
	// 	     $wpvmachine_rem_links = $result->text;
	// 	 	else
	// 	 		$wpvmachine_rem_links = 0;
	// 	     set_transient( 'wpvmachine_rem_links', $wpvmachine_rem_links, 1 * HOUR_IN_SECONDS );
	// 	     wpvmachine_did_request( 0 );
	// 	}

	// 	return $wpvmachine_rem_links;
	// 	return 0;
	// }

	// function wpvmachine_do_request( $url, $action = 'video', $args = false, $override_email = false ) {
	function wpvmachine_api_test_api_key( $email, $key ) {

		// $url = add_query_arg( 'action', 'testapi', WPVMACHINE_API_URL );
		$result = wpvmachine_do_request( WPVMACHINE_API_URL, 'testapi', false, $email );
		// $result = wpvmachine_do_request( $url );
		if( empty( $result ) )
			return false;
		$result = json_decode( $result );
		if( !$result || !isset( $result->result ) )
			return false;
		if( $result->result )
			return true;
		return false;
	}

	function wpvmachine_check_valid_user( $email ) {
		// $url = add_query_arg( 'action', , WPVMACHINE_API_URL );
		$result = wpvmachine_do_request( WPVMACHINE_API_URL, 'testapi', false, $email );
		// var_dump($url);
		// var_dump($result);
		if( empty( $result ) )
			return false;
		$result = json_decode( $result );
		if( !$result || !isset( $result->result ) )
			return false;
		if( $result->result )
			return true;
		return false;
	}

	function wpvmachine_get_vstatus( $job_id ) {
		$params = array(
			'job_id' => intval( $job_id ),
		);

		$url = add_query_arg( $params, WPVMACHINE_API_URL );
		$result = wpvmachine_do_request( $url, 'videostatus' );
		$result = json_decode( $result );
		// var_dump($result);
		if( !$result || !isset( $result->result ) )
			return 0;
		if( $result->result ) {
			$status = $result->text;
			// var_du
			// $ret = json_decode( $status );
			$state = wpvmachine_status_num( $status[0] );
			return array( $state, $status[1] );
		}
	}

	function wpvmachine_status_num( $status ) {
		switch( $status ) {
			case 'error':
				return 2;
			case 'done':
			case 'processed':
				return 1;
			default:
				return 0;
		}
	}

	function wpvmachine_status_text( $status ) {
		switch( $status ) {
			case 2:
				return '<i class="fas fa-times"></i> Error';
			case 1:
				return '<i class="fas fa-check"></i> DONE';
			default:
				return '<i class="far fa-clock"></i> Processing';
		}
	}

	function wpvmachine_did_request( $val ) {
		update_option( 'wpvmachine_did_request', $val );
	}

	function get_wpvmachine_did_request() {
		return get_option( 'wpvmachine_did_request', 0 );
	}

	function wpvmachine_generate_api_key( $email ) {
	  return md5( 'VP1'.base64_encode( $email ).'XD2' );
	}
?>