<?php

function wpvmachine_get_settings( $path = array() ) {
	$settings = wpvmachine_get_plugin_settings();
	if( empty( $path ) )
		return $settings;
	$val = $settings;
	foreach( $path as $field ) {
		$val = isset( $val[ $field ] ) ? $val[ $field ] : false;
	}
	return $val;
}

function wpvmachine_get_import_settings() {
	$settings = wpvmachine_get_plugin_settings();
	if( isset( $settings['import'] ) )
		return $settings['import'];
	return array();
}

function wpvmachine_get_plugin_settings() {
	return get_option( 'wpvmachine_settings' );
}

function wpvmachine_save_plugin_settings( $settings ) {
	return update_option( 'wpvmachine_settings', $settings );
}

function wpvmachine_escape_input_txt( $text ) {
	return htmlentities( $text, ENT_QUOTES, 'UTF-8' );
}

function wpvmachine_debug( $text, $level = 'notice' ) {
	if( defined( 'WPVMACHINE_CRON_DEBUG' ) )
		echo '<p>'.$text.'</p>';
}

function wpvmachine_do_delete_video( ) {
    $video_id = isset( $_POST['video_id'] ) ? intval( $_POST['video_id'] ) : 0;
    if( $video_id ) {
    	wpvmachine_delete_video( $video_id );
    }
    echo "1";
    exit();
}

function wpvmachine_youtube_valid() {
    $youtube_settings = wpvmachine_get_settings( array( 'youtube') );
    $valid = false;
    if( !empty( $youtube_settings ) ) {
		// var_dump($youtube_settings);
		$ytClientId = isset( $youtube_settings['client_id'] ) ? trim( $youtube_settings['client_id'] ) : '';
		$ytClientSecret = isset( $youtube_settings['client_secret'] ) ? trim( $youtube_settings['client_secret'] ) : '';
		$ytAccessToken = isset( $youtube_settings['token'] ) ? trim( $youtube_settings['token'] ) : '';
		$ytRefreshToken = isset( $youtube_settings['refresh_token'] ) ? trim( $youtube_settings['refresh_token'] ) : '';

		if( !empty( $ytClientId ) && !empty( $ytClientSecret ) && !empty( $ytAccessToken ) && !empty( $ytRefreshToken ) )
			return true;
	}

	return $valid;
}
/*
	function wpvmachine_save_settings() {
		$settings = array();
		$settings['email'] = isset( $_POST['wpvmachine_email'] ) ? trim( $_POST['wpvmachine_email'] ) : '';
		$settings['apikey'] = isset( $_POST['wpvmachine_apikey'] ) ? trim( $_POST['wpvmachine_apikey'] ) : '';
		$settings['auto'] = isset( $_POST['wpvmachine_auto'] ) ? $_POST['wpvmachine_auto'] : '';
		$settings['kw_tags'] = isset( $_POST['wpvmachine_kw_tags'] ) ? $_POST['wpvmachine_kw_tags'] : '';
		$settings['num_blinks'] = isset( $_POST['wpbl-backlinks-num'] ) ? intval( $_POST['wpbl-backlinks-num'] ) : 0;
		$settings['default_kw'] = isset( $_POST['wpvmachine_default_kw'] ) ? $_POST['wpvmachine_default_kw'] : '';
		wpvmachine_save_plugin_settings( $settings );
		delete_transient( 'wpvmachine_rem_links' );
		if( wpvmachine_api_test_api_key( $settings['email'], $settings['apikey'] ) ) {
			wpvmachine_set_valid_api();
			return true;
		}
		return false;
	}

	function wpvmachine_get_plugin_settings() {
		return get_option( 'wpvmachine_settings' );
	}

	function wpvmachine_save_plugin_settings( $settings ) {
		return update_option( 'wpvmachine_settings', $settings );
	}
*/
	// add_action ( 'wp_ajax_wpvmachine_get_backlinks', 'wpvmachine_do_get_backlinks' );

	// function wpvmachine_do_get_tags() {
	// 	$post_id = isset( $_POST['post_id'] ) ? intval( $_POST['post_id'] ) : 0;
	// 	$post_type = get_post_type( $post_id );
	// 	if( $post_type == 'product' ) {
	// 		// WooCommerce product
	//     	$tags = wp_get_post_terms( $post_id, 'product_tag' );
	// 	}
	// 	else {
	//     	$tags = wp_get_post_terms( $post_id, 'post_tag' );
	// 	}

	// 	if( $tags ) {
	// 		$num_tags = count( $tags );
	// 		foreach( $tags as $index => $tag ) {
	// 			echo $tag->name;
	// 			if( ( $index +1 ) < $num_tags )
	// 				echo "\n";
	// 		}
	// 	}
	// 	exit();
	// }

	function wpvmachine_add_to_log( $post_id, $job_id = 0, $title, $content, $images, $video_language = 'en-us', $upload_youtube = 0, $youtube_title = '', $youtube_description = '', $result = 1 ) {
		global $wpdb;
		$wpdb->insert ( $wpdb->prefix.'wpvmachine_requests' , array (
				'post_id' => intval( $post_id ),
				'images' => json_encode( $images ),
				'title' => trim( $title ),
				'texto' => trim( $content ),
				'voiceLanguage' => trim( $video_language ),
				'voiceSex' => 0,
				'ytUploadEnabled' => $upload_youtube,
				'videoTitle' => trim( $youtube_title ),
				'videoDescription' => trim( $youtube_description ),
				'job_id' => intval( $job_id ),
				'result' => intval( $result ),
				'requested_at' => /*date("Y-m-d h:m:s")*/current_time( 'mysql' )
		) );
		// die();
	}

	function wpvmachine_get_log( $page = 0, $per_page = 50 ) {
		global $wpdb;
		if( $page )
			$page--;
		$page = $page * $per_page;
		$sql = "SELECT r.*, DATE_FORMAT(requested_at, '%e %b %Y - %H:%i') AS requested_at_f FROM ".$wpdb->prefix."wpvmachine_requests r ORDER BY id DESC LIMIT $page, $per_page";
		return $wpdb->get_results( $sql );
	}

	function update_log_status( $video_id, $status = 0, $youtube_id = '' ) {
		global $wpdb;
		$sql = "UPDATE ".$wpdb->prefix."wpvmachine_requests SET state = ".intval( $status).", youtube_id = '".$youtube_id."' WHERE id = ".intval( $video_id );
		// echo $sql;
		return $wpdb->query( $sql );
	}

	function wpvmachine_get_video( $video_id ) {
		global $wpdb;
		$sql = "SELECT * FROM ".$wpdb->prefix."wpvmachine_requests r WHERE id = ".intval( $video_id );
		return $wpdb->get_row( $sql );
	}

	function wpvmachine_delete_video( $video_id ) {
		global $wpdb;
		$sql = "DELETE FROM ".$wpdb->prefix."wpvmachine_requests WHERE id = ".intval( $video_id );
		return $wpdb->query( $sql );
	}

	function wpvmachine_is_valid_api() {
		// return true;
		return get_option( 'wpvmachine_valid_api', false );
	}

	function wpvmachine_set_valid_api() {
		return update_option( 'wpvmachine_valid_api', 1 );
	}

	function wpvmachine_set_invalid_api() {
		return update_option( 'wpvmachine_valid_api', 0 );
	}

	function wpvmachine_get_post_types() {
		$args = array(
			'public'   => true,
			// '_builtin' => true
		);

		$output = 'objects'; // names or objects, note names is the default
		$operator = 'and'; // 'and' or 'or'

		return get_post_types( $args, $output/*, $operator*/ );
	}
	/* Activation / Deactivation */

	function wpvmachine_activation() {
		global $wpdb;

		$table_name = $wpdb->prefix . "wpvmachine_requests";
		$charset_collate = $wpdb->get_charset_collate ();

		/*$sql = "CREATE TABLE IF NOT EXISTS $table_name (
			id int(11) NOT NULL AUTO_INCREMENT,
			post_id int(11) NOT NULL,
			created_at datetime NOT NULL,
			keywords varchar(1024) NOT NULL,
			num_links tinyint(4) NOT NULL DEFAULT '0',
			job_id int(11) NOT NULL DEFAULT '0',
			result tinyint(4) NOT NULL DEFAULT '0',
			bl_type BOOLEAN NOT NULL DEFAULT 0,
		   UNIQUE KEY id (id)
		   ) $charset_collate;";
*/
		   $sql = "CREATE TABLE IF NOT EXISTS $table_name (
		     id int(11) NOT NULL AUTO_INCREMENT,
		     post_id int(11) NOT NULL DEFAULT '0',
		     title varchar(1024) NOT NULL,
		     texto text,
		     images text,
		     voiceLanguage varchar(12) NOT NULL DEFAULT 'en-us',
		     voiceSex tinyint(4) NOT NULL DEFAULT '0',
		     ytUploadEnabled tinyint(1) NOT NULL DEFAULT '0',
		     videoTitle varchar(1048) NOT NULL DEFAULT '',
		     videoDescription text NOT NULL,
		     requested_at datetime NOT NULL,
		     job_id int(11) NOT NULL DEFAULT '0',
		     result tinyint(4) NOT NULL DEFAULT '0',
		     state tinyint(4) NOT NULL DEFAULT '0',
		     youtube_id varchar(16) NOT NULL DEFAULT '',
		     PRIMARY KEY (id)
		   ) $charset_collate;";

		require_once ( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta ( $sql );
	}


	function wpvmachine_get_post_content( $post_id, $strip_html = true ) {
		$content = apply_filters('the_content', get_post_field('post_content', $post_id ));
		if( $strip_html )
			$content = wp_strip_all_tags( $content );
		return $content;
	}

	function wpvmachine_get_post_images( $post_id ) {
		$post_thumbnail_id = get_post_thumbnail_id( $post_id );
		$ret = array();
		if( !empty( $post_thumbnail_id ) ) {
			$ret[] = get_the_post_thumbnail_url( $post_id, 'full' );
			// $ret[] = array( 'type' => 'id', 'val' => $post_thumbnail_id );
		}
		$post_content = wpvmachine_get_post_content( $post_id, false );

		$doc = new DOMDocument();
	    @$doc->loadHTML( $post_content );
	    @$imageTags = $doc->getElementsByTagName('img');
	    // $allImgs = array();
	    foreach($imageTags as $tag) {
	        // echo $tag->getAttribute('src');
	        $src = false;
            $classes = $tag->getAttribute('class');
            if( !empty( $classes ) ) {
            	$class_arr = explode( ' ', $classes );
            	if( !empty( $class_arr ) ) {
            		foreach( $class_arr as $class ) {
            			if( substr( $class, 0, strlen('wp-image-') ) === 'wp-image-' ) {
            				// clase ok
            				// $image_id = abs((int) filter_var($class, FILTER_SANITIZE_NUMBER_INT));
            				$image_id = preg_replace('/\D/', '', $class); // Get digits
            				$full_img = wp_get_attachment_image_src( $image_id, 'full' );
            				// var_dump($full_img);
            				if( !empty( $full_img ) ) {
            					$src = ( isset( $full_img[0] ) && !empty( $full_img[0] ) ) ? $full_img[0] : false;
            				}
            				// var_dump($class);
            				// var_dump($image_id);
            			}
            		}
            	}
            }
            if( empty( $src ) )
            	$src = $tag->getAttribute('src');
            $ret[] = $src;
	        // $width = $tag->getAttribute('width') ? $tag->getAttribute('width') : 5000;
	        // if( ( strpos ( $src, 'base64') == false ) && ( ( strpos ( $src, '.jpg') != false ) || ( strpos ( $src, '.png') != false ) ) && ( $width >= 100 ) ) {
         //        if ( strpos($src, 'http') !== false) {
         //            $allImages[] = $src;
         //        }
         //        else {
         //            $allImages[] = $url.$src;
         //        }
         //    }
	    }
		// $images = wpvmachine_get_images( $post_content );
		// var_dump($images);
		// $img = array();
		// if ( preg_match_all('/<img (.+?)>/', $post_content, $matches) ) {
		// 	// var_dump($matches);
		//         foreach ($matches as $match) {
		//                 foreach ( wp_kses_hair( $match[0], array('http')) as $attr) {
		//                 	var_dump($attr);
		//                 	if( !empty( $attr['value']) )
		//                 		$ret[] = $attr['value'];
		//                 }
		//                 // echo $img['src'];
		//         }
		// }
		// var_dump($ret);
		return $ret;
	}

	function wpvmachine_get_images($html_string, $get_attrs = FALSE)
	{
	    $post_images = array();

	    // Get all images
	    preg_match_all('/<img (.+)>/', $html_string, $image_matches, PREG_SET_ORDER);

	    // Loop the images and add the raw img html tag to $post_images
	    foreach ($image_matches as $image_match)
	    {
	        // $post_image->html = $image_match[0];

	        // If attributes have been requested get them and add them to the $post_image
	        if ($get_attrs == TRUE)
	        {
	            preg_match_all('/\s+?(.+)="([^"]*)"/U', $image_match[0], $image_attr_matches, PREG_SET_ORDER);

	            foreach ($image_attr_matches as $image_attr)
	            {
	                $post_image->attr->{$image_attr[1]} = $image_attr[2];
	            }
	        }

	        $post_images[] = $post_image;
	    }

	    return $post_images;
	}

	  	add_filter( 'plugin_action_links_' . WPVMACHINE_PLUGIN_NAME.'/'.WPVMACHINE_PLUGIN_NAME.'.php', 'wpvideomachine_add_plugin_action_links' );

	  	function wpvideomachine_add_plugin_action_links( $links ) {
	  		$tagmachine_options = array(
	  				'Support' => '<a target="_blank" href="https://wpvideomachine.com/support/">Support</a>'
	  		);
	  		if( !wpvmachine_is_pro() ) {
				$tagmachine_options = array_merge( $tagmachine_options,
					array(
									'Upgrade to Pro' => '<a target="_blank" href="http://wpvideomachine.convertri.com/pro" style="font-weight:bold;color:red">Upgrade to Pro</a>'
						)
				);
			}


	  		return array_merge(
	  			$links,
	  			$tagmachine_options
	  		);
	  	}

  	/* enable sessions */
  	if ( !function_exists( 'wpvmachine_session_enable' ) ) {
  		function wpvmachine_session_enable() {
  			if ( !session_id() ) {
  			    session_start( [
  			        'read_and_close' => true,
  			    ] );
  			}
  		 	// if(!session_id()){
  		  //   	session_start();
  	   //  	}
  	    }
  	}
  	add_action( 'init','wpvmachine_session_enable' );

	function wpvmachine_is_pro() {
		return false;
		return true;
	}
?>