<?php
add_action( 'admin_enqueue_scripts', 'wpvmachine_load_scripts' );

function wpvmachine_load_scripts() {
	wp_enqueue_style( 'wpvmachine_img', WPVMACHINE_URL . '/css/backend.css' );
	wp_enqueue_script( 'wpvmachine_img', WPVMACHINE_URL . '/js/backend.js', array( 'jquery' ), 1, true );
	wp_localize_script( 'wpvmachine_img', 'wpvmachine_img_vars', array(
		'wpvmachine_key'       => ( get_option( 'wpvmachine_key' ) != '' ? get_option( 'wpvmachine_key' ) : '1498928-f190b376157b831824bdfb89b' ),
		'wpvmachine_url'       => admin_url( 'admin-ajax.php' ),
		'wpvmachine_media_url' => admin_url( 'upload.php' ),
		'wpvmachine_nonce'     => wp_create_nonce( 'wpvmachine_nonce' )
	) );
}

// if( isset( $_GET['page'] ) && ( 'wp-video-machine-newvid' == $_GET['page']  ) ) {
    add_filter( 'media_upload_tabs', 'wpvmachine_img_media_upload_tabs' );
    add_action( 'media_upload_wpvmachine_img', 'wpvmachine_img_media_upload_iframe' );
// }

function wpvmachine_img_media_upload_tabs( $tabs ) {
    if( isset( $_GET['page'] ) ||  isset( $_GET['tab'] ) )
	   $tabs['wpvmachine_img'] = esc_html__( 'WP Video Machine', 'wpvmachine_img' );
	return $tabs;
}

function wpvmachine_img_media_upload_iframe() {
	return wp_iframe( 'wpvmachine_img_media_upload_content' );
}

function wpvmachine_img_media_upload_content() {
	media_upload_header();
	wpvmachine_area();
}

/*
function wpvmachine_menu_media() {
	?>
	<div class="wpvmachine_img_media_container">
	<div class="wpvmachine_header">
	    <h1><?php echo esc_html__( 'WP Pixabay', 'wpvmachine_img' ); ?>
	        <span><?php esc_html_e( 'You can search & save the image(s) to Media Library.', 'wpvmachine_img' ); ?></span>
	    </h1>
	</div>
	<?php wpvmachine_area(); ?>
	</div>
	<?php
}*/


function wpvmachine_area_content() {
	?>
    <div style='display:none'>
		<?php wpvmachine_area( true ); ?>
    </div>
	<?php
}

function wpvmachine_area( $full = false ) {
	?>
    <div id="wpvmachine_area" class="wpvmachine_area">
        <div class="wpvmachine_area_content">
            <div class="wpvmachine_area_content_col wpvmachine_area_content_left">
                <div class="wpvmachine_area_content_col_inner">
                    <div class="wpvmachine_area_content_col_top">
                        <input type="text" id="wpvmachine_input" name="wpvmachine_input" value=""
                               class="wpvmachine_input wpvmachine_input-normal"
                               placeholder="<?php esc_html_e( 'Enter a keyword to search...', 'wpvmachine_img' ); ?>"/>


                        <input type="button" id="wpvmachine_search" class="wpvmachine_button"
                               value="<?php esc_html_e( 'Search', 'wpvmachine_img' ); ?>"/>

                    </div>
                    <div class="wpvmachine_area_content_col_mid">
                        <div id="wpvmachine_container" class="wpvmachine_container"></div>
                    </div>
                    <div class="wpvmachine_area_content_col_bot">
                        <div id="wpvmachine_page" class="wpvmachine_page"> Page 1</div>
                    </div>
                </div>
            </div>
            <div class="wpvmachine_area_content_col wpvmachine_area_content_right">
                <div id="wpvmachine_use_image" class="wpvmachine_area_content_right_inner wpvmachine_area_content_col_inner">
                    <div class="wpvmachine_area_content_col_mid">
                        <div id="wpvmachine_view"></div>
                        <div class="wpvmachine_item_info">
                            <div><?php esc_html_e( 'Title', 'wpvmachine_img' ); ?></div>
                            <div>
                                <textarea id="wpvmachine_title"
                                       class="wpvmachine_input" class="wpvmachine_textarea"></textarea>
                            </div>
                        </div>
<!--                         <div class="wpvmachine_item_info">
                            <div><?php esc_html_e( 'Caption', 'wpvmachine_img' ); ?></div>
                            <div>
									<textarea id="wpvmachine_caption" name="wpvmachine_caption"
                                              class="wpvmachine_textarea"></textarea>
                            </div>
                        </div> -->
<!-- 		                                <div class="wpvmachine_item_info">
                            <div><?php esc_html_e( 'File name', 'wpvmachine_img' ); ?>
                            </div>
                            <div>
                                <select name="wpvmachine_filename" id="wpvmachine_filename" class="wpvmachine_select">
                                    <option
                                            value="0"><?php esc_html_e( 'Keep original file name', 'wpvmachine_img' ); ?>
                                    </option>
                                    <option
                                            value="1"><?php esc_html_e( 'Generate from title', 'wpvmachine_img' ); ?>
                                    </option>
                                </select>
                            </div>
                        </div> -->
						<?php if ( 0 && $full ) { ?>
                            <div class="wpvmachine_item_info">
                                <div><?php esc_html_e( 'Size', 'wpvmachine_img' ); ?></div>
                                <div>
                                    <input type="number" id="wpvmachine_width" value="0"
                                           class="wpvmachine_input wpvmachine_input_small"
                                           placeholder="<?php esc_html_e( 'width', 'wpvmachine_img' ); ?>"/>
                                    <input
                                            type="number" id="wpvmachine_height" value="0"
                                            class="wpvmachine_input wpvmachine_input_small"
                                            placeholder="<?php esc_html_e( 'height', 'wpvmachine_img' ); ?>"/>
                                </div>
                            </div>
                            <div class="wpvmachine_item_info">
                                <div><?php esc_html_e( 'Alignment', 'wpvmachine_img' ); ?>
                                </div>
                                <div>
                                    <select name="wpvmachine_align" id="wpvmachine_align" class="wpvmachine_select">
                                        <option
                                                value="alignnone"><?php esc_html_e( 'None', 'wpvmachine_img' ); ?>
                                        </option>
                                        <option
                                                value="alignleft"><?php esc_html_e( 'Left', 'wpvmachine_img' ); ?>
                                        </option>
                                        <option
                                                value="alignright"><?php esc_html_e( 'Right', 'wpvmachine_img' ); ?>
                                        </option>
                                        <option
                                                value="aligncenter"><?php esc_html_e( 'Center', 'wpvmachine_img' ); ?>
                                        </option>
                                    </select>
                                </div>
                            </div>
                            <div class="wpvmachine_item_info">
                                <div><?php esc_html_e( 'Link to', 'wpvmachine_img' ); ?></div>
                                <div>
                                    <select name="wpvmachine_link" id="wpvmachine_link" class="wpvmachine_select">
                                        <option
                                                value="0"><?php esc_html_e( 'None', 'wpvmachine_img' ); ?></option>
                                        <option
                                                value="1"><?php esc_html_e( 'Original site', 'wpvmachine_img' ); ?></option>
                                        <option
                                                value="2"><?php esc_html_e( 'Original image', 'wpvmachine_img' ); ?></option>
                                    </select>
                                </div>
                            </div>
                            <div class="wpvmachine_item_info">
                                <div>&nbsp;</div>
                                <div>
                                    <input name="wpvmachine_blank" id="wpvmachine_blank" type="checkbox"
                                           class="wpvmachine_checkbox"/> <?php esc_html_e( 'Open new windows', 'wpvmachine_img' ); ?>
                                </div>
                            </div>
                            <div class="wpvmachine_item_info">
                                <div>&nbsp;</div>
                                <div>
                                    <input name="wpvmachine_nofollow" id="wpvmachine_nofollow"
                                           type="checkbox"
                                           class="wpvmachine_checkbox"/> <?php esc_html_e( 'Rel nofollow', 'wpvmachine_img' ); ?>
                                </div>
                            </div>
						<?php } ?>
                    </div>
                    <div class="wpvmachine_area_content_col_bot">
                        <div class="wpvmachine_notice">
                                <span class="wpvmachine_loading_text" id="wpvmachine_loading_text"
                                      style="display:none"><?php esc_html_e( 'Saving to Media Library...', 'wpvmachine_img' ); ?></span>
                            <span id="wpvmachine_error"></span>
                        </div>
						<?php if ( 0 && $full ) { ?>
                            <div class="wpvmachine_actions">
                                <div>
                                    <input type="hidden" id="wpvmachine_url" value=""/>
                                    <input type="hidden" id="wpvmachine_eid" value=""/>
                                    <button id="wpvmachine_insert"><?php esc_html_e( 'Insert', 'wpvmachine_img' ); ?>
                                        <span></span></button>
                                </div>
                                <div>
                                    <a href="https://wpclever.net/downloads/wp-pixabay" target="_blank"
                                       onclick="return confirm('1This feature only available in Premium Version!\nBuy it now? Just $15')">
                                        <button id="wpvmachine_save" class="disable">
											<?php esc_html_e( 'Save&Insert', 'wpvmachine_img' ); ?><span></span>
                                        </button>
                                    </a>
                                </div>
                                <div>
                                    <input type="button" id="wpvmachine_featured" class="wpvmachine_button"
                                           value="<?php esc_html_e( 'Featured', 'wpvmachine_img' ); ?>"/>
                                </div>
                            </div>
						<?php } else { ?>
                            <div class="wpvmachine_actions one_button">
                                <div>
                                    <!-- <a href="#" target="_blank" -->
                                       <!-- onclick="Inserting..."> -->
                                        <button id="wpvmachine_use_imgs" type="button" class="button button-primary">
											<?php esc_html_e( 'Use Image/s', 'wpvmachine_img' ); ?><span></span>
                                        </button>
                                    <!-- </a> -->
                                </div>
                            </div>
						<?php } ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
	<?php
}

// Image Search

include WPVMACHINE_DIR.'/lib/libs/images/pixabay.php';
include WPVMACHINE_DIR.'/lib/libs/images/flickr.php';
include WPVMACHINE_DIR.'/lib/libs/images/pexels.php';

function wpvmachine_img_library_results( $keyword, $num = 15 ) {
	// $res = pixabay_imagesearch( $keyword );
	// print_images( $res );
	// var_dump( $res );
	$res = search_images_keyword( $keyword, $num );
	print_images_src( $res );

}

function wpvmachine_print_images( $images ) {
	if( !empty( $images->images ) ) {
		// $max = 9;
		foreach( $images->images as $key => $image ) {
			echo '<li><div class="thumbnail"><img class="image_picker_image" src="'.$image->thumbnail_url.'" alt="'.$image->title.'"></div></li>';
			// if( $key >= $max )
			// 	return;
		}
	}
}

function wpvmachine_print_images_src( $images ) {
	if( !empty( $images ) ) {
		foreach( $images as $key => $image ) {
			echo '<li><div class="thumbnail"><img class="image_picker_image" src="'.$image.'"></div></li>';
		}
	}
}

function wpvmachine_print_images_simple( $images ) {
	if( !empty( $images ) ) {
		$max = 9;
		foreach( $images as $key => $image ) {
			echo '<li><div class="thumbnail"><img class="image_picker_image" src="'.$image['thumbnail_url'].'" alt="'.$image['title'].'"></div></li>';
			if( $key >= $max )
				return;
		}
	}
}

function wpvmachine_search_images_keyword( $keyword, $page = 1, $per_page = 25, $num_needed = 5, $random_sites = 0, $random_res = 0 ) {
	$sites = array( 'pixabay', 'pexels', 'flickr' );
	if( $random_sites )
		shuffle( $sites );
	$images = array();
	$num_images = 0;
	foreach( $sites as $site ) {
		$function_name = 'wpvmachine_img_urls_'.$site;
		$images = $function_name( $keyword, $page, $per_page, $num_needed, $random_res, $images, $num_images );
		if( count( $images ) >= $num_needed )
			return $images;
	}
	return $images;
}

function wpvmachine_img_urls_pixabay( $keyword, $page = 1, $per_page, $num_needed = 5, $random_res = 0, $images = array(), $num_images = 0 ) {
	$pixabay = wpvmachine_pixabay_imagesearch( $keyword, '', $page, $per_page );
	$num_images = isset( $pixabay->images ) ? count( $pixabay->images ) : 0;
	if( !empty( $pixabay ) ) {
		$images = array_merge( $images, wpvmachine_get_images_urls( $pixabay->images ) );
		if( $num_images >= $num_needed ) {
			if( $random_res)
				return array_rand( array_flip( $images ), $num_needed );
			return array_slice( $images, 0, $num_needed );
		}
	}
	else {
		$images = array();
		$num_images = 0;
	}
	return $images;
}

function wpvmachine_img_urls_pexels( $keyword, $num_needed = 5, $random_res = 0, $images = array(), $num_images = 0 ) {
	$pexels = wpvmachine_pexels_imagesearch( $keyword );
	$num_images += isset( $pexels->images ) ? count( $pexels->images ) : 0;
	$images = array_merge( $images, wpvmachine_get_images_urls( $pexels->images ) );
	if( $num_images >= $num_needed ) {
		if( $random_res)
			return array_rand( array_flip( $images ), $num_needed );
		return array_slice( $images, 0, $num_needed );
	}
	return $images;
}

function wpvmachine_img_urls_flickr( $keyword, $num_needed = 5, $random_res = 0, $images = array(), $num_images = 0 ) {
	$flickr = wpvmachine_flickr_imagesearch( $keyword );
	$num_images += isset( $flickr->images ) ? count( $flickr->images ) : 0;
	$images = array_merge( $images, wpvmachine_get_images_urls( $flickr->images ) );
	if( $num_images >= $num_needed ) {
		if( $random_res)
			return array_rand( array_flip( $images ), $num_needed );
		return array_slice( $images, 0, $num_needed );
	}
	return $images;
}

function wpvmachine_get_images_urls( $imgs_array ) {
	return $imgs_array;
	$ret = array();
	if( empty( $imgs_array ) )
		return $ret;
	foreach( $imgs_array as $image )
		$ret[] = $image->fullsize_url;
	return $ret;
}

function wpvmachine_do_search_images( ) {
    $keyword = isset( $_POST['keyword'] ) ? trim( $_POST['keyword'] ) : '';
    $per_page = isset( $_POST['per_page'] ) ? intval( $_POST['per_page'] ) : 25;
    $page = isset( $_POST['page'] ) ? intval( $_POST['page'] ) : 1;
    $images = wpvmachine_search_images_keyword ( $keyword, $page, $per_page, $per_page );
    echo json_encode( $images );
    // var_dump($images);
    exit();
}
?>