<?php
define( 'WPVMACHINE_PIXABAY_URL', 'https://pixabay.com/api/' );
define( 'WPVMACHINE_PIXABAY_APIKEY', '1260271-c62621822e9870b3968a53ac3' );


function wpvmachine_pixabay_imagesearch( $search_term, $license='', $page=1, $results_per_page=36, $offset=0, $attribution_required=0, $imgtype=0, $only_modifiables = 0 ) {
	// no images with attribution required here, so return
	// if ( $attribution_required == 2 ) return 0;
	// $is_hires = 0;

	$pixabay_key = WPVMACHINE_PIXABAY_APIKEY/*$sites['pixabay']['details']['api_key']*/;
	$is_hires = 1;
	// }
	$search_term = str_replace( ' ', '+', $search_term );

	if ( $offset ) {
		if ( $page > 1 ) $page--;
	}

	if ( $imgtype == 2 )
		$image_type = 'photo';
	else if ( $imgtype == 1 )
		$image_type = 'clipart';
	else
		$image_type = 'all';

	$req_args = array(
		/*'username' => $pixabay_username,*/
		'key' => $pixabay_key,
		'search_term' => $search_term,
		'image_type' => $image_type,
		'per_page' => $results_per_page,
		'page' => $page
	);

// die(add_query_arg( $req_args, WPVMACHINE_PIXABAY_URL ));
	if( 0 && $is_hires )
		$req_args = array_merge( $req_args, array( 'response_group' => 'high_resolution' ) );
// var_dump($sites['pixabay']['details']);die();
	if ( !$offset ) {
		$response = wp_remote_get( add_query_arg( $req_args, WPVMACHINE_PIXABAY_URL ) );
		// echo add_query_arg( $req_args, WPVMACHINE_PIXABAY_URL );
		// var_dump($response);
		/*if ($is_hires) {
			$error_code = wpvmachine_pixabay_check_hires($response);
			if ($error_code) {
				echo $error_code;
				return;
			}
		}*/
		if ( is_wp_error( $response ) ) {
			return 0;
		} else {
			return wpvmachine_pixabay_togeneric ( json_decode( $response['body'] ), $is_hires, $offset, $results_per_page );
		}
	}
	else {
		$response = wp_remote_get( add_query_arg( $req_args, WPVMACHINE_PIXABAY_URL ) );
		// var_dump($response);
		/*if ($is_hires) {
			$error_code = wpvmachine_pixabay_check_hires($response);
			if ($error_code) {
				echo $error_code;
				return;
			}
		}*/
		if ( is_wp_error( $response ) ) {
			return 0;
		} else {
			$arr1 = wpvmachine_pixabay_togeneric ( json_decode( $response['body'] ), $is_hires, $offset, $results_per_page );
			$req_args['page']++;
			$response = wp_remote_get( add_query_arg( $req_args, WPVMACHINE_PIXABAY_URL ) );
			if ( is_wp_error( $response ) ) {
				return 0;
			} else {
				$arr2 = wpvmachine_pixabay_togeneric ( json_decode( $response['body'] ), $is_hires, $offset, $results_per_page );
				$return_object = new stdClass();
				$return_object->total_images = $arr1->total_images; // + $arr2->total_images;
				$max_page = ( floor( $arr1->total_images / $results_per_page )+1 );
				if ( $req_args['page'] < $max_page )
					$return_object->images = array_merge( $arr1->images, $arr2->images );
				else
					$return_object->images = $arr1->images;

				$return_object->images = array_slice( $return_object->images, $offset, $results_per_page );
				$return_object->images_in_group = count( $return_object->images );
				return $return_object;
			}
		}

	}
}

/*
	Object definition

total_images = num
images {
	thumbnail_url = url
	fullsize_url = url
	width = number
	height = number
	attribution = true/false
	author_name = name
	authour_url = url
}
*/

function wpvmachine_pixabay_togeneric( $images, $is_hires=0, $offset=0, $results_per_page=0 ) {
	$return_object = new stdClass();
	// var_dump($images);
	// exit(0);
	if ( !$images ) return 0;
	$return_object->total_images = $images->totalHits;
	$return_object->images = array();

	if ( !is_array( $images->hits ) ) return 0;
	foreach ( $images->hits as $hit ) {
		// var_dump($hit); exit(0);
		$image = new stdClass();
		// var_dump($hit);
		// exit(0);
		// $image->thumbnail_url = $hit->previewURL;
		$image->thumbnail_url = $hit->webformatURL;
		
		if ( $is_hires ) {
			$image->fullsize_url = $hit->largeImageURL;
			$image->width = $hit->imageWidth;
			$image->height = $hit->imageHeight;
		}
		else {
			$image->fullsize_url = $hit->webformatURL;
			$image->width = $hit->webformatWidth;
			$image->height = $hit->webformatHeight;
		}
		$image->attribution = false;
		$image->author_name = null;
		$image->author_url = null;
        $image->modifiable = true;
		$image->license_type = 9;
		$image->id = $hit->id;

		if ( isset( $image->tags ) )
			$image->title = isset( $hit->tags ) ? $hit->tags : 'Pixabay Image '.$hit->id;
		else
			$image->title = 'Pixabay Image '.$hit->id;
        $image->original_url = $hit->pageURL;

		$return_object->images[] = $image;
	}

	$return_object->images_in_group = count( $return_object->images );

	return $return_object;
}

function  pixabay_check_hires($response) {
	return 0;
	if (isset($response['response']['code']) && $response['response']['code'] == 403)
		return $response;
	return 0;
}

/*
function search_free_image() {
	@ini_set( 'max_execution_time', '480' );

	$keyword = $_POST['keyword'];
	$page = isset( $_POST['page'] ) ? $_POST['page'] : 1;
	$results_per_page=36;

	// include_once WPVMACHINE_DIR.'/lib/imageapis.php';

	// extra options
	$attribution = ( $_POST['attribution'] == 'true' ) ? 1 : 0;
	$noattribution = ( $_POST['noattribution'] == 'true' ) ? 1 : 0;
	$modifiables = ( $_POST['only_modifiables'] == 'true' ) ? 1 : 0;

	$photo = ( $_POST['photo'] == 'true' ) ? 1 : 0;
	$clipart = ( $_POST['clipart'] == 'true' ) ? 1 : 0;

	$is_small = ( isset($_POST['is_small']) && $_POST['is_small'] == 'true' ) ? 1 : 0;


	if ( !$photo && !$clipart ) {
		echo '<p class="padded">You must select at least one image type (photo/clipart)</p>';
		exit( 0 );
	}
	if ( !$attribution && !$noattribution ) {
		echo '<p class="padded">You must select at least one attribution type (with/without attribution)</p>';
		exit( 0 );
	}

	$extra_args = array();

	if ( !$attribution || !$noattribution ) {
		if ( $attribution )
			$extra_args['attribution'] = true;
		else if ( $noattribution )
			$extra_args['noattribution'] = true;
	}

	if ($modifiables)
		$extra_args['modifiables'] = true;
	else
		$extra_args['modifiables'] = false;

	if ( !$photo || !$clipart ) {
		if ( $photo )
			$extra_args['photo'] = true;
		else if ( $clipart )
			$extra_args['clipart'] = true;
	}

	if ( isset( $_POST['sites'] ) )
		$extra_args['sites'] = $_POST['sites'];


	$all_res = image_search( $keyword, 0, $results_per_page, $page, $extra_args );

	if ( !$all_res ) {
		exit( 0 );
	}
	$total_images = $all_res->total_results;
	$str_ret = paint_pagination( $page, $total_images, $results_per_page, $is_small );
	$str_ret .=  '<div class = "attachments_container" style="" class="wpbeautify-attachments">';
	$str_ret .=  '<ul class="attachments-view-wpbeautify" style="margin-top:0px;">';

	echo $str_ret;

	// go through all results
	$current_n_results = 0;
	foreach ( $all_res->image_groups as $res ) {

		if ( !is_array( $res->images ) ) {
			echo 'No results';
			exit( 0 );
		}

		//var_dump($res);
		$counter = 1;
		foreach ( $res->images as $image ) {
?>
			<li class="wpbeautify-attachment">
				<div class="wpbeautify-attachment-preview">
						<div class="wpbeautify-thumbnail">
							<div class="centered">
								<img class="thumb thumb_<?php echo $res->image_source;?>" src="<?php echo $image->thumbnail_url;?>"
									data-width="<?php echo $image->width;?>"
									data-height="<?php echo $image->height;?>"
									data-url="<?php echo $image->fullsize_url;?>"
									data-author_name="<?php echo $image->author_name;?>"
									data-author_url="<?php echo $image->author_url;?>"
									data-attribution="<?php echo $image->attribution ? 1 : 0; ?>"
									data-modifiable="<?php echo $image->modifiable ? 1 : 0; ?>"
									data-license="<?php echo $image->license_type;?>"
									data-origin="<?php echo $res->image_source;?>"
									data-original-url="<?php echo $image->original_url;?>"
									title="<?php echo $image->title;?>"
									/>
							</div>
						</div>
						<a title="Deselect" href="#" class="check"><div class="media-modal-icon"></div></a>
				</div>
			</li>

	<?php
			if ( ++$current_n_results >= $results_per_page ) break 2;
		}
	}



	echo '</ul><div style="clear:both;"></div></div>';

	exit( 0 );
}

function paint_pagination( $current_page, $total_results, $results_per_page, $is_small = false, $extra_class = '' ) {
	$total_pages = ceil( $total_results / $results_per_page );
	$str_ret = '';
	if (!$total_pages || $total_pages == 1) return '';

	// $str_ret .= '<div class="tablenav" style=""><div class="tablenav-pages" style="float:left"> <b>Total :</b> '.$total_results.' results &nbsp;&nbsp;&nbsp;&nbsp;';
	$str_ret .= '<div class="row '.$extra_class.'" style="" id="free_img_pagination"><div class="col-md-6"> <b>Total :</b> '.$total_results.' results ';
	if (!$is_small)
		$str_ret .= '&nbsp;&nbsp;&nbsp;&nbsp;';

	if ( $total_pages )
		$str_ret .= '<span class="displaying-num">Showing page '.($current_page ? $current_page : 1).' of  '.$total_pages.'</span></div>';


    $page_links = paginate_links( array(
            'base' =>  '#',
            'format' => '',
            'end_size' => 2,
            'mid_size' => 3,
            'prev_text' => __( '&laquo;', 'aag' ),
            'next_text' => __( '&raquo;', 'aag' ),
            'total' => $total_pages,
            'current' => ($current_page ? $current_page : 1),
            'type' => 'array'
        ) );


	if ($is_small) {
		$str_ret .= '<div class="col-md-6"><a href="#" class="small-navi-prev">< Prev</a> &nbsp;&nbsp;&nbsp;<a href="#" class="small-navi-next">Next ></a></div>';
	}
	else
		$str_ret .= '<div class="col-md-6">'. listify_pagination($page_links, 'pull-right') . '</div>';
	$str_ret .= '</div></div>';
	return $str_ret;
}
*/

function get_licenses() {
	$licenses = array();
	$licenses[0] = array( 'id' => 0, 'short' => '', 'name' => 'All Rights Reserved', 'url' => '' );
	$licenses[1] = array( 'id' => 1, 'short' => 'CC BY-NC-SA', 'name' => 'Attribution-NonCommercial-ShareAlike License', 'url' => 'http://creativecommons.org/licenses/by-nc-sa/2.0/' );
	$licenses[2] = array( 'id' => 2, 'short' => 'CC BY-NC', 'name' => 'Attribution-NonCommercial License', 'url' => 'http://creativecommons.org/licenses/by-nc/2.0/' );
	$licenses[3] = array( 'id' => 3, 'short' => 'CC BY-NC-ND', 'name' => 'Attribution-NonCommercial-NoDerivs License', 'url' => 'http://creativecommons.org/licenses/by-nc-nd/2.0/' );
	$licenses[4] = array( 'id' => 4, 'short' => 'CC BY', 'name' => 'Attribution License', 'url' => 'http://creativecommons.org/licenses/by/2.0/' );
	$licenses[5] = array( 'id' => 5, 'short' => 'CC BY-SA', 'name' => 'Attribution-ShareAlike License', 'url' => 'http://creativecommons.org/licenses/by-sa/2.0/' );
	$licenses[6] = array( 'id' => 6, 'short' => 'CC BY-ND', 'name' => 'Attribution-NoDerivs License', 'url' => 'http://creativecommons.org/licenses/by-nd/2.0/' );
	$licenses[7] = array( 'id' => 7, 'short' => '', 'name' => 'No known copyright restrictions', 'url' => 'http://www.23hq.com/commons/usage/' );
	$licenses[8] = array( 'id' => 8, 'short' => '', 'name' => 'United States Government Work', 'url' => 'http://www.usa.gov/copyright.shtml' );
	$licenses[9] = array( 'id' => 9, 'short' => 'CC0', 'name' => 'Public Domain Dedication', 'url' => 'http://creativecommons.org/publicdomain/zero/1.0/deed.en' );

	return $licenses;
}

function wpvmachine_get_license_id_from_short( $short ) {
	foreach ( $licenses = get_licenses() as $license ) {
		if ( str_replace( ' ', '-', tolower( $license['short'] ) ) == str_replace( ' ', '-', tolower( $short ) ) )
			return $license['id'];
	}
}

// global $sites_internal;
// $sites_internal = get_site_option( 'image_sites', 0 );

function wpvmachine_tolower( $string ) {
	if ( function_exists( 'mb_strtolower' ) )
		return mb_strtolower( $string );
	else
		return strtolower( $string );
}

function wpvmachine_image_search( $search_term, $license='', $results_per_page=36, $page=1, $options=array() ) {

	@ini_set( 'max_execution_time', '480' );
	// $apis_used = get_site_option( 'sites_in_order', 0 );
	$search_term = tolower( $search_term );

	

	if ( !is_array( $apis_used ) ) return 0;
	$total_images  = new stdClass();
	$total_images->total_results = 0;
	$total_images->image_groups = array();

	$current_images = 0;
	$is_first_look = 1;
	$is_first_checked = 1;

	$page_needed = $page; // TODO: revisar
	$remaining_needed = $results_per_page;
	$image_offset = 0;
	$original_page = $page;
	$total_shown = 0;

	if ( isset( $options['attribution'] ) )
		$attribution = 2;
	else if ( isset( $options['noattribution'] ) )
		$attribution = 1;
	else
		$attribution = 0;

	if ( isset( $options['modifiables'] ) &&  ( $options['modifiables'] == 1 ) )
		$modifiables = 1;
	else
		$modifiables = 0;

	if ( isset( $options['photo'] ) )
		$imgtype = 2;
	else if ( isset( $options['clipart'] ) )
			$imgtype = 1;
	else
		$imgtype = 0;

				$images = pixabay_imagesearch( $search_term, $license, 1, $results_per_page, 0, $attribution, $imgtype, $modifiables );
				var_dump($images);
			return $images;
}

function wpvmachine_count_current_images( $total_images ) {
	$total_count = 0;
	foreach ( $total_images as $image_group ) {
		$total_count += $image_group->total_images;
	}
	return $total_count;
}
/*
	Object definition

total_images = num
image_source = string
images {
	thumbnail_url = url
	fullsize_url = url
	width = number
	height = number
	attribution = true/false
	author_name = name
	authour_url = url
}
*/

function wpvmachine_debug_image_object( $images ) {
	if ( 1 ) return;
	foreach ( $images->image_groups as $image_type ) {
		echo '<b>'.$image_type->image_source. '</b><br/>';
		echo "total total = ".$image_type->total_images. '<br/>';
		echo "total en el grupo = ".count( $image_type->images ). '<br/>';
	}

}

function wpvmachine_join_arrays( $temp_results, $page, $results_per_page, $offset ) {
	$return_object = new stdClass();
	$cont = 0;
	$images = array();
	foreach ( $temp_results as $result ) {
		if ( !$result ) continue;
		$cont += count( $result->images );
		$images = array_merge( $images, $result->images );
	}
	$elem_offset = ( $page-1 )*$results_per_page;
	$total = $results_per_page;

	$images = array_slice( $images, $elem_offset+$offset, $total );
	$return_object->total_images = $cont;
	$return_object->images_in_group = count( $images );
	$return_object->images = $images;

	return $return_object;
}

?>