<?php

function wpvmachine_screen1() {
	if (! current_user_can ( 'manage_options' ))
		wp_die ( 'You don\'t have access to this page.' );
	if (! user_can_access_admin_page ())
		wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-backlinks-machine' ) );
	$page = isset( $_GET['pagenum'] ) ? intval( $_GET['pagenum'] ) : 1;
	$post_type = isset( $_GET['posttype'] ) ? $_GET['posttype'] : 'post';
	$search_term = isset( $_POST['sterm'] ) ? $_POST['sterm'] : '';
	$post_type_details = get_post_type_object( $post_type );
	$post_type_name = $post_type_details->labels->name;
		?>
		<div class="wrap">
		<?php wpvmachine_header(); ?>
		<?php if( wpvmachine_is_pro() ) { ?>
		<div style="float:right"><b>Display: </b> <?php wpvmachine_post_type_selector( $post_type ); ?></div><h1><?php echo $post_type_name;?></h1> <?php }  else { echo '<div style="float:right"><h3>Posts</h3></div>'; } ?>
		<br/>
		<div class="searcher-posts" style="margin-bottom:10px">
			<form action="<?php echo admin_url('admin.php?page=wp-video-machine-log&posttype='.$post_type);?>" method="POST">
		<b>Search:</b>
			<input type="text" name="sterm" value="<?php echo $search_term;?>" style="min-width:30%">
			<button type="submit" class="button button-primary"><i class="fas fa-search"></i> Search</button>
			<button type="button" class="button button-secondary" id="do-reset-term"><i class="fas fa-times"></i> Show all</button>
		</form>
		</div>
		<?php wpvmachine_print_posts_list( $post_type, $search_term, $page, 50 ); ?>
		</div>
		<?php /*wpvmachine_popup();*/ ?>
	<?php
}
 
function wpvmachine_print_posts_list( $post_type = 'post', $search_term = '', $page = 0, $per_page = 50 ) {
	global $wpdb;
	$args = array(
		'post_type' => $post_type,
		'posts_per_page'   => $per_page,
		'offset'           => ( ( $page -1 ) * $per_page ),
	);
	if( !empty( $search_term ) )
		$args['s'] = $search_term;

	$posts = get_posts( $args );

	$total_query = "SELECT COUNT(id) FROM {$wpdb->prefix}posts WHERE post_type = '$post_type' AND post_status = 'publish' ";
	if( !empty( $search_term ) )
		$total_query .= " AND (post_title LIKE '%".$search_term."%' OR post_content LIKE '%".$search_term."%' )";
	$total = $wpdb->get_var( $total_query );
	$num_of_pages = ceil( $total / $per_page );


	$str_ret = '<table class="widefat">';
	$str_ret .= '<thead><tr><th scope="col">Id</th><th scope="col">Name</th><th scope="col">&nbsp;</th></tr></thead><tbody>';
	if( $posts ) {
		foreach( $posts as $post ) {
			$str_ret .= '<tr><td class="post_id">'.$post->ID.'</td><td class="post_name">'.get_the_title( $post->ID ).'</td><td><a href="'.admin_url('/admin.php?page=wp-video-machine-newvid&pid='.$post->ID).'"  class="button button-primary"><i class="fas fa-video"></i> Create Video</a> <a class="button button-secondary post_url" href="'.get_permalink( $post->ID ).'" target="_blank"><i class="fas fa-bullseye"></i> Preview</a></td></tr>';
		}
	}
	$str_ret .= '</tbody></table>';
	echo $str_ret;

	$page_links = paginate_links( array(
		'base' => add_query_arg( /*'pagenum', '%#%'*/ array(
			    'pagenum' => '%#%',
			    'posttype' => $post_type,
			)
		),
		'format' => '',
		'end_size' => 4,
		'mid_size' => 3,
		'prev_text' => __( '«', 'text-domain' ),
		'next_text' => __( '»', 'text-domain' ),
		'total' => $num_of_pages,
		'current' => $page
	) );
	if ( $page_links ) {
	echo '<div class="tablenav"><div class="tablenav-pages" style="margin: 1em 0;">' . $page_links . '</div></div>';
	}
}
?>