<?php

function wpvmachine_screen_settings() {
		// delete_option( 'wpvmachine_valid_api');
	if (! current_user_can ( 'manage_options' ))
		wp_die ( 'You don\'t have access to this page.' );
	if (! user_can_access_admin_page ())
		wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-backlinks-machine' ) );
	$posted_settings = 0;
	$valid = 0;
	$already_valid = wpvmachine_is_valid_api();
	if( isset( $_POST['wpvmachine_save_settings'] ) ) {
		$valid = wpvmachine_save_settings();
		$posted_settings = 1;
	}
	$settings = wpvmachine_get_plugin_settings();
		?>
			<div class="wrap">
			<?php wpvmachine_header(); ?>
			<?php
			if( isset( $_GET['yt_authed'] ) && $_GET['yt_authed'] ) {
				echo '<div class="notice notice-success is-dismissible inline"><p><i class="fa fa-check"></i> Youtube authorization correct</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>';
			}
			else if( isset( $_GET['yt_authed'] ) && !$_GET['yt_authed'] ) {
				echo '<div class="notice notice-error is-dismissible inline"><p><i class="fa fa-times"></i> Error with Youtube authorization, please check your settings and try again. <a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-youtube-client-id-and-secret/" target="_blank">Tutorial</a></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>';
			}
			?>
			<h1>Settings <small style="font-size:0.6em"><a href="https://wpvideomachine.com/support/knowledgebase/which-settings-do-i-need-to-fill-in-to-get-the-plugin-working/" target="_blank">Help - which settings do I need to fill?</a></small></h1>
			<br/>
			<?php
			if( $posted_settings && !$valid ) {
				echo '<div class="notice notice-error is-dismissible inline"><p><i class="fas fa-times"></i> ERROR: email invalid</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>';
			}
			else if( !$already_valid && $posted_settings && $valid ) {
				echo '<div class="notice notice-success is-dismissible inline"><p><i class="fas fa-check"></i> Your email is valid. <a href="">Start using the plugin</a></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>';
			}
			else if( isset( $_POST['wpvmachine_save_settings'] ) ) {
				echo '<div class="notice notice-success is-dismissible inline"><p><i class="fas fa-check"></i> Settings saved!</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>';
			} ?>
			<form action="" method="post" id="wpvmachine-settings-form">
				<?php
				if( wpvmachine_is_valid_api() ) { ?>
					<div id="wpvmachine-tabs" >
					    <h2 class="nav-tab-wrapper">
					        <a href="#wpvmachine-settingsv-tab" class="nav-tab nav-tab-active"><i class="fas fa-video"></i> Video</a>
					        <a href="#wpvmachine-settingssoc-tab" class="nav-tab"><i class="fa fa-share-alt"></i> Social</a>
   							<?php if( wpvmachine_is_pro() ) { ?>
	                        	<a href="#wpvmachine-spinners-tab" class="nav-tab"><i class="fas fa-random"></i> Spinners</a>
	                        	<a href="#wpvmachine-affiliate-tab" class="nav-tab"><i class="fas fa-dollar-sign"></i> Affiliate</a>
	                        	<a href="#wpvmachine-content-tab" class="nav-tab"><i class="far fa-file-alt"></i> Content</a>
	                        <?php } ?>
					        <a href="#wpvmachine-reg-tab" class="nav-tab"><i class="fa fa-user"></i> Registration</a>
					    </h2>
					    <div style="clear:both"></div>
					    <div id="wpvmachine-settingsv-tab" class="tab-inner" style="display:block"><?php wpvmachine_set_tab_video( $settings );?></div>
			        	<div id="wpvmachine-settingssoc-tab" class="tab-inner"><?php wpvmachine_set_tab_social( $settings );?></div>
   						<?php if( wpvmachine_is_pro() ) { ?>
	            			<div id="wpvmachine-spinners-tab" class="tab-inner"><?php wpvmachine_settings_tab_spinners( $settings );?></div>
	            			<div id="wpvmachine-affiliate-tab" class="tab-inner"><?php wpvmachine_settings_tab_affiliate( $settings );?></div>
	            			<div id="wpvmachine-content-tab" class="tab-inner"><?php wpvmachine_settings_tab_content( $settings );?></div>
	            		<?php } ?>
			        	<div id="wpvmachine-reg-tab" class="tab-inner"><?php wpvmachine_set_tab_register( $settings );?></div>

			    </div>
			<?php
			}
			else {
				echo '<p>To get started using the plugin, please enter the e-mail you used to sign-up</p>';
				wpvmachine_set_tab_register( $settings );
				echo '<input type="hidden" name="wpvmachine_email_only" value="1">';

			}
			?>
			<br/>
				<input type="hidden" name="wpvmachine_save_settings" value="1">
				<button type="submit"  class="button button-primary"><i class="fas fa-save"></i> Save Changes</button>
			</form>
			</div>
		<?php
	}

function wpvmachine_set_tab_video( $settings ) {
	$youtube_settings = isset( $settings['youtube'] ) ? $settings['youtube'] : false;
	$vimeo_settings = isset( $settings['vimeo'] ) ? $settings['vimeo'] : false;
	$dailymotion_settings = isset( $settings['dailymotion'] ) ? $settings['dailymotion'] : false;
    // var_dump($youtube_settings['token']);
    // var_dump($youtube_settings['refresh_token']);

	// var_dump($youtube_settings);
	$client_id = isset( $youtube_settings['client_id'] ) ? trim( $youtube_settings['client_id'] ) : '';
	$client_secret = isset( $youtube_settings['client_secret'] ) ? trim( $youtube_settings['client_secret'] ) : '';
?>
	<h3><i class="fab fa-youtube"></i> Youtube Authorization</h3>
	<p>You need to authorize your Youtube account (once) so the plugin can upload videos to your Youtube Channel</p>
    <table class="form-table">
    <?php
		wpvmachine_field_text( 'Youtube Client ID', 'youtube_client_id', $client_id, false, '',  '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-youtube-client-id-and-secret/" target="_blank">How to get your Youtube Client ID and Secret</a>', 'Your Youtube Client ID' );
		wpvmachine_field_text( 'Youtube Client Secret', 'youtube_client_secret', $client_secret, false, '',  '', 'Your Youtube Client Secret' );
		wpvmachine_field_static( 'Redirect URL', admin_url( 'admin.php?page=wp-video-machine-settings&yt_auth=1'), '', 'feat-url', 'Enter this URL when setting up the project in the Google Developers Console' );
	?>
	<?php if( !empty( $client_id ) && !empty( $client_secret ) ) { ?>
		<tr valign="top">
		  <th scope="row"></th>
		  <td>
		  		<input type="hidden" name="wpvmachine_yt_auth" id="wpvmachine_yt_auth" value="0">
		  		<input type="hidden" name="auth_youtube_num" id="auth_youtube_num" value="0">
				<button class="button button-secondary" type="button" id="wpvmachine-auth-youtube"><i class="fab fa-youtube"></i> Authorize your Youtube Account</button>
				<br/>
				<p><a href="https://wpvideomachine.com/support/knowledgebase/what-to-do-if-you-are-getting-errors-when-authorizing-with-youtube/" target="_blank">Click here if you are having issues when authenticating with Youtube.</a></p>
		  </td>
		 </tr>
	<?php } ?>
	</table>

	<?php if( wpvmachine_is_pro() ) { ?>
	    <br/><br/><h4>Extra Youtube Accounts:           <a class="button button-secondary" id="btn-show-youtubes">
	        <i class="fas fa-plus"></i> Click here to enter info about your other Youtube accounts
	      </a></h4>
	    <div class="wpvm-collapse" id="wpvmcollapseYoutube">
	    	<div id="yt-accounts-extra">
	        	<?php wpvmachine_extra_youtube_accounts( $youtube_settings ); ?>
	        </div>
	    </div>
		<br/>
	<h3><i class="fab fa-vimeo"></i> Vimeo Authorization</h3>

    	<table class="form-table">
	<?php
		$vimeo_client_id = isset( $vimeo_settings['client_id'] ) ? trim( $vimeo_settings['client_id'] ) : '';
		$vimeo_client_secret = isset( $vimeo_settings['client_secret'] ) ? trim( $vimeo_settings['client_secret'] ) : '';
		$vimeo_token = isset( $vimeo_settings['token'] ) ? trim( $vimeo_settings['token'] ) : '';
		wpvmachine_field_text( 'Vimeo Client ID', 'vimeo_client_id', $vimeo_client_id, false, '',  '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-authorize-wp-video-machine-to-upload-to-vimeo/" target="_blank">How to get your Vimeo Client ID and Secret</a>', 'Your Vimeo Client ID' );
		wpvmachine_field_text( 'Vimeo Client Secret', 'vimeo_client_secret', $vimeo_client_secret, false, '',  '', 'Your Vimeo Client Secret' );
		wpvmachine_field_text( 'Vimeo Access Token', 'vimeo_token', $vimeo_token, false, '',  '', 'Your Vimeo Access Token' );
		wpvmachine_field_static( 'Redirect URL', admin_url( 'admin.php?page=wp-video-machine-settings&vimeo_auth=1'), '', 'feat-url', '' );
	?>
		</table>
		<br/>

		<h3><i class="fas fa-video"></i> Dailymotion Authorization</h3>

	    	<table class="form-table">
		<?php
			$dailymotion_api_key = isset( $dailymotion_settings['api_key'] ) ? trim( $dailymotion_settings['api_key'] ) : '';
			$dailymotion_api_secret = isset( $dailymotion_settings['api_secret'] ) ? trim( $dailymotion_settings['api_secret'] ) : '';
			wpvmachine_field_text( 'Dailymotion API Key', 'dailymotion_api_key', $dailymotion_api_key, false, '',  '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-authorize-wp-video-machine-to-upload-videos-to-dailymotion/" target="_blank">How to get your Dailymotion API Key and Secret</a>', 'Your Dailymotion Client ID' );
			wpvmachine_field_text( 'Dailymotion API Secret', 'dailymotion_api_secret', $dailymotion_api_secret, false, '',  '', 'Your Dailymotion API Secret' );
			wpvmachine_field_static( 'Callback URL', admin_url( 'admin.php?page=wp-video-machine-settings&dailymotion_auth=1'), '', 'feat-url', '' );
		?>
			</table>
	<?php
	}
}


function wpvmachine_extra_youtube_accounts( $settings ) {
    for( $i=1; $i<11;$i++ ) {
        wpvmachine_extra_youtube_account( $settings, $i );
    }
}

function wpvmachine_extra_youtube_account( $settings, $num ) {
    $youtube_settings = isset( $settings[$num] ) ? $settings[$num] : false;
    // var_dump($youtube_settings);
    $youtube_name = '';
    $youtube_client_id = '';
    $youtube_client_secret = '';
    if( !empty( $youtube_settings ) ) {
        $youtube_name = isset( $youtube_settings['name'] ) ? $youtube_settings['name'] : '';
        $youtube_client_id = isset( $youtube_settings['client_id'] ) ? $youtube_settings['client_id'] : '';
        $youtube_client_secret = isset( $youtube_settings['client_secret'] ) ? $youtube_settings['client_secret'] : '';
    }
    echo '<h3><i class="fab fa-youtube-square"></i> Account '.$num.'</h3>';
    echo '<table class="form-table">';
    wpvmachine_field_text( 'Account name', 'youtube_namem['.$num.']', $youtube_name, false, '',  '', 'Give this account a name' );
    wpvmachine_field_text( 'Youtube Client ID', 'youtube_client_idm['.$num.']', $youtube_client_id, false, '',  '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-youtube-client-id-and-secret/" target="_blank">How to get your Youtube Client ID and Secret</a>', 'Your Youtube Client ID' );
    wpvmachine_field_text( 'Youtube Client Secret', 'youtube_client_secretm['.$num.']', $youtube_client_secret, false, '',  '', 'Your Youtube Client Secret' );
    wpvmachine_field_static( 'Redirect URL', admin_url( 'admin.php?page=wp-video-machine-settings&yt_auth=1&num='.$num), '', 'feat-url', 'Enter this URL when setting up the project in the Google Developers Console' );
    // dashboardx_text_field('youtube_namem['.$num.']', $youtube_name, 'Account Name', 'Give it a name for your future reference' );
    // dashboardx_text_field('youtube_client_idm['.$num.']', $youtube_client_id, 'Youtube Client ID', 'Your Youtube Client ID' );
    // dashboardx_text_field('youtube_client_secretm['.$num.']', $youtube_client_secret, 'Youtube Client Secret', 'Your Youtube Client Secret' );
    // dashboardx_text_field('youtube_redi_urlm', DASHBOARDX_APP_URL.'/app-settings.php?auth=youtube&num='.$num, 'Redirect URL', '', '(Enter this redirect URL inside the Google Developers console in your project)', 1, 0 );
    if( !empty( $youtube_client_id ) && !empty( $youtube_client_secret ) ) {
        echo '<tr><th></th><td><button type="button" data-account-num = "'.$num.'" class="button button-secondary do-auth-youtube-acc"><i class="fas fa-sign-in-alt"></i> Authorize Youtube account '.$num.'</button></td>';
    }
    echo '</table>';

    echo '<hr/>';
}
function wpvmachine_set_tab_social( $settings ) {
	    $social_settings = isset( $settings['social'] ) ? $settings['social'] : false;
	    // var_dump($social_settings);
	    $twitter_key = isset( $social_settings['twitter']['key'] ) ? trim( $social_settings['twitter']['key'] ) : '';
	    $twitter_secret = isset( $social_settings['twitter']['secret'] ) ? trim( $social_settings['twitter']['secret'] ) : '';
	    $twitter_oauth_token = isset( $social_settings['twitter']['oauth_token'] ) ? trim( $social_settings['twitter']['oauth_token'] ) : '';
	    $twitter_oauth_secret = isset( $social_settings['twitter']['oauth_secret'] ) ? trim( $social_settings['twitter']['oauth_secret'] ) : '';

	    $facebook_app_id = isset( $social_settings['facebook']['app_id'] ) ? trim( $social_settings['facebook']['app_id'] ) : '';
	    $facebook_app_secret = isset( $social_settings['facebook']['app_secret'] ) ? trim( $social_settings['facebook']['app_secret'] ) : '';

	    $pinterest_email = isset( $social_settings['pinterest']['email'] ) ? trim( $social_settings['pinterest']['email'] ) : '';
	    $pinterest_pass = isset( $social_settings['pinterest']['pass'] ) ? trim( $social_settings['pinterest']['pass'] ) : '';
	    $pinterest_app_id = isset( $social_settings['pinterest']['app_id'] ) ? trim( $social_settings['pinterest']['app_id'] ) : '';
	    $pinterest_app_secret = isset( $social_settings['pinterest']['app_secret'] ) ? trim( $social_settings['pinterest']['app_secret'] ) : '';

	    // $stumbleupon_email = isset( $social_settings['stumbleupon']['email'] ) ? trim( $social_settings['stumbleupon']['email'] ) : '';
	    // $stumbleupon_pass = isset( $social_settings['stumbleupon']['pass'] ) ? trim( $social_settings['stumbleupon']['pass'] ) : '';

	    // $reddit_email = isset( $social_settings['reddit']['email'] ) ? trim( $social_settings['reddit']['email'] ) : '';
	    // $reddit_pass = isset( $social_settings['reddit']['pass'] ) ? trim( $social_settings['reddit']['pass'] ) : '';

	    // $instagram_email = isset( $social_settings['instagram']['email'] ) ? trim( $social_settings['instagram']['email'] ) : '';
	    // $instagram_pass = isset( $social_settings['instagram']['pass'] ) ? trim( $social_settings['instagram']['pass'] ) : '';

	    // $googleplus_email = isset( $social_settings['googleplus']['email'] ) ? trim( $social_settings['googleplus']['email'] ) : '';
	    // $googleplus_pass = isset( $social_settings['googleplus']['pass'] ) ? trim( $social_settings['googleplus']['pass'] ) : '';
	    // $googleplus_apikey = isset( $social_settings['googleplus']['key'] ) ? trim( $social_settings['googleplus']['key'] ) : '';

	    $medium_token = isset( $social_settings['medium']['token'] ) ? trim( $social_settings['medium']['token'] ) : '';

	    $tumblr_key = isset( $social_settings['tumblr']['key'] ) ? trim( $social_settings['tumblr']['key'] ) : '';
	    $tumblr_secret = isset( $social_settings['tumblr']['secret'] ) ? trim( $social_settings['tumblr']['secret'] ) : '';
	    $tumblr_oauth_token = isset( $social_settings['tumblr']['oauth_token'] ) ? trim( $social_settings['tumblr']['oauth_token'] ) : '';
	    $tumblr_oauth_secret = isset( $social_settings['tumblr']['oauth_secret'] ) ? trim( $social_settings['tumblr']['oauth_secret'] ) : '';

	    $linkedin_app_id = isset( $social_settings['linkedin']['app_id'] ) ? trim( $social_settings['linkedin']['app_id'] ) : '';
	    $linkedin_app_secret = isset( $social_settings['linkedin']['app_secret'] ) ? trim( $social_settings['linkedin']['app_secret'] ) : '';

	    $buffer_client_id = isset( $social_settings['buffer']['client_id'] ) ? trim( $social_settings['buffer']['client_id'] ) : '';
	    $buffer_client_secret = isset( $social_settings['buffer']['client_secret'] ) ? trim( $social_settings['buffer']['client_secret'] ) : '';

	    wpvmachine_try_linkedin_auth( $linkedin_app_id, $linkedin_app_secret );
	    // var_dump($social_settings['buffer']);
	?>
	    <p>Enter your social settings if you would like to share your videos uploaded to Youtube on social media to get extra traffic to them</p>

	    <h3><i class="fab fa-facebook-f"></i> Facebook</h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'App ID', 'wpvmachine_facebook_app_id', $facebook_app_id, false, '', '', 'Your Facebook App ID' ); ?>
	        <?php wpvmachine_field_text( 'App Secret', 'wpvmachine_facebook_app_secret', $facebook_app_secret, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-a-facebook-app-id-and-secret/" target="_blank">How to get your free Facebook App ID and Secret</a>', 'Your Facebook App Secret' ); ?>
	    </table>
	    <?php
	        $login_url = false;
	        if ( !empty($facebook_app_id ) && !empty( $facebook_app_secret ) ) {
	            require_once WPVMACHINE_DIR . 'lib/libs/facebook/Facebook/autoload.php';
	            $fb = new Facebook\Facebook([
	                'app_id' => $facebook_app_id,
	                'app_secret' =>$facebook_app_secret,
	            ]);

	            $helper = $fb->getRedirectLoginHelper();
	            $permissions = ['publish_actions,manage_pages,publish_pages']; // optional
	            $login_url = $helper->getLoginUrl( WPVMACHINE_URL . '/lib/libs/facebook/facebookcallback.php?fbid=' . $facebook_app_id . '&secret=' . $facebook_app_secret . '' , $permissions);
	        }
	        if( $login_url ) {
	            echo '<a href="'.$login_url.'" class="button button-secondary">Auth Facebook</a>';
	        }
	    ?>
	    <br/>
	    <br/>

	    <h3><i class="fab fa-twitter"></i> Twitter</h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Consumer Key', 'wpvmachine_twitter_key', $twitter_key, false, '', '', 'Your Twitter Consumer Key' ); ?>
	        <?php wpvmachine_field_text( 'Consumer Secret', 'wpvmachine_twitter_secret', $twitter_secret, false, '', '', 'Your Twitter Consumer Secret' ); ?>
	        <?php wpvmachine_field_text( 'Oauth Access Token', 'wpvmachine_twitter_token', $twitter_oauth_token, false, '', '', 'Your Twitter Oauth Token' ); ?>
	        <?php wpvmachine_field_text( 'Oauth Token Secret', 'wpvmachine_twitter_oauth_secret', $twitter_oauth_secret, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-twitter-details/" target="_blank">How to get your free Twitter API Details</a>', 'Your Twitter Token Secret' ); ?>
	    </table>
	    <br/>

	    <h3><i class="fab fa-medium"></i> Medium</h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Token', 'wpvmachine_medium_token', $medium_token, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-medium-token/" target="_blank">How to get your free Medium Token</a>', 'Your Medium Token' ); ?>
	    </table>
	    <br/>

	    <h3><i class="fab fa-tumblr"></i> Tumblr</h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Consumer Key', 'wpvmachine_tumblr_key', $tumblr_key, false, '', '', 'Your Tumblr Consumer Key' ); ?>
	        <?php wpvmachine_field_text( 'Consumer Secret', 'wpvmachine_tumblr_secret', $tumblr_secret, false, '', '', 'Your Tumblr Consumer Secret' ); ?>
	        <?php wpvmachine_field_text( 'Oauth Access Token', 'wpvmachine_tumblr_token', $tumblr_oauth_token, false, '', '', 'Your Tumblr Oauth Token' ); ?>
	        <?php wpvmachine_field_text( 'Oauth Token Secret', 'wpvmachine_tumblr_oauth_secret', $tumblr_oauth_secret, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-tumblr-api-details/" target="_blank">How to get your free Tumblr API Details</a>', 'Your Tumblr Token Secret'  ); ?>
	    </table>
	    <br/>
	    <h3><i class="fab fa-linkedin"></i> Linkedin</h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'App ID/Api Key', 'wpvmachine_linkedin_app_id', $linkedin_app_id, false, '', '', 'Your Linkedin App ID' ); ?>
	        <?php wpvmachine_field_text( 'App Secret', 'wpvmachine_linkedin_app_secret', $linkedin_app_secret, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-linkedin-app-details/" target="_blank">How to get your Linkedin API Details</a>', 'Your Linkedin App Secret' ); ?>
	        <?php wpvmachine_field_static( 'Callback URL', admin_url('/admin.php?page=wp-video-machine-settings&lin_auth=true'), false, '', 'Enter this URL to your linkedin app in OAuth 2.0 Redirect URLs field.'  ); ?>
	    </table>

	    <?php
	        $login_url = false;
	        if ( !empty($linkedin_app_id ) && !empty( $linkedin_app_secret ) ) {
	            require_once WPVMACHINE_DIR . 'lib/libs/linkedin/LinkedIn.php';
	            $li = new LinkedIn(
	              array(
	                'api_key' => $linkedin_app_id,
	                'api_secret' => $linkedin_app_secret,
	                'callback_url' => admin_url('/admin.php?page=wp-video-machine-settings&lin_auth=true')
	              )
	            );

	            $login_url = $li->getLoginUrl(
	              array(
	                LinkedIn::SCOPE_BASIC_PROFILE,
	                LinkedIn::SCOPE_WRITE_SHARE
	              )
	            );
	        }
	        if( $login_url ) {
	            echo '<a href="'.$login_url.'" class="button button-secondary">Auth Linkedin</a>';
	        }
	    ?>
	    <br/>
	    <br/>

	    <h3><i class="fas fa-share-square"></i> BufferApp</h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Client ID', 'wpvmachine_buffer_client_id', $buffer_client_id, false, '', '', 'Your Buffer Client ID' ); ?>
	        <?php wpvmachine_field_text( 'Client Secret', 'wpvmachine_buffer_client_secret', $buffer_client_secret, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-buffer-client-id-and-secret/" target="_blank">How to get your Buffer API Details</a>', 'Your Buffer Client Secret' ); ?>
	        <?php wpvmachine_field_static( 'Callback URL', admin_url('/admin.php?page=wp-video-machine-settings&buffer_auth=true'), false, '', 'Enter this URL when creating your Buffer APP.'  ); ?>
	    </table>

	    <?php
	        $login_url = false;
	        if ( !empty($buffer_client_id ) && !empty( $buffer_client_secret ) ) {
	            require_once WPVMACHINE_DIR . 'lib/libs/buffer/buffer.php';
	            $buffer = new WVMBufferApp( $buffer_client_id, $buffer_client_secret, admin_url('/admin.php?page=wp-video-machine-settings&buffer_auth=true') );
	            $login_url = $buffer->get_login_url();
	            echo '<a href="'.$login_url.'" class="button button-secondary">Auth Buffer</a>';
	        }
	    ?>
	    <br/>
	    <br/>
	<?php
	}

	function wpvmachine_settings_tab_spinners( $settings = false ) {
	    $spinners_settings = isset( $settings['spinners'] ) ? $settings['spinners'] : false;
	    $srewriter_email = isset( $spinners_settings['spinrewriter']['email'] ) ? trim( $spinners_settings['spinrewriter']['email'] ) : '';
	    $srewriter_apikey = isset( $spinners_settings['spinrewriter']['apikey'] ) ? trim( $spinners_settings['spinrewriter']['apikey'] ) : '';

	    $schief_username = isset( $spinners_settings['schief']['username'] ) ? trim( $spinners_settings['schief']['username'] ) : '';
	    $schief_password = isset( $spinners_settings['schief']['password'] ) ? trim( $spinners_settings['schief']['password'] ) : '';

	    $tbs_username = isset( $spinners_settings['tbs']['username'] ) ? trim( $spinners_settings['tbs']['username'] ) : '';
	    $tbs_password = isset( $spinners_settings['tbs']['password'] ) ? trim( $spinners_settings['tbs']['password'] ) : '';

	    $wordai_username = isset( $spinners_settings['wordai']['username'] ) ? trim( $spinners_settings['wordai']['username'] ) : '';
	    $wordai_password = isset( $spinners_settings['wordai']['password'] ) ? trim( $spinners_settings['wordai']['password'] ) : '';

	    $spinner = isset( $spinners_settings['spinner'] ) ? trim( $spinners_settings['spinner'] ) : 1;
	    // var_dump($spinners_settings);
	?>
	    <p><a href="https://wpvideomachine.com/support/knowledgebase/what-is-an-article-spinner-and-why-should-i-use-it/" target="_blank"><i class="fa fa-question"></i> What is an article spinner?</a></p>
	    <h3><i class="fa fa-random"></i> Spin Rewriter - <a href="https://wpvideomachine.com/support/spinrewriter" target="_blank" style="font-size: 0.9em">Get an account</a></h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Spin Rewriter Email', 'wpvmachine_srewriter_email', $srewriter_email, false, '', '', 'Your Spin Rewriter Email address' ); ?>
	        <?php wpvmachine_field_text( 'Spin Rewriter Api Key', 'wpvmachine_srewriter_apikey', $srewriter_apikey, false, '', 'Get it <a target="_blank" href="https://wpvideomachine.com/support/spinrewriter">here</a> - <a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-spin-rewriter-api-key/" target="_blank">Tutorial</a>', 'Your Spin Rewriter API Key' ); ?>
	    </table>
	    <br/>
	    <h3><i class="fa fa-random"></i> Spinner Chief - <a href="https://wpvideomachine.com/support/spinnerchief" target="_blank" style="font-size: 0.9em">Get an account</a></h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Username', 'wpvmachine_schief_username', $schief_username, false, '', '', 'Your Email address for Spinner Chief' ); ?>
	        <?php wpvmachine_field_password( 'Password', 'wpvmachine_schief_pass', $schief_password, false, '', 'Get it <a target="_blank" href="https://wpvideomachine.com/support/spinnerchief">here</a> - <a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-settings-for-spinner-chief/" target="_blank">Tutorial</a>', 'Your Spinner Chief Password' ); ?>
	    </table>
	    <br/>
	    <h3><i class="fa fa-random"></i> The Best Spinner - <a href="https://wpvideomachine.com/support/bestspinner" target="_blank" style="font-size: 0.9em">Get an account</a></h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Username', 'wpvmachine_tbspinner_username', $tbs_username, false, '', '', 'Your Email address for TBS' ); ?>
	        <?php wpvmachine_field_password( 'Password', 'wpvmachine_tbspinner_pass', $tbs_password, false, '', 'Get it <a target="_blank" href="https://wpvideomachine.com/support/bestspinner">here</a> - <a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-settings-for-the-best-spinner/" target="_blank">Tutorial</a>', 'Your TBS Password' ); ?>
	    </table>
	    <br/>
	    <?php 
	    // echo wpvmachine_spin_text_schief( 'The cat sat on the mat, and this is very good because Spain is a nice country, and I like to go fishing on the weekend to visit my friends, who are very kind' );
	    ?>
	    <h3><i class="fa fa-random"></i> WordAI - <a href="https://wpvideomachine.com/support/wordai" target="_blank" style="font-size: 0.9em">Get an account</a></h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Email', 'wpvmachine_wordai_username', $wordai_username, false, '', '', 'Your Email address for WordAI' ); ?>
	        <?php wpvmachine_field_password( 'Password', 'wpvmachine_wordai_pass', $wordai_password, false, '', 'Get it <a target="_blank" href="https://wpvideomachine.com/support/wordai">here</a> - <a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-settings-for-wordai/" target="_blank">Tutorial</a>', 'Your WordAI Password' ); ?>
	    </table>

	    <br/>
	    <h3>Spinner to Use</h3>
	    <table class="form-table">
	    <?php
	        $spinners = array( array( 'value' => 1, 'label' => 'Spin Rewriter' ), array( 'value' => 2, 'label' => 'The Best Spinner' ), array( 'value' => 3, 'label' => 'WordAI'  ), array( 'value' => 4, 'label' => 'Spinner Chief',  ) );
	    ?>
	    <?php wpvmachine_field_select( 'Spinner', 'wpvmachine_spinner', $spinner, $spinners, false, 'Select the spinner you want to use (you need to enter the details for that spinner above or it won\'t work)' ); ?>
	    </table>
	    <br/>

	<?php
	}


	function wpvmachine_settings_tab_affiliate( $settings = false ) {
	    $aff_settings = isset( $settings['affiliate'] ) ? $settings['affiliate'] : false;
	    $amazon_key = isset( $aff_settings['amazon']['key'] ) ? trim( $aff_settings['amazon']['key'] ) : '';
	    $amazon_secret = isset( $aff_settings['amazon']['secret'] ) ? trim( $aff_settings['amazon']['secret'] ) : '';
	    $amazon_tag = isset( $aff_settings['amazon']['tag'] ) ? trim( $aff_settings['amazon']['tag'] ) : '';
	    $amazon_country = isset( $aff_settings['amazon']['country'] ) ? trim( $aff_settings['amazon']['country'] ) : 'com';
	    $ebay_appid = isset( $aff_settings['ebay']['appid'] ) ? trim( $aff_settings['ebay']['appid'] ) : '';
	    $ebay_campaignid = isset( $aff_settings['ebay']['campaignid'] ) ? trim( $aff_settings['ebay']['campaignid'] ) : '';
	    $ebay_country = isset( $aff_settings['ebay']['country'] ) ? trim( $aff_settings['ebay']['country'] ) : 'US';
	    $clickbank_id = isset( $aff_settings['clickbank']['id'] ) ? trim( $aff_settings['clickbank']['id'] ) : '';
	    $bestbuy_api = isset( $aff_settings['bestbuy']['apikey'] ) ? trim( $aff_settings['bestbuy']['apikey'] ) : '';
	    $walmart_api = isset( $aff_settings['walmart']['apikey'] ) ? trim( $aff_settings['walmart']['apikey'] ) : '';
	    $walmart_aff_id = isset( $aff_settings['walmart']['aff_id'] ) ? trim( $aff_settings['walmart']['aff_id'] ) : '';
	    $envato_api = isset( $aff_settings['envato']['apikey'] ) ? trim( $aff_settings['envato']['apikey'] ) : '';
	    $envato_username = isset( $aff_settings['envato']['username'] ) ? trim( $aff_settings['envato']['username'] ) : '';

	    $aliexpress_api = isset( $aff_settings['aliexpress']['apikey'] ) ? trim( $aff_settings['aliexpress']['apikey'] ) : '';
	    $aliexpress_hash = isset( $aff_settings['aliexpress']['hash'] ) ? trim( $aff_settings['aliexpress']['hash'] ) : '';
	    $careerjet_affid = isset( $aff_settings['careerjet']['affid'] ) ? trim( $aff_settings['careerjet']['affid'] ) : '';
	    $gearbest_appid = isset( $aff_settings['gearbest']['appid'] ) ? trim( $aff_settings['gearbest']['appid'] ) : '';
	    $gearbest_appsecret = isset( $aff_settings['gearbest']['appsecret'] ) ? trim( $aff_settings['gearbest']['appsecret'] ) : '';
	    $gearbest_deeplink = isset( $aff_settings['gearbest']['deeplink'] ) ? trim( $aff_settings['gearbest']['deeplink'] ) : '';

	?>
	<h3><i class="fab fa-amazon"></i> Amazon</h3>
	<table class="form-table">
	    <?php wpvmachine_field_text( 'Amazon Key', 'wpvmachine_amazon_key', $amazon_key, false, '', '', 'Your Amazon Key' ); ?>
	    <?php wpvmachine_field_text( 'Amazon Secret', 'wpvmachine_amazon_secret', $amazon_secret, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-create-an-amazon-key-and-secret/" target="_blank">How to get your free Key and Secret Key from Amazon</a>', 'Your Amazon Secret Key' ); ?>
	    <?php wpvmachine_field_text( 'Amazon Tag', 'wpvmachine_amazon_tag', $amazon_tag, false, '', 'usually ends with -20', 'Your Amazon Affiliate Tag ' ); ?>
	    <?php $amazon_countries = wpvmachine_get_amazon_countries(); ?>
	    <?php wpvmachine_field_select( 'Amazon Country', 'wpvmachine_amazon_country', $amazon_country, $amazon_countries, false, '' ); ?>
	</table>
	<br/>
	<h3><i class="fab fa-ebay"></i> eBay</h3>
	<table class="form-table">
	    <?php wpvmachine_field_text( 'App ID', 'wpvmachine_ebay_appid', $ebay_appid, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-create-an-ebay-app/" target="_blank">How to get your free ebay App ID</a>', 'Your ebay App ID' ); ?>
	    <?php wpvmachine_field_text( 'Default Campaign ID', 'wpvmachine_ebay_cid', $ebay_campaignid, false, '', 'Your campaign ID to use. Get it <a target="_blank" href="https://epn.ebay.com/login">here</a>' ); ?>
	    <?php $ebay_countries = wpvmachine_get_ebay_countries(); ?>
	    <?php wpvmachine_field_select( 'eBay Country', 'wpvmachine_ebay_country', $ebay_country, $ebay_countries, false, '' ); ?>
	</table>

	<br/>

	<h3><i class="fas fa-shopping-cart"></i> Aliexpress</h3>
	<table class="form-table">
	    <?php wpvmachine_field_text( 'EPN API Key', 'wpvmachine_aliexpress_api', $aliexpress_api, false, '', 'Get it <a target="_blank" href="https://epn.bz/en/cabinet#/epn-api">here</a> - <a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-epn-api-and-hash-for-aliexpress/" target="_blank">Tutorial</a>' ); ?>
	    <?php wpvmachine_field_text( 'EPN Deeplink Hash', 'wpvmachine_aliexpress_hash', $aliexpress_hash, false, '', 'Your EPN Hash. Get it <a target="_blank" href="https://epn.bz/en/cabinet#/creative/create/type/4">here</a>' ); ?>
	</table>

	<br/>
	<h3><i class="fas fa-shopping-cart"></i> Gearbest</h3>
	<table class="form-table">
	    <?php wpvmachine_field_text( 'Gearbest DeepLink ID', 'wpvmachine_gearbest_deeplink', $gearbest_deeplink, false, '', 'Get it <a target="_blank" href="https://affiliate.gearbest.com/">here</a> - <a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-gearbest-app-id-and-secret/" target="_blank">Tutorial</a>' ); ?>
	    <?php wpvmachine_field_text( 'Gearbest App ID', 'wpvmachine_gearbest_appid', $gearbest_appid, false, '', 'Your Gearbest App ID' ); ?>
	    <?php wpvmachine_field_text( 'Gearbest App Secret', 'wpvmachine_gearbest_appsecret', $gearbest_appsecret, false, '', 'Your Gearbest App Secret' ); ?>
	</table>

	<br/>
	<h3><i class="far fa-bell"></i> Clickbank</h3>
	<table class="form-table">
	    <?php wpvmachine_field_text( 'CBPro Ads Account Number', 'wpvmachine_clickbank_id', $clickbank_id, false, '', 'Get it <a target="_blank" href="https://wpvideomachine.com/support/cbproads">here</a> - <a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-cbpro-ads-account-number/" target="_blank">Tutorial</a>' ); ?>
	</table>

	<br/>
	<h3><i class="fa fa-shopping-cart"></i> Best Buy</h3>
	<table class="form-table">
	    <?php wpvmachine_field_text( 'BestBuy API Key', 'wpvmachine_bestbuy_api', $bestbuy_api, false, '', 'Get it <a target="_blank" href="https://developer.bestbuy.com">here</a> - <a target="_blank" href="https://wpvideomachine.com/support/knowledgebase/how-to-create-a-best-buy-api-key/">Tutorial</a>', 'Your BestBuy API Key' ); ?>
	</table>

	<br/>
	<h3><i class="fa fa-shopping-cart"></i> Walmart</h3>
	<table class="form-table">
	    <?php wpvmachine_field_text( 'Walmart API Key', 'wpvmachine_walmart_api', $walmart_api, false, '', 'Get it <a target="_blank" href="https://developer.walmartlabs.com/">here</a> - <a target="_blank" href="https://wpvideomachine.com/support/knowledgebase/how-to-create-a-walmart-api-key-and-get-your-affiliate-id/">Tutorial</a>' ); ?>
	    <?php wpvmachine_field_text( 'Walmart Affiliate ID', 'wpvmachine_walmart_aff_id', $walmart_aff_id, false, '', 'Your Linkshare Id. Get it <a target="_blank" href="http://cli.linksynergy.com/cli/publisher/home.php">here</a>' ); ?>
	</table>

	<br/>
	<h3><i class="fa fa-leaf"></i> Envato</h3>
	<table class="form-table">
	    <?php wpvmachine_field_text( 'Envato API Key', 'wpvmachine_envato_api', $envato_api, false, '', 'Get it <a target="_blank" href="https://build.envato.com/my-apps/#tokens">here</a> - <a target="_blank" href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-envato-api-key/">Tutorial</a>', 'Your Envato API Key' ); ?>
	    <?php wpvmachine_field_text( 'Envato username', 'wpvmachine_envato_username', $envato_username, false, '', 'So you can get affiliate commissions from Envato sites' ); ?>
	</table>

	<?php
	}

	function wpvmachine_settings_tab_content( $settings = false ) {
	    $content_settings = isset( $settings['content'] ) ? $settings['content'] : false;
	    $vimeo_app = isset( $content_settings['vimeo']['appid'] ) ? trim( $content_settings['vimeo']['appid'] ) : '';
	    $vimeo_secret = isset( $content_settings['vimeo']['appsecret'] ) ? trim( $content_settings['vimeo']['appsecret'] ) : '';
	    $vimeo_token = isset( $content_settings['vimeo']['token'] ) ? trim( $content_settings['vimeo']['token'] ) : '';

	    $youtube_apikey = isset( $content_settings['youtube']['apikey'] ) ? trim( $content_settings['youtube']['apikey'] ) : '';
	    $eza_apikey = isset( $content_settings['eza']['apikey'] ) ? trim( $content_settings['eza']['apikey'] ) : '';
	    $newsapi_apikey = isset( $content_settings['newsapi']['apikey'] ) ? trim( $content_settings['newsapi']['apikey'] ) : '';
	    $nyt_apikey = isset( $content_settings['nyt']['apikey'] ) ? trim( $content_settings['nyt']['apikey'] ) : '';
	    $whio_apikey = isset( $content_settings['whio']['apikey'] ) ? trim( $content_settings['whio']['apikey'] ) : '';
	    $etsy_apikey = isset( $content_settings['etsy']['apikey'] ) ? trim( $content_settings['etsy']['apikey'] ) : '';

	    $bigcs_username = isset( $content_settings['bigcs']['username'] ) ? trim( $content_settings['bigcs']['username'] ) : '';
	    $bigcs_apikey = isset( $content_settings['bigcs']['apikey'] ) ? trim( $content_settings['bigcs']['apikey'] ) : '';

	    $bigas_username = isset( $content_settings['bigas']['username'] ) ? trim( $content_settings['bigas']['username'] ) : '';
	    $bigas_apikey = isset( $content_settings['bigas']['apikey'] ) ? trim( $content_settings['bigas']['apikey'] ) : '';

	    $aforge_username = isset( $content_settings['aforge']['username'] ) ? trim( $content_settings['aforge']['username'] ) : '';
	    $aforge_apikey = isset( $content_settings['aforge']['apikey'] ) ? trim( $content_settings['aforge']['apikey'] ) : '';

	    $abuilder_username = isset( $content_settings['abuilder']['username'] ) ? trim( $content_settings['abuilder']['username'] ) : '';
	    $abuilder_pass = isset( $content_settings['abuilder']['pass'] ) ? trim( $content_settings['abuilder']['pass'] ) : '';

	    $udemy_client_id = isset( $content_settings['udemy']['client_id'] ) ? trim( $content_settings['udemy']['client_id'] ) : '';
	    $udemy_client_secret = isset( $content_settings['udemy']['client_secret'] ) ? trim( $content_settings['udemy']['client_secret'] ) : '';

	    $plrtrove_apikey = isset( $content_settings['plrtrove']['apikey'] ) ? trim( $content_settings['plrtrove']['apikey'] ) : '';
	    $eventbrite_token = isset( $content_settings['eventbrite']['token'] ) ? trim( $content_settings['eventbrite']['token'] ) : '';

	    $yelp_client_id = isset( $content_settings['yelp']['client_id'] ) ? trim( $content_settings['yelp']['client_id'] ) : '';
	    $yelp_client_secret = isset( $content_settings['yelp']['client_secret'] ) ? trim( $content_settings['yelp']['client_secret'] ) : '';
	?>
	    <h3><i class="fab fa-youtube"></i> Youtube</h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Youtube API Key', 'wpvmachine_youtube_apikey', $youtube_apikey, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-create-a-youtube-api-key/" target="_blank">How to get your API Key from Youtube</a>', 'Your Youtube API Key' ); ?>
	    </table>
	    <br/>
	    <!-- <h3><i class="fab fa-vimeo"></i> Vimeo</h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Vimeo Application ID', 'wpvmachine_vimeo_appid', $vimeo_app, false, '', '', 'Your Vimeo App ID' ); ?>
	        <?php wpvmachine_field_text( 'Vimeo Application Secret', 'wpvmachine_vimeo_appsecret', $vimeo_secret, false, '', '', 'Your Vimeo App Secret' ); ?>
	        <?php wpvmachine_field_text( 'Vimeo Access token', 'wpvmachine_vimeo_token', $vimeo_token, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-create-a-vimeo-application/" target="_blank">How to create a Vimeo Application</a>', 'Your Vimeo Access Token' ); ?>
	    </table>
	    <br/> -->

	    <!-- <h3><i class="fa fa-file-text-o"></i> EzineArticles</h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'EzineArticles API Key', 'wpvmachine_eza_apikey', $eza_apikey, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-create-a-ezinearticles-api-key/" target="_blank">How to get your free API Key from EZA</a>', 'Your EzineArticles API Key' ); ?>
	    </table>
	    <br/> -->

	    <h3><i class="fas fa-newspaper"></i> Newsapi</h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Newsapi.org API Key', 'wpvmachine_newsapi_apikey', $newsapi_apikey, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-a-newsapi-org-api-key/" target="_blank">How to get your free API Key from Newsapi.org</a>', 'Your Newsapi.org API Key' ); ?>
	    </table>
	    <br/>

	   <!--  <h3><i class="fa fa-newspaper-o"></i> New York Times</h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'NYT API Key', 'wpvmachine_nyt_apikey', $nyt_apikey, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-a-new-york-times-api-key/" target="_blank">How to get your free API Key from NYT</a>', 'Your New York Times API Key' ); ?>
	    </table>
	    <br/>
	        <h3><i class="fa fa-newspaper-o"></i> Webhose.io</h3>
	        <table class="form-table">
	            <?php wpvmachine_field_text( 'Webhose.io API Key', 'wpvmachine_whio_apikey', $whio_apikey, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-a-webhose-io-api-key/" target="_blank">How to get your free API Key from Webhose.io</a>', 'Your Webhose.io API Key' ); ?>
	        </table>
	        <br/> -->
	    <h3><i class="fa fa-qrcode"></i> BigContentSearch.com - <a href="https://wpvideomachine.com/support/bigcontentsearch" target="_blank" style="font-size: 0.9em">Get an account</a></h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'E-mail', 'wpvmachine_bigcs_username', $bigcs_username, false, '', '', 'Your Big Content Search email address' ); ?>
	        <?php wpvmachine_field_text( 'API Key', 'wpvmachine_bigcs_apikey', $bigcs_apikey, false, '', '<a href="https://wpvideomachine.com/support/bigcontentsearch" target="_blank">Get it here</a> - <a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-bigcontentsearch-com-api-key/" target="_blank">Tutorial</a>', 'Your Big Content Search API Key' ); ?>
	    </table>
	    <br/>

	    <h3><i class="fa fa-qrcode"></i> ArticleBuilder - <a href="https://wpvideomachine.com/support/articlebuilder" target="_blank" style="font-size: 0.9em">Get an account</a></h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Username', 'wpvmachine_abuilder_username', $abuilder_username, false, '', '', 'Your ArticleBuilder username' ); ?>
	        <?php wpvmachine_field_password( 'Password', 'wpvmachine_abuilder_pass', $abuilder_pass, false, '', '<a href="https://wpvideomachine.com/support/articlebuilder" target="_blank">Get it here</a> - <a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-articlebuilder-details/" target="_blank">Tutorial</a>', 'Your ArticleBuilder Password' ); ?>
	    </table>
	    <br/>

 	    <h3><i class="fa fa-qrcode"></i> PLR Trove - <a href="https://wpvideomachine.com/support/plrtrove" target="_blank" style="font-size: 0.9em">Get an account</a></h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'PLR Trove API Key', 'wpvmachine_plrtrove_apikey', $plrtrove_apikey, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-plrtrove-api-key/" target="_blank">How to get your PLR Trove API Key</a>', 'Your PLR Trove API Key' ); ?>
	    </table>
	    <br/>
<!-- 	    <h3><i class="fa fa-etsy"></i> Etsy</h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Etsy API Key', 'wpvmachine_etsy_apikey', $etsy_apikey, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-a-etsy-api-key/" target="_blank">How to get your API Key from Etsy</a>', 'Your Etsy API Key' ); ?>
	    </table>
	    <br/> -->


	    <h3><i class="fa fa-book"></i> Udemy</h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Client ID', 'wpvmachine_udemy_client_id', $udemy_client_id, false, '', '', 'Your Udemy Client ID' ); ?>
	        <?php wpvmachine_field_text( 'Client Secret', 'wpvmachine_udemy_client_secret', $udemy_client_secret, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-udemy-client-id-and-secret/" target="_blank">How to get your Client ID and Secret from Udemy</a>', 'Your Udemy Client Secret' ); ?>
	    </table>
	    <br/>


<!-- 	    <h3><i class="fa fa-calendar-check-o"></i> Eventbrite</h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Eventbrite Token', 'wpvmachine_eventbrite_token', $eventbrite_token, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-your-eventbrite-token/" target="_blank">How to get your free Eventbrite token</a>', 'Your Eventbrite Token' ); ?>
	    </table>
	    <br/> -->

	    <h3><i class="fab fa-yelp"></i> Yelp</h3>
	    <table class="form-table">
	        <?php wpvmachine_field_text( 'Client ID', 'wpvmachine_yelp_client_id', $yelp_client_id, false, '', '', 'Your Yelp Client ID' ); ?>
	        <?php wpvmachine_field_text( 'Client Secret', 'wpvmachine_yelp_client_secret', $yelp_client_secret, false, '', '<a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-a-yelp-client-id-and-secret/" target="_blank">How to get your Yelp Client ID and Secret</a>', 'Your Yelp Client Secret' ); ?>
	    </table>
	    <br/>


	<?php
	}

function wpvmachine_set_tab_register( $settings ) {
?>
<table class="form-table">
	<tr valign="top">
		<th scope="row">Your e-mail</th>
		<td>
			<input type="email" class="regular-text" name="wpvmachine_email" placeholder="Enter your e-mail" value="<?php echo empty( $settings['email'] ) ? '' : $settings['email']; ?>"><br/>
			<span class="description">The e-mail you used to sign-up for WP Video Machine</span>
		</td>
	</tr>
<!-- 	<tr valign="top">
		<th scope="row">&nbsp;</th>
		<td> -->

		<!-- </td> -->
	<!-- </tr> -->
</table>
			<?php if( wpvmachine_is_valid_api() ) echo '<input type="hidden" name="wpvmachine_already_valid" value="1">';?>
<?php
}
	// add_action( 'admin_init', 'wpvmachine_check_save_settings', -5 );

	function wpvmachine_check_save_settings() {
		if( isset( $_POST['wpvmachine_save_settings'] ) ) {
			$already_valid = isset( $_POST['wpvmachine_already_valid'] );
			$valid = wpvmachine_save_settings();
			if( $valid ) {
				if( ! $already_valid )
					wp_redirect( admin_url( 'admin.php?page=wp-video-machine' ) );
				else
					wp_redirect( admin_url( 'admin.php?page=wp-video-machine-settings' ) );
				exit();
			}
			else {
				if( !wpvmachine_is_valid_api() )
					wp_redirect( admin_url( 'admin.php?page=wp-video-machine&apiinvalid=true' ) );
				else
					wp_redirect( admin_url( 'admin.php?page=wp-video-machine-settings&apiinvalid=true' ) );
				exit();
			}
		}
	}

// Save Settings

/*
	Change in e-mail???

*/
	function wpvmachine_save_settings() {
	    $settings = wpvmachine_get_plugin_settings();
	    $prev_email = isset( $settings['email'] ) ? trim( $settings['email'] ) : '';
	    $reg_email = isset( $_POST['wpvmachine_email'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_email'] ) ) : '';

	    if( isset( $_POST['wpvmachine_email_only'] ) ) {
	    	// first time activation, o se fue la licencia
	    	$is_valid = wpvmachine_check_valid_user( $reg_email );
	    	// var_dump($is_valid);
	    	if( $is_valid )
	    		wpvmachine_set_valid_api();
	    	else
	    		wpvmachine_set_invalid_api();
	    	if( empty( $settings ) )
	    		$settings = array();
	    	$settings['email'] = $reg_email;
	    	wpvmachine_save_plugin_settings( $settings );
	    	return $is_valid;
	    }
	    else if( !wpvmachine_is_valid_api() || ( !empty( $prev_email ) && ( $prev_email != $reg_email ) ) ) {
	    	// email change
	    	$is_valid = wpvmachine_check_valid_user( $reg_email );
	    	if( $is_valid )
	    		wpvmachine_set_valid_api();
	    	else
	    		wpvmachine_set_invalid_api();
	    	// var_dump($is_valid);
	    	if( empty( $settings ) )
	    		$settings = array();
	    	$settings['email'] = $reg_email;
	    	wpvmachine_save_plugin_settings( $settings );
	    	return $is_valid;
	    }

	    // 5. Social
	    $twitter_key = isset( $_POST['wpvmachine_twitter_key'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_twitter_key'] ) ) : '';
	    $twitter_secret = isset( $_POST['wpvmachine_twitter_secret'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_twitter_secret'] ) ) : '';
	    $oauth_token = isset( $_POST['wpvmachine_twitter_token'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_twitter_token'] ) ) : '';
	    $oauth_secret = isset( $_POST['wpvmachine_twitter_oauth_secret'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_twitter_oauth_secret'] ) ) : '';

	    $facebook_app_id = isset( $_POST['wpvmachine_facebook_app_id'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_facebook_app_id'] ) ) : '';
	    $facebook_secret = isset( $_POST['wpvmachine_facebook_app_secret'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_facebook_app_secret'] ) ) : '';
	    $facebook_token = isset( $settings['social']['facebook']['token'] ) ? $settings['social']['facebook']['token'] : false;
	 /*   $pinterest_email = isset( $_POST['wpvmachine_pinterest_email'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_pinterest_email'] ) ) : '';
	    $pinterest_pass = isset( $_POST['wpvmachine_pinterest_pass'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_pinterest_pass'] ) ) : '';
	    $pinterest_app_id = isset( $_POST['wpvmachine_pinterest_app_id'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_pinterest_app_id'] ) ) : '';
	    $pinterest_secret = isset( $_POST['wpvmachine_pinterest_app_secret'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_pinterest_app_secret'] ) ) : '';

	    $stumbleupon_email = isset( $_POST['wpvmachine_stumbleupon_email'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_stumbleupon_email'] ) ) : '';
	    $stumbleupon_pass = isset( $_POST['wpvmachine_stumbleupon_pass'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_stumbleupon_pass'] ) ) : '';

	    $googleplus_email = isset( $_POST['wpvmachine_googleplus_email'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_googleplus_email'] ) ) : '';
	    $googleplus_pass = isset( $_POST['wpvmachine_googleplus_pass'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_googleplus_pass'] ) ) : '';
	    $googleplus_apikey = isset( $_POST['wpvmachine_googleplus_apikey'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_googleplus_apikey'] ) ) : '';

	    $instagram_email = isset( $_POST['wpvmachine_instagram_email'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_instagram_email'] ) ) : '';
	    $instagram_pass = isset( $_POST['wpvmachine_instagram_pass'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_instagram_pass'] ) ) : '';

	    $reddit_email = isset( $_POST['wpvmachine_reddit_email'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_reddit_email'] ) ) : '';
	    $reddit_pass = isset( $_POST['wpvmachine_reddit_pass'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_reddit_pass'] ) ) : '';
	*/
	    $medium_token = isset( $_POST['wpvmachine_medium_token'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_medium_token'] ) ) : '';

	    $tumblr_key = isset( $_POST['wpvmachine_tumblr_key'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_tumblr_key'] ) ) : '';
	    $tumblr_secret = isset( $_POST['wpvmachine_tumblr_secret'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_tumblr_secret'] ) ) : '';
	    $tumblr_oauth_token = isset( $_POST['wpvmachine_tumblr_token'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_tumblr_token'] ) ) : '';
	    $tumblr_oauth_secret = isset( $_POST['wpvmachine_tumblr_oauth_secret'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_tumblr_oauth_secret'] ) ) : '';

	    $linkedin_app_id = isset( $_POST['wpvmachine_linkedin_app_id'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_linkedin_app_id'] ) ) : '';
	    $linkedin_secret = isset( $_POST['wpvmachine_linkedin_app_secret'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_linkedin_app_secret'] ) ) : '';

	    $buffer_client_id = isset( $_POST['wpvmachine_buffer_client_id'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_buffer_client_id'] ) ) : '';
	    $buffer_client_secret = isset( $_POST['wpvmachine_buffer_client_secret'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_buffer_client_secret'] ) ) : '';

	    $settings_social = array(
	        'twitter' => array(
	            'key' => $twitter_key,
	            'secret' => $twitter_secret,
	            'oauth_token' => $oauth_token,
	            'oauth_secret' => $oauth_secret
	        ),
	        'facebook' => array(
	            'app_id' => $facebook_app_id,
	            'app_secret' => $facebook_secret,
	            'token' => $facebook_token
	        ),
	  /*      'pinterest' => array(
	            'email' => $pinterest_email,
	            'pass' => $pinterest_pass,
	            'app_id' => $pinterest_app_id,
	            'app_secret' => $pinterest_secret
	        ),
	        'stumbleupon' => array(
	            'email' => $stumbleupon_email,
	            'pass' => $stumbleupon_pass
	        ),
	        'reddit' => array(
	            'email' => $reddit_email,
	            'pass' => $reddit_pass
	        ),
	        'instagram' => array(
	            'email' => $instagram_email,
	            'pass' => $instagram_pass
	        ),
	        'googleplus' => array(
	            'email' => $googleplus_email,
	            'pass' => $googleplus_pass,
	            'key' => $googleplus_apikey
	        ),*/
	        'medium' => array(
	            'token' => $medium_token
	        ),
	        'tumblr' => array(
	            'key' => $tumblr_key,
	            'secret' => $tumblr_secret,
	            'oauth_token' => $tumblr_oauth_token,
	            'oauth_secret' => $tumblr_oauth_secret
	        ),
	        'linkedin' => array(
	            'app_id' => $linkedin_app_id,
	            'app_secret' => $linkedin_secret
	        ),
	        'buffer' => array(
	            'client_id' => $buffer_client_id,
	            'client_secret' => $buffer_client_secret
	        ),
	    );

	    $token = '';
	    $refresh_token = '';
	    if( isset( $settings['youtube'] ) && $settings['youtube'] ) {
	    	$token = isset( $settings['youtube']['token'] ) ? trim( $settings['youtube']['token'] ) : '';
	    	$refresh_token = isset( $settings['youtube']['refresh_token'] ) ? trim( $settings['youtube']['refresh_token'] ) : '';
	    }
	    $youtube_client_id = isset( $_POST['youtube_client_id'] ) ? trim( sanitize_text_field( $_POST['youtube_client_id'] ) ) : '';
	    $youtube_client_secret = isset( $_POST['youtube_client_secret'] ) ? trim( sanitize_text_field( $_POST['youtube_client_secret'] ) ) : '';



	    $settings_youtube = array(
	    	'client_id' => $youtube_client_id,
	    	'client_secret' => $youtube_client_secret,
	    	'token' => $token,
	    	'refresh_token' => $refresh_token
	    );

	    if( wpvmachine_is_pro() ) {
	    	$youtubes = array();
	    	for( $i=1; $i<=11; $i++ ) {
	    		$yt_settings = array();
	    		$youtube_name = isset( $_POST['youtube_namem'][$i] ) ? trim( $_POST['youtube_namem'][$i] ) : '';
	    		$youtube_client_id = isset( $_POST['youtube_client_idm'][$i] ) ? trim( $_POST['youtube_client_idm'][$i] ) : '';
	    		$youtube_client_secret = isset( $_POST['youtube_client_secretm'][$i] ) ? trim( $_POST['youtube_client_secretm'][$i] ) : '';

	    		$settings_old = $settings /*( isset( $settings['youtube'] ) && !empty( $settings['youtube'] ) ) ? $settings['youtube'] : array()*/;
	    		$youtube_settings_old = isset( $settings_old['youtube'][$i] ) ? $settings_old['youtube'][$i] : false;
	    		$youtube_token = '';
	    		$youtube_refresh_token = '';
	    		if( !empty( $youtube_settings_old ) ) {
	    			$youtube_token = isset( $youtube_settings_old['token'] ) ? $youtube_settings_old['token'] : '';
	    			$youtube_refresh_token = isset( $youtube_settings_old['refresh_token'] ) ? $youtube_settings_old['refresh_token'] : '';
	    		}
	    		$yt_settings = array(
	    			'name' => $youtube_name,
	    			'client_id' => $youtube_client_id,
	    			'client_secret' => $youtube_client_secret,
	    			'token' => $youtube_token,
	    			'refresh_token' => $youtube_refresh_token
	    		);
	    		$settings_youtube[$i] = $yt_settings;
	    	}
	    }

	    // 6. Affiliate
	    $amazon_key = isset( $_POST['wpvmachine_amazon_key'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_amazon_key'] ) ) : '';
	    $amazon_secret = isset( $_POST['wpvmachine_amazon_secret'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_amazon_secret'] ) ) : '';
	    $amazon_tag = isset( $_POST['wpvmachine_amazon_tag'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_amazon_tag'] ) ) : '';
	    $amazon_country = isset( $_POST['wpvmachine_amazon_country'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_amazon_country'] ) ) : '';

	    $ebay_appid = isset( $_POST['wpvmachine_ebay_appid'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_ebay_appid'] ) ) : '';
	    $ebay_cid = isset( $_POST['wpvmachine_ebay_cid'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_ebay_cid'] ) ) : '';
	    $ebay_country = isset( $_POST['wpvmachine_ebay_country'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_ebay_country'] ) ) : '';

	    $clickbank_id = isset( $_POST['wpvmachine_clickbank_id'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_clickbank_id'] ) ) : '';
	    $bestbuy_api = isset( $_POST['wpvmachine_bestbuy_api'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_bestbuy_api'] ) ) : '';
	    $walmart_api = isset( $_POST['wpvmachine_walmart_api'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_walmart_api'] ) ) : '';
	    $walmart_aff_id = isset( $_POST['wpvmachine_walmart_aff_id'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_walmart_aff_id'] ) ) : '';

	    $aliexpress_api = isset( $_POST['wpvmachine_aliexpress_api'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_aliexpress_api'] ) ) : '';
	    $aliexpress_hash = isset( $_POST['wpvmachine_aliexpress_hash'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_aliexpress_hash'] ) ) : '';
	    $envato_api = isset( $_POST['wpvmachine_envato_api'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_envato_api'] ) ) : '';
	    $envato_username = isset( $_POST['wpvmachine_envato_username'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_envato_username'] ) ) : '';

	    $careerjet_affid = isset( $_POST['wpvmachine_careerjet_affid'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_careerjet_affid'] ) ) : '';

	    $gearbest_appid = isset( $_POST['wpvmachine_gearbest_appid'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_gearbest_appid'] ) ) : '';
	    $gearbest_appsecret = isset( $_POST['wpvmachine_gearbest_appsecret'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_gearbest_appsecret'] ) ) : '';
	    $gearbest_deeplink = isset( $_POST['wpvmachine_gearbest_deeplink'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_gearbest_deeplink'] ) ) : '';


	    $settings_affiliate = array(
	        'amazon' => array(
	            'key' => $amazon_key,
	            'secret' => $amazon_secret,
	            'tag' => $amazon_tag,
	            'country' => $amazon_country
	        ),
	        'ebay' => array(
	            'appid' => $ebay_appid,
	            'campaignid' => $ebay_cid,
	            'country' => $ebay_country
	        ),
	        'clickbank'  => array(
	            'id' => $clickbank_id,
	        ),
	        'bestbuy'  => array(
	            'apikey' => $bestbuy_api,
	        ),
	        'aliexpress'  => array(
	            'apikey' => $aliexpress_api,
	            'hash' => $aliexpress_hash,
	        ),
	        'walmart'  => array(
	            'apikey' => $walmart_api,
	            'aff_id' => $walmart_aff_id,
	        ),
	        'envato'  => array(
	            'apikey' => $envato_api,
	            'username' => $envato_username
	        ),
	        'careerjet'  => array(
	            'affid' => $careerjet_affid
	        ),
	        'gearbest' => array(
	            'deeplink' => $gearbest_deeplink,
	            'appid' => $gearbest_appid,
	            'appsecret' => $gearbest_appsecret,
	        )
	    );


	    // 2. Content
	    $vimeo_app = isset( $_POST['wpvmachine_vimeo_appid'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_vimeo_appid'] ) ) : '';
	    $vimeo_secret = isset( $_POST['wpvmachine_vimeo_appsecret'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_vimeo_appsecret'] ) ) : '';
	    $vimeo_token = isset( $_POST['wpvmachine_vimeo_token'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_vimeo_token'] ) ) : '';

	    $youtube_apikey = isset( $_POST['wpvmachine_youtube_apikey'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_youtube_apikey'] ) ) : '';
	    $eza_apikey = isset( $_POST['wpvmachine_eza_apikey'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_eza_apikey'] ) ) : '';
	    $newsapi_apikey = isset( $_POST['wpvmachine_newsapi_apikey'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_newsapi_apikey'] ) ) : '';
	    $nyt_apikey = isset( $_POST['wpvmachine_nyt_apikey'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_nyt_apikey'] ) ) : '';
	    $whio_apikey = isset( $_POST['wpvmachine_whio_apikey'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_whio_apikey'] ) ) : '';
	    $etsy_apikey = isset( $_POST['wpvmachine_etsy_apikey'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_etsy_apikey'] ) ) : '';
	    $udemy_client_id = isset( $_POST['wpvmachine_udemy_client_id'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_udemy_client_id'] ) ) : '';
	    $udemy_client_secret = isset( $_POST['wpvmachine_udemy_client_secret'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_udemy_client_secret'] ) ) : '';

	    $bigcs_username = isset( $_POST['wpvmachine_bigcs_username'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_bigcs_username'] ) ) : '';
	    $bigcs_apikey = isset( $_POST['wpvmachine_bigcs_apikey'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_bigcs_apikey'] ) ) : '';

	    $bigas_username = isset( $_POST['wpvmachine_bigas_username'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_bigas_username'] ) ) : '';
	    $bigas_apikey = isset( $_POST['wpvmachine_bigas_apikey'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_bigas_apikey'] ) ) : '';

	    $aforge_username = isset( $_POST['wpvmachine_aforge_username'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_aforge_username'] ) ) : '';
	    $aforge_apikey = isset( $_POST['wpvmachine_aforge_apikey'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_aforge_apikey'] ) ) : '';

	    $abuilder_username = isset( $_POST['wpvmachine_abuilder_username'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_abuilder_username'] ) ) : '';
	    $abuilder_pass = isset( $_POST['wpvmachine_abuilder_pass'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_abuilder_pass'] ) ) : '';

	    $plrtrove_apikey = isset( $_POST['wpvmachine_plrtrove_apikey'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_plrtrove_apikey'] ) ) : '';
	    $eventbrite_token = isset( $_POST['wpvmachine_eventbrite_token'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_eventbrite_token'] ) ) : '';
	    $yelp_client_id = isset( $_POST['wpvmachine_yelp_client_id'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_yelp_client_id'] ) ) : '';
	    $yelp_client_secret = isset( $_POST['wpvmachine_yelp_client_secret'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_yelp_client_secret'] ) ) : '';
	    $yelp_token = isset( $settings['content']['yelp']['token'] ) ? $settings['content']['yelp']['token'] : false;
	    $yelp_expiration = isset( $settings['content']['yelp']['expiration'] ) ? $settings['content']['yelp']['expiration'] : false;

	    $settings_content = array(
	        'vimeo' => array(
	            'appid' => $vimeo_app,
	            'appsecret' => $vimeo_secret,
	            'token' => $vimeo_token
	        ),
	        'youtube' => array(
	            'apikey' => $youtube_apikey
	        ),
	        'eza' => array(
	            'apikey' => $eza_apikey
	        ),
	        'newsapi' => array(
	            'apikey' => $newsapi_apikey
	        ),
	        'nyt' => array(
	            'apikey' => $nyt_apikey
	        ),
	        'whio' => array(
	            'apikey' => $whio_apikey
	        ),
	        'bigcs' => array(
	            'username' => $bigcs_username,
	            'apikey' => $bigcs_apikey
	        ),
	        'bigas' => array(
	            'username' => $bigas_username,
	            'apikey' => $bigas_apikey
	        ),
	        'aforge' => array(
	            'username' => $aforge_username,
	            'apikey' => $aforge_apikey
	        ),
	        'abuilder' => array(
	            'username' => $abuilder_username,
	            'pass' => $abuilder_pass
	        ),
	        'etsy' => array(
	            'apikey' => $etsy_apikey
	        ),
	        'plrtrove' => array(
	            'apikey' => $plrtrove_apikey
	        ),
	        'udemy' => array(
	            'client_id' => $udemy_client_id,
	            'client_secret' => $udemy_client_secret
	        ),
	        'eventbrite' => array(
	            'token' => $eventbrite_token
	        ),
	        'yelp' => array(
	            'client_id' => $yelp_client_id,
	            'client_secret' => $yelp_client_secret,
	            'token' => $yelp_token,
	            'expiration' => $yelp_expiration
	        ),
	    );

	    // vimeo and dailymotion

	    $vimeo_client_id = isset( $_POST['vimeo_client_id'] ) ? trim( sanitize_text_field( $_POST['vimeo_client_id'] ) ) : '';
	    $vimeo_client_secret = isset( $_POST['vimeo_client_secret'] ) ? trim( sanitize_text_field( $_POST['vimeo_client_secret'] ) ) : '';
	    $vimeo_token = isset( $_POST['vimeo_token'] ) ? trim( sanitize_text_field( $_POST['vimeo_token'] ) ) : '';

	    $dailymotion_api_key = isset( $_POST['dailymotion_api_key'] ) ? trim( sanitize_text_field( $_POST['dailymotion_api_key'] ) ) : '';
	    $dailymotion_api_secret = isset( $_POST['dailymotion_api_secret'] ) ? trim( sanitize_text_field( $_POST['dailymotion_api_secret'] ) ) : '';


	    $settings = array(
	        'social' => $settings_social,
	        'youtube' => $settings_youtube,
	        'vimeo' => array(
	        	'client_id' => $vimeo_client_id,
	        	'client_secret' => $vimeo_client_secret,
	        	'token' => $vimeo_token,
	        ),
	        'dailymotion' => array(
	        	'api_key' => $dailymotion_api_key,
	        	'api_secret' => $dailymotion_api_secret
	        ),
	        'affiliate' => $settings_affiliate,
	        'content' => $settings_content,
	        'email' => $reg_email/*,
	        'scrolling' => array(
	            'enabled' => $scrolling_enabled,
	            'related' => $related_enabled,
	            'video' => $scrolling_video,
	            'scrolling_txt' => $scrolling_txt,
	            'button_txt' => $scrolling_button_txt
	        )*/
	    );


	    // 4. Traffic
	    $bm_email = isset( $_POST['wpvmachine_bm_email'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_bm_email'] ) ) : '';
	    $bm_apikey = isset( $_POST['wpvmachine_bm_apikey'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_bm_apikey'] ) ) : '';
	    $ili_apikey = isset( $_POST['wpvmachine_ili_apikey'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_ili_apikey'] ) ) : '';
	    $bli_apikey = isset( $_POST['wpvmachine_bli_apikey'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_bli_apikey'] ) ) : '';

	    $settings['traffic'] = array(
	        'bmachine' => array(
	            'email' => $bm_email,
	            'apikey' => $bm_apikey,
	        ),
	        'ili' => array(
	            'apikey' => $ili_apikey,
	        ),
	        'bli' => array(
	            'apikey' => $bli_apikey,
	        )
	    );

	    // 7. Text Spinners
	    $srewriter_email = isset( $_POST['wpvmachine_srewriter_email'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_srewriter_email'] ) ) : '';
	    $srewriter_apikey = isset( $_POST['wpvmachine_srewriter_apikey'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_srewriter_apikey'] ) ) : '';

	    $schief_username = isset( $_POST['wpvmachine_schief_username'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_schief_username'] ) ) : '';
	    $schief_password = isset( $_POST['wpvmachine_schief_pass'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_schief_pass'] ) ) : '';

	    $tbs_username = isset( $_POST['wpvmachine_tbspinner_username'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_tbspinner_username'] ) ) : '';
	    $tbs_password = isset( $_POST['wpvmachine_tbspinner_pass'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_tbspinner_pass'] ) ) : '';

	    $wordai_username = isset( $_POST['wpvmachine_wordai_username'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_wordai_username'] ) ) : '';
	    $wordai_password = isset( $_POST['wpvmachine_wordai_pass'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_wordai_pass'] ) ) : '';

	    $spinner = isset( $_POST['wpvmachine_spinner'] ) ? trim( sanitize_text_field( $_POST['wpvmachine_spinner'] ) ) : '';

	    $settings['spinners'] = array(
	        'spinrewriter' => array(
	            'email' => $srewriter_email,
	            'apikey' => $srewriter_apikey,
	        ),
	        'schief' => array(
	            'username' => $schief_username,
	            'password' => $schief_password,
	        ),
	        'tbs' => array(
	            'username' => $tbs_username,
	            'password' => $tbs_password,
	        ),
	        'wordai' => array(
	            'username' => $wordai_username,
	            'password' => $wordai_password,
	        ),
	        'spinner' => $spinner
	    );
	    wpvmachine_save_plugin_settings( $settings );
	    return true;
	}

	// Check youtube auth

/*	add_action( 'admin_init', 'wpvmachine_save_yt_auth', -5 );

	function wpvmachine_save_yt_auth() {

	if ( isset( $_GET['auth'] ) && ( $_GET['auth'] == 'youtube' ) && isset( $_GET['code'] ) ) {
		require_once 'lib/libs/google1/vendor/autoload.php';

		$user_id = get_logged_user();
		$settings = get_settings( $user_id );
		$youtube_settings = isset( $settings['youtube'] ) ? $settings['youtube'] : false;

		$youtube_client_id = '';
		$youtube_client_secret = '';
		if( isset( $_GET['num'] ) && !empty( $_GET['num'] ) ) {
			$num = intval( $_GET['num'] );
			$yt_settings = isset( $settings['youtube'][$num] ) ? $settings['youtube'][$num] : false;
			if( !empty( $yt_settings ) ) {
			    $youtube_client_id = isset( $yt_settings['client_id'] ) ? $yt_settings['client_id'] : '';
			    $youtube_client_secret = isset( $yt_settings['client_secret'] ) ? $yt_settings['client_secret'] : '';
			}
		}
		else {
			$num = 0;
			if( !empty( $youtube_settings ) ) {
			    $youtube_client_id = isset( $youtube_settings['client_id'] ) ? $youtube_settings['client_id'] : '';
			    $youtube_client_secret = isset( $youtube_settings['client_secret'] ) ? $youtube_settings['client_secret'] : '';
			}
		}

		$APPNAME = "Azon Video Maker2";

		$client = new Google_Client();
		$client->setClientId( $youtube_client_id );
		$client->setClientSecret( $youtube_client_secret );
		$client->setScopes('https://www.googleapis.com/auth/youtube');
		if( $num )
			$client->setRedirectUri( DASHBOARDX_APP_URL."/app-settings.php?auth=youtube&num=".$num );
		else
			$client->setRedirectUri( DASHBOARDX_APP_URL."/app-settings.php?auth=youtube" );
		$client->setApplicationName( $APPNAME );
		$client->setAccessType('offline');
		$client->setApprovalPrompt('force');

		// Define an object that will be used to make all API requests.
		$youtube = new Google_Service_YouTube( $client );

	    if (strval($_SESSION['state']) !== strval($_GET['state'])) {
	        die('The session state did not match.');
	    }

	    $client->authenticate( $_GET['code'] );
	    // $_SESSION['token'] = $client->getAccessToken();
	    // $_SESSION['refresh_token'] = $client->getRefreshToken();
	    // var_dump($client->getAccessToken());
	    $token = $client->getAccessToken();
	    if( $num ) {
	    	$youtube_settings[$num]['token'] = $token['access_token'];
	    	$youtube_settings[$num]['refresh_token'] = $token['refresh_token'];
	    }
	    else {
	    	$youtube_settings['token'] = $token['access_token'];
	    	$youtube_settings['refresh_token'] = $token['refresh_token'];
	    }
	    $settings['youtube'] = $youtube_settings;
	    save_settings( $user_id, $settings );
		// $youtube_settings = isset( $settings['youtube'] ) ? $settings['youtube'] : false;

	}
}
*/

add_action( 'admin_init', 'wpvmachine_check_yt_auth' );

function wpvmachine_check_yt_auth() {
	if ( isset( $_POST['wpvmachine_yt_auth'] ) && !empty( $_POST['wpvmachine_yt_auth'] ) || ( ( isset( $_GET['yt_auth'] ) && isset( $_GET['code'] ) ) ) ) {
		if( !class_exists( 'Google_Client' ) )
			require_once WPVMACHINE_DIR.'lib/libs/Google/Client.php';
		require_once WPVMACHINE_DIR.'lib/libs/Google/Service/YouTube.php';
		$num = 0;
		$settings = wpvmachine_get_plugin_settings();
		$youtube_settings = isset( $settings['youtube'] ) ? $settings['youtube'] : false;

		if ( isset( $_GET['yt_auth'] ) && !empty( $_GET['yt_auth'] ) && isset( $_GET['num'] ) && !empty( $_GET['num'] ) ) {
			// 2a vez, get code
			$num = intval( $_GET['num'] );
			if( !empty( $youtube_settings ) ) {
			    $youtube_client_id = isset( $youtube_settings[$num]['client_id'] ) ? $youtube_settings[$num]['client_id'] : '';
			    $youtube_client_secret = isset( $youtube_settings[$num]['client_secret'] ) ? $youtube_settings[$num]['client_secret'] : '';
			}
		}
		else if ( isset( $_POST['auth_youtube_num'] ) && !empty( $_POST['auth_youtube_num'] ) ) {
			$num = intval( $_POST['auth_youtube_num'] );
			$youtube_name = isset( $_POST['youtube_namem'][$num] ) ? trim( $_POST['youtube_namem'][$num] ) : '';
			$youtube_client_id = isset( $_POST['youtube_client_idm'][$num] ) ? trim( $_POST['youtube_client_idm'][$num] ) : '';
			$youtube_client_secret = isset( $_POST['youtube_client_secretm'][$num] ) ? trim( $_POST['youtube_client_secretm'][$num] ) : '';
			$youtube_num_settings = isset( $settings['youtube'][$num] ) ? $settings['youtube'][$num] : array();

			if( !empty( $youtube_client_id ) && !empty( $youtube_client_secret) ) {
				$youtube_num_settings['name'] = $youtube_name;
				$youtube_num_settings['client_id'] = $youtube_client_id;
				$youtube_num_settings['client_secret'] = $youtube_client_secret;
				$youtube_settings[$num] = $youtube_num_settings;
				$settings['youtube'] = $youtube_settings;
				wpvmachine_save_plugin_settings( $settings );
			}

			else if( !empty( $youtube_settings ) ) {
			    $youtube_client_id = isset( $youtube_num_settings['client_id'] ) ? $youtube_num_settings['client_id'] : '';
			    $youtube_client_secret = isset( $youtube_num_settings['client_secret'] ) ? $youtube_num_settings['client_secret'] : '';
			}
		}
		else {
			$youtube_client_id = isset( $_POST['youtube_client_id'] ) ? trim( $_POST['youtube_client_id'] ) : '';
			$youtube_client_secret = isset( $_POST['youtube_client_secret'] ) ? trim( $_POST['youtube_client_secret'] ) : '';

			// $settings = wpvmachine_get_plugin_settings();
			// $youtube_settings = isset( $settings['youtube'] ) ? $settings['youtube'] : false;
			if( !empty( $youtube_client_id ) && !empty( $youtube_client_secret) ) {
				$youtube_settings['client_id'] = $youtube_client_id;
				$youtube_settings['client_secret'] = $youtube_client_secret;
				$settings['youtube'] = $youtube_settings;
				wpvmachine_save_plugin_settings( $settings );
			}
			else if( !empty( $youtube_settings ) ) {
			    $youtube_client_id = isset( $youtube_settings['client_id'] ) ? $youtube_settings['client_id'] : '';
			    $youtube_client_secret = isset( $youtube_settings['client_secret'] ) ? $youtube_settings['client_secret'] : '';
			}
		}


		// $OAUTH2_CLIENT_ID = '193116693558-gpmlrtoe1cbudq90tmpochr2s8iout13.apps.googleusercontent.com'; // Enter your Client ID here
		// $OAUTH2_CLIENT_SECRET = 'NnYKgQlrYAZghldnA8C74TkX'; // Enter your Client Secret here
		// $REDIRECT = filter_var('http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'], FILTER_SANITIZE_URL);
		$APPNAME = "WP Affiliate Machine";

		$client = new Google_Client();
		$client->setClientId( $youtube_client_id );
		$client->setClientSecret( $youtube_client_secret );
		$client->setScopes('https://www.googleapis.com/auth/youtube');
		if( $num )
			$client->setRedirectUri( admin_url( 'admin.php?page=wp-video-machine-settings&yt_auth=1&num='.$num) );
		else
			$client->setRedirectUri( admin_url( 'admin.php?page=wp-video-machine-settings&yt_auth=1') );

		$client->setApplicationName( $APPNAME );
		$client->setAccessType('offline');
		$client->setApprovalPrompt('force');

		// Define an object that will be used to make all API requests.
		$youtube = new Google_Service_YouTube( $client );

		if (isset($_GET['code'])) {
		    if (strval( /*$_SESSION['state']*/ get_option( 'vmach_state' ) ) !== strval($_GET['state'])) {
		        die('The session state did not match.');
		    }

		    try {
			    $res = $client->authenticate( $_GET['code'] );
			    if( !empty( $res ) ) {

			    	$data = json_decode( $res );
			    	$access_token = $data->access_token;
			    	$refresh_token = $data->refresh_token;
			    	$_SESSION['token'] = $access_token;
			    	$_SESSION['refresh_token'] = $refresh_token;

			    	if( $num ) {
			    		$youtube_settings[$num]['token'] = $access_token;
			    		$youtube_settings[$num]['refresh_token'] = $refresh_token;
			    	}
			    	else {
			    		$youtube_settings['token'] = $access_token;
			    		$youtube_settings['refresh_token'] = $refresh_token;
			    	}
			    	$settings['youtube'] = $youtube_settings;
			    	wpvmachine_save_plugin_settings( $settings );
			    	if( $num )
			    		wp_redirect( admin_url( 'admin.php?page=wp-video-machine-settings&yt_authed=1&num='.$num) );
			    	else
			    		wp_redirect( admin_url( 'admin.php?page=wp-video-machine-settings&yt_authed=1') );
			    	exit();
			    }
			} catch (Exception $e) {
				// var_dump($e);die();
			    wp_redirect( admin_url( 'admin.php?page=wp-video-machine-settings&yt_authed=0') );
			    exit();
			}
		    // var_dump($res);die();
		    // $_SESSION['token'] = $client->getAccessToken();
		    // $_SESSION['refresh_token'] = $client->getRefreshToken();
		}

	// if (isset($_SESSION['token'])) {

	// }

	// Check to ensure that the access token was successfully acquired.

		$state = mt_rand();
		$client->setState($state);
		// $_SESSION['state'] = $state;
		update_option( 'vmach_state', $state );

		$authUrl = $client->createAuthUrl();
		header("Location: ".$authUrl);
		exit();
	}
	else if ( isset( $_GET['yt_auth'] ) && isset( $_GET['code'] ) ) {

	}
}

function wpvmachine_get_yt_accounts( $only_valid = true ) {
	$settings = wpvmachine_get_plugin_settings();
	$youtube_settings = isset( $settings['youtube'] ) ? $settings['youtube'] : false;
	if( empty( $youtube_settings ) )
		return array();
	$accs = array();
	$accs[] = array( 'value' => 0, 'label' => 'Main Account' );
	for( $i=0; $i < 11; $i++ ) {
		if( isset( $youtube_settings[$i] ) && !empty( $youtube_settings[$i] ) ) {
			$set = $youtube_settings[$i];
			if( isset( $set['token'] ) && !empty( $set['token'] ) && isset( $set['refresh_token'] ) && !empty( $set['refresh_token'] ) ) {
				$accs[] = array( 'value' => $i, 'label' => $set['name'] );
			}
		}
	}
	return $accs;
}

function wpvmachine_yt_accounts_select( $name = 'wpvm_yt_account', $echo = 1  ) {
	$langs = wpvmachine_get_yt_accounts();
	$str = '<select id="'.$name.'">';
	foreach( $langs as $acc ) {
		$str .= '<option value="'.$acc['value'].'">'.$acc['label'].'</option>';
	}
	$str .= '</select>';
	if( $echo )
		echo $str;
}
?>