<?php
/* Spinners */

function wpvmachine_get_valid_spinners() {
	$res = array( 0, 0, 0, 0 );
	$spinner_settings =  wpvmachine_get_settings( array( 'spinners' ) );
	$sr_settings = isset( $spinner_settings['spinrewriter'] ) ? $spinner_settings['spinrewriter'] : false;
	// var_dump($sr_settings);
	if( !empty( $sr_settings ) ) {
	    $sr_api_key = isset( $sr_settings['apikey'] ) ? trim( $sr_settings['apikey'] ) : '';
	    $sr_email = isset( $sr_settings['email'] ) ? $sr_settings['email'] : '';
	    if( !empty( $sr_api_key ) && !empty( $sr_email ) )
	    	$res[0] = 1;
	}

	$tbs_settings = isset( $spinner_settings['tbs'] ) ? $spinner_settings['tbs'] : false;
	if( !empty( $tbs_settings ) ) {
	    $tbs_email = isset( $tbs_settings['email'] ) ? trim( $tbs_settings['email'] ) : '';
	    $tbs_password = isset( $tbs_settings['password'] ) ? trim( $tbs_settings['password'] ) : '';
	    if( !empty( $tbs_email ) && !empty( $tbs_password ) )
	    	$res[1] = 1;
	}

	$schief_settings = isset( $spinner_settings['schief'] ) ? $spinner_settings['schief'] : false;
	if( !empty( $schief_settings ) ) {
	    $schief_email = isset( $schief_settings['email'] ) ? $schief_settings['email'] : '';
	    $schief_password = isset( $schief_settings['password'] ) ? $schief_settings['password'] : '';
	    if( !empty( $schief_email ) && !empty( $schief_password ) )
	    	$res[3] = 1;
	}

	$wordai_settings = isset( $spinner_settings['wordai'] ) ? $spinner_settings['wordai'] : false;
	if( !empty( $wordai_settings ) ) {
	    $wordai_email = isset( $wordai_settings['email'] ) ? $wordai_settings['email'] : '';
	    $wordai_password = isset( $wordai_settings['password'] ) ? $wordai_settings['password'] : '';
	    if( !empty( $wordai_email ) && !empty( $wordai_password ) )
	    	$res[2] = 1;
	}
	// var_dump($res);
	if( $res == array( 0, 0, 0, 0 ) )
		return false;
	return $res;
}

function wpvmachine_error_no_spinners() {
?>
<div class="">
    <i class="fas fa-warning"></i>
    To be able to use the spinning functionality, you need to have a valid account with any of these spinners:
    	<ul class="listasp">
			<li><a href="https://wpautocontent.com/support/spinrewriter" target="_blank">Spin Rewriter</a></li>
			<li><a href="https://wpautocontent.com/support/bestspinner" target="_blank">The Best Spinner</a></li>
			<li><a href="https://wpautocontent.com/support/spinnerchief" target="_blank">Spinner Chief</a></li>
			<li><a href="https://wpautocontent.com/support/wordai" target="_blank">WordAI</a></li>
    	</ul>
    	<br/>
    	and enter the details in the settings menu.
    	<br/>
    	<br/>
  </div>
<?php
}

function wpvmachine_spin_text_ajax() {
	$spinner = intval( $_POST['spinner'] );
	$text = trim( $_POST['text'] );
	if( !$text )
	    exit();
	echo wpvmachine_spin_text( $text, $spinner );
	exit();
}

function wpvmachine_spin_text( $text, $spinner = 1 ) {
	$spinners_settings = wpvmachine_get_settings( array( 'spinners' ) );
	// $spinners_settings = isset( $settings['spinners'] ) ? $settings['spinners'] : false;
	$spinner = isset( $spinners_settings['spinner'] ) ? trim( $spinners_settings['spinner'] ) : 1;
// die('sss');
	if( $spinner == 2 )
		return wpvmachine_spin_text_tbs( $text );
	else if( $spinner == 3 )
		return wpvmachine_spin_text_wordai( $text );
	else if( $spinner == 4 )
		return wpvmachine_spin_text_schief( $text );
	return wpvmachine_spin_text_srewiter( $text );
}

function wpvmachine_spin_text_srewiter( $text ) {
	require_once WPVMACHINE_DIR.'/lib/libs/spinners/SpinRewriterAPI.php';

	$sr_settings = wpvmachine_get_settings( array( 'spinners', 'spinrewriter' ) );

	// var_dump($sr_settings);
	if ( ! isset( $sr_settings['email'] ) || empty( $sr_settings['email'] ) || ! isset( $sr_settings['apikey'] ) || empty( $sr_settings['apikey'] ) )
		return $text;
// die('aa');
/*	$email_address = "raulmellado@gmail.com";			// your Spin Rewriter email address goes here
	$api_key = "e53de7e#d903feb_2d3542b?e5acb71";	// your unique Spin Rewriter API key goes here
*/
	// Include the Spin Rewriter API SDK.

	// Authenticate yourself.
	$spinrewriter_api = new SpinRewriterAPI( $sr_settings['email'], $sr_settings['apikey'] );

	/*
	 * (optional) Set a list of protected terms.
	 * You can use one of the following formats:
	 * - protected terms are separated by the '\n' (newline) character
	 * - protected terms are separated by commas (comma-separated list)
	 * - protected terms are stored in a PHP array
	 */
	// $protected_terms = "John, Douglas Adams, then";
	// $spinrewriter_api->setProtectedTerms($protected_terms);

	// (optional) Set whether the One-Click Rewrite process automatically protects Capitalized Words outside the article's title.
	$spinrewriter_api->setAutoProtectedTerms(true);

	// (optional) Set the confidence level of the One-Click Rewrite process.
	$spinrewriter_api->setConfidenceLevel("medium");

	// (optional) Set whether the One-Click Rewrite process uses nested spinning syntax (multi-level spinning) or not.
	$spinrewriter_api->setNestedSpintax(true);

	// (optional) Set whether Spin Rewriter rewrites complete sentences on its own.
	$spinrewriter_api->setAutoSentences(true);

	// (optional) Set whether Spin Rewriter rewrites entire paragraphs on its own.
	$spinrewriter_api->setAutoParagraphs(true);

	// (optional) Set whether Spin Rewriter writes additional paragraphs on its own.
	$spinrewriter_api->setAutoNewParagraphs(false);

	// (optional) Set whether Spin Rewriter changes the entire structure of phrases and sentences.
	$spinrewriter_api->setAutoSentenceTrees(true);

	// (optional) Sets whether Spin Rewriter should only use synonyms (where available) when generating spun text.
	$spinrewriter_api->setUseOnlySynonyms(false);

	// (optional) Sets whether Spin Rewriter should intelligently randomize the order of paragraphs and lists when generating spun text.
	$spinrewriter_api->setReorderParagraphs(false);

	// Make the actual API request and save the response as a native PHP array.
	// $text = "John will book a room. Then he will read a book by Douglas Adams.";
	$api_response = $spinrewriter_api->getUniqueVariation($text);
// var_dump($api_response);
// die();

	if( isset( $api_response ['status']) && $api_response ['status'] == 'OK' )
		return $api_response['response'];
	else
		return $text;
}

function wpvmachine_spin_text_wordai( $text ) {
	$sr_settings = wpvmachine_get_settings( array( 'spinners', 'wordai' ) );

	// var_dump($sr_settings);
	if ( ! isset( $sr_settings['username'] ) || empty( $sr_settings['username'] ) || ! isset( $sr_settings['password'] ) || empty( $sr_settings['password'] ) )
		return $text;

	//'Regular', 'Unique', 'Very Unique', 'Readable', or 'Very Readable

	$quality = 'Readable';
	$email = $sr_settings['username'];
	$pass = $sr_settings['password'];
	$text = urlencode($text);

     $ch = curl_init('http://wordai.com/users/turing-api.php');

     curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
     curl_setopt ($ch, CURLOPT_POST, 1);
     curl_setopt ($ch, CURLOPT_POSTFIELDS, "s=$text&quality=$quality&email=$email&pass=$pass&output=json&returnspin=true&sentence=on&paragraph=on");
     curl_setopt($ch, CURLOPT_TIMEOUT, 30); //timeout in seconds
     $result = curl_exec($ch);

     curl_close ($ch);
	// var_dump($result);
	$res = json_decode( $result );
	// var_dump($res);
	if( isset( $res->status ) && $res->status == 'Success' )
		return $res->text;
	return $text;
}

function wpvmachine_spin_text_schief( $text ) {
	$sr_settings = wpvmachine_get_settings( array( 'spinners', 'schief' ) );

	// var_dump($sr_settings);
	if ( ! isset( $sr_settings['username'] ) || empty( $sr_settings['username'] ) || ! isset( $sr_settings['password'] ) || empty( $sr_settings['password'] ) )
		return $text;

	$quality = 'Readable';
	$email = $sr_settings['username'];
	$pass = $sr_settings['password'];
	// $text = urlencode($text);

     $ch = curl_init("http://api.spinnerchief.com:443/apikey=72f539e6f62b411a9&username=$email&password=$pass&protecthtml=1&spintype=1");

     curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
     curl_setopt ($ch, CURLOPT_POST, 1);
     curl_setopt($ch, CURLOPT_POSTFIELDS, $text);
     curl_setopt($ch, CURLOPT_TIMEOUT, 30); //timeout in seconds
     $result = curl_exec($ch);

     curl_close ($ch);
     if( $result && !empty( $result ) )
     	return $result;
	// var_dump($result);
	// $res = base64_decode( $result );
	// var_dump($res);
	/*if( isset( $res->status ) && $res->status == 'Success' )
		return $res->text;*/
	return $text;
}

function wpvmachine_tbs_curl_post($url, $data, &$info){

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_POST, true);
  curl_setopt($ch, CURLOPT_POSTFIELDS, curl_postData($data));
  curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_REFERER, $url);
  $html = trim(curl_exec($ch));
  curl_close($ch);

  return $html;
}

function wpvmachine_tbs_curl_postData($data){

  $fdata = "";
  foreach($data as $key => $val){
    $fdata .= "$key=" . urlencode($val) . "&";
  }

  return $fdata;

}

function wpvmachine_spin_text_tbs( $text ) {

	$tbs_settings = wpvmachine_get_settings( array( 'spinners', 'tbs' ) );

	// var_dump($settings);
	if ( ! isset( $tbs_settings['username'] ) || empty( $tbs_settings['username'] ) || ! isset( $tbs_settings['password'] ) || empty( $tbs_settings['password'] ) )
		return $text;

	if( empty( $email_address ) || empty( $api_key ) )
		return $text;

	$url = 'http://thebestspinner.com/api.php';

	#$testmethod = 'identifySynonyms';
	$testmethod = 'replaceEveryonesFavorites';


	# Build the data array for authenticating.

	$data = array();
	$data['action'] = 'authenticate';
	$data['format'] = 'php'; # You can also specify 'xml' as the format.

	# The user credentials should change for each UAW user with a TBS account.

	$data['username'] = $tbs_settings['username'];
	$data['password'] = $tbs_settings['password'];

	# Authenticate and get back the session id.
	# You only need to authenticate once per session.
	# A session is good for 24 hours.
	$output = unserialize(wpvmachine_tbs_curl_post($url, $data, $info));

	if($output['success']=='true'){
	  # Success.
	  $session = $output['session'];

	  # Build the data array for the example.
	  $data = array();
	  $data['session'] = $session;
	  $data['format'] = 'php'; # You can also specify 'xml' as the format.
	  $data['text'] = $text;
	  $data['action'] = /*$testmethod*/'rewriteText';
	  $data['maxsyns'] = '3'; # The number of synonyms per term.

	  /*if($testmethod=='replaceEveryonesFavorites'){
	    # Add a quality score for this method.
	    $data['quality'] = '1';
	  }*/

	  # Post to API and get back results.
	  $output = wpvmachine_tbs_curl_post($url, $data, $info);
	  $output = unserialize($output);
	  if($output['success']=='true')
	  	return $output['output'];
  		return $text;
	}
	else{
	  # There were errors.
		return $text;
	}
}

function wpvmachine_get_spinners() {
  return array(
    array( 'value' => '0', 'label' => 'Spin Rewriter' ),
    array( 'value' => '1', 'label' => 'The Best Spinner' ),
    array( 'value' => '2', 'label' => 'WordAI' ),
    array( 'value' => '3', 'label' => 'Spinner Chief' )
  );
}
?>