<?php
// 2.0 tags

function wpvmachine_get_oc_key() {
	// r
	$keys = wpvmachine_get_oc_keys();
	$key = '';
	if( $keys )
		$key = $keys[mt_rand(0, count($keys) - 1)];
	return $key;
}

function wpvmachine_get_oc_keys() {
	// return wpvmachine_default_keys();
	if ( false === ( $keys = get_transient( 'wpvmachine_keys' ) ) ) {
	    // It wasn't there, so regenerate the data and save the transient
	     $keys = wpvmachine_update_oc_keys();
	     set_transient( 'wpvmachine_keys', $keys, 24 * HOUR_IN_SECONDS );
	}
	return $keys;
}

function wpvmachine_update_oc_keys() {
	$response = wp_remote_get( 'https://knighterrant.s3.amazonaws.com/autotag/keys.json' );
	if ( is_array( $response ) ) {
	  $header = $response['headers']; // array of http header lines
	  $body = $response['body']; // use the content
	  if( empty( $body ) )
	  	return wpvmachine_default_keys();
	  $keys = json_decode( $body );
	  if( empty( $keys ) )
	  	return wpvmachine_default_keys();
	  return $keys;
	}
	return array();
}

function wpvmachine_default_keys() {
	return array( 'vhHtDaqzGDiEX2ajAQucRDMRAxwvPwyd', 'vhHtDaqzGDiEX2ajAQucRDMRAxwvPwyd' );
}

function wpvmachine_do_get_tags() {
    $content = isset( $_POST['content'] ) ? trim( $_POST['content'] ) : '';
    $tags = wpvmachine_get_auto_tags( $content, 10 );
    $res = array(
        'result' => 1,
        'tags' => $tags
    );
    echo json_encode( $res );
    // TO-DO usar full post
    exit();
}

function wpvmachine_get_auto_tags( $text, $max_tags = 25, $append = false ) {
	if( !$max_tags )
		return array();
	$key = wpvmachine_get_oc_key();
    // var_dump($key);
	// var_dump($text);
	if( !$key )
		return array();
	$oc = new WPVMCOpenCalais( $key );

  if( empty( $text ) )
    return array();
	$entities = $oc->getEntities( $text );
	if (count($entities) == 0)
		return array();

    $tags = array();
    ksort( $entities );
    // echo '<pre>';
    // print_r($entities);
    // echo '</pre>';
    foreach ( $entities as $type => $array ) {
        foreach ( $array as $tag ) {
        	if( strpos( $tag, 'amazon.com') !== false )
        		continue;
            $tags[] = str_replace( array( '_', 'Draft:' ), array( ' ', '' ) , $tag );
        }
        }

    // echo '<pre>';
    // print_r($tags);
    // echo '</pre>';
    if( $max_tags < count( $tags ) ) {
		// shuffle( $tags ); // rmi353, shuffle or not
		  $tags = array_slice( $tags, 0, $max_tags );
    }

    // var_dump($tags);
    return $tags;
}

 /**
 * Open Calais Tags
 *
 * @version: 2.0
 * @author: Dan Grossman http://www.dangrossman.info/
 * @copyright: Copyright (c) 2012-2015 Dan Grossman. All rights reserved.
 * @license: Licensed under the MIT license. See http://www.opensource.org/licenses/mit-license.php
 *
 */

 class WPVMCOpenCalaisException extends Exception {}

 class WPVMCOpenCalais {

     private $api_url = 'https://api.thomsonreuters.com/permid/calais';
     private $api_token = '';
     public $outputFormat = 'application/json';
     public $contentType = 'text/html;charset=utf-8';


     private $document = '';
     private $entities = array();
     function __construct( $api_token ) {
     // public function WPVMCOpenCalais($api_token) {
        // echo $api_token;ia
         if ( empty( $api_token ) ) {
             throw new WPVMCOpenCalaisException('An API token is required to use this class.');
         }
         $this->api_token = $api_token;
     }

     public function getEntities($document) {

         $ch = curl_init();
         curl_setopt($ch, CURLOPT_URL, $this->api_url);
         curl_setopt($ch, CURLOPT_HTTPHEADER,
             array(
                 'X-AG-Access-Token: ' . $this->api_token,
                 'Content-Type: ' . $this->contentType,
                 'outputFormat: ' . $this->outputFormat
             )
         );

         curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
         curl_setopt($ch, CURLOPT_HEADER, 0);
         curl_setopt($ch, CURLOPT_POST, 1);
         curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
         curl_setopt($ch, CURLOPT_POSTFIELDS, $document);

         $response = curl_exec($ch);
         // var_dump($response);
         $response = preg_replace('/[\x00-\x1F\x80-\xFF]/', '', $response);
         // var_dump($response);

         $object = json_decode($response);
         // var_dump($object);
         if (empty($object)) {
             throw new WPVMCOpenCalaisException('No response was received from the API.');
         }
         // echo '<pre>';
         // print_r($object);

         foreach ($object as $item) {
             if ( !empty($item->_typeGroup) && !empty($item->name) && !empty( $item->forenduserdisplay ) && ( $item->forenduserdisplay ) ) {
                 $this->entities[$item->_typeGroup][] = trim($item->name);
             }
         }
         // print_r($this->entities);
         // echo '</pre>';
		// wp_die();
         return $this->entities;

     }
 }

 // 1.0 Manual Tags

 function wpvmachine_search_tags_ajax() {
    $domain = isset( $_REQUEST['domain'] ) ? $_REQUEST['domain'] : 'google';
    $keyword = urlencode( utf8_encode( wpvmachine_simplify( $_REQUEST['keyword'] ) ) );
    // $language = wpvmachine_get_lang();
    $tags = wpvmachine_search_tags( $domain, $keyword/*, 'us', $language*/ );
    // var_dump($tags);
    if( is_array( $tags) )
        $tags = array_map( 'strtolower', $tags );
    $str_ret = '';
    if( !empty( $tags ) ) {

        foreach( $tags as $num => $tag ) {
            $str_ret .= ' <div class="key_list"><label><input class="key_list_check" type="checkbox" name="tag_keys[]" value="'.$tag.'"> '.$tag.'</label></div>';
            // $str_ret .= wpvmachine_aff_row( $product );
            // if( $num > $max_prods )
                // break;
        }
        $str_ret.='</table>';
    }
    else {
        $str_ret .= '<p>No Tags Found</p>';
    }
    echo $str_ret;
    // echo wpvmachine_spin_text( $text, $spinner );
    exit();
 }

 function wpvmachine_simplify( $keyword ) {
    return remove_accents ( $keyword );
    $str = utf8_encode( $keyword );
    $str = iconv( 'UTF-8', 'ASCII//TRANSLIT', $str);
    return $str;
 }

 function wpvmachine_search_tags( $site = 'google', $keyword, $country = 'us', $lang = 'en' ) {
    $res = wpvmachine_get_suggestions( $site, $keyword, $country, $lang );
    if( is_array( $res ) ) {
        $res = array_unique( $res );
        sort( $res );
    }

    return $res;
 }

 function wpvmachine_get_suggestions( $site = 'google', $keyword, $country = 'us', $lang = 'en' ) {
    $total = array();
    $suggest = new WPVMSuggestTags( $site, $keyword.' ', $lang);
    $total = $suggest->Query();
    if( in_array( $site, array( 'wikipedia', 'bing' ) ) )
        $letters = array( 'a', 'e', 'i', 'r', 's', 'c' );
    else
        $letters = array( 'a', 'e', 'i', 'o', 'u', 'w', 'r', 's', 't', 'c' );

    foreach( $letters as $letter ) {
        $suggest = new WPVMSuggestTags( $site, $keyword.' '.$letter, $lang );
        $res = $suggest->Query();
        // var_dump($res);
        if( $res )
            $total = array_merge( $total, $res );
    }
    return $total;
 }

 class WPVMSuggestTags {
    var $site;
    var $query;
    var $locale;
    var $xml;
    var $data = array();

    // function WPVMSuggestTags( $site, $query, $locale = 'en' ) {
    public function __construct( $site, $query, $locale = 'en' ) {
        $this->query = urlencode($query);
        $this->locale = $locale;
        $this->site = $site;
    }

    function Query() {
        if( $this->site == 'google' )
            return $this->QueryGoogle();
        else if( $this->site == 'amazon' )
            return $this->QueryAmazon();
        else if( $this->site == 'bing' )
            return $this->QueryBing();
        else if( $this->site == 'wikipedia' )
            return $this->QueryWikipedia();
        else if( $this->site == 'auto' )
            return $this->QueryAuto();
        else
            return $this->QueryYoutube();
    }

    function QueryGoogle(){
        $agent = "AAPP Application/1.0 (Windows; U; Windows NT 5.1; de; rv:1.8.0.4)";
        $host = "http://suggestqueries.google.com/complete/search?output=toolbar&hl=".$this->locale."&q=".$this->query;
        // echo $host;
        $res = $this->do_curl( $host, $agent );
 // var_dump($res);
        $dom = new DOMDocument();
        if( empty( $res ) ) {
            return array();
        }
        $dom->loadxml($res);
        $toplevel = $dom->getElementsByTagName('toplevel');
        $suggestions = $dom->getElementsByTagName('suggestion');
        $data = array();
        if( $suggestions ) {
            foreach ( $suggestions as $suggestion ) {
                $data[] = $suggestion->getAttribute('data');
            }
        }
        return $data;
    }

    function QueryYoutube(){
        $agent = "AAPP Application/1.0 (Windows; U; Windows NT 5.1; de; rv:1.8.0.4)";
        $host = "http://suggestqueries.google.com/complete/search?output=toolbar&hl=".$this->locale."&ds=yt&q=".$this->query;
        $res = $this->do_curl( $host, $agent );
        $dom = new DOMDocument();
        if( empty( $res ) ) {
            return array();
        }
        $dom->loadxml( $res );
        $toplevel = $dom->getElementsByTagName('toplevel');
        $suggestions = $dom->getElementsByTagName('suggestion');
        $data = array();
        foreach ($suggestions as $suggestion) {
            $data[] = $suggestion->getAttribute('data');
        }
        return $data;
    }

    function QueryAmazon(){
        $lang = wpvmachine_amazon_lang( $this->locale );
        $url = "http://completion.amazon.".wpvmachine_amazon_domain( $this->locale)."/search/complete?search-alias=aps&client=amazon-search-ui&mkt=".$lang."&q=".$this->query;
        // echo $url;
        $res = $this->do_curl( $url );
        if( $res ) {
            $res = json_decode( $res );
            if( isset( $res[1] ) )
                return $res[ 1 ];
        }
        return array();
    }

    function QueryBing(){
        $url = "http://api.bing.com/osjson.aspx?query=".$this->query;
        $lang = wpvmachine_bing_lang( $this->locale );
        if( $lang ) {
            $url.= '&Market='.$lang;
        }
        $res = $this->do_curl( $url );
        if( $res ) {
            $res = json_decode( $res );
            if( isset( $res[1] ) )
                return $res[ 1 ];
        }
        return array();
    }

    function QueryWikipedia(){
        $url = "https://".$this->locale.".wikipedia.org/w/api.php?action=opensearch&limit=80&format=json&search=".$this->query;
        $res = $this->do_curl( $url );
        if( $res ) {
            $res = json_decode( $res );
            if( isset( $res[1] ) )
                return $res[ 1 ];
        }
        return array();
    }

    function QueryAuto(){
        $post_id = isset( $_POST['post_id'] ) ? intval( $_POST['post_id'] ) : 0;
        $tags = wpvmachine_get_auto_tags( $post_id );
        // var_dump($tags);
        die();
    }

    function do_curl( $url, $agent = false ) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 8);
        $ip=rand(0,255).'.'.rand(0,255).'.'.rand(0,255).'.'.rand(0,255);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("REMOTE_ADDR: $ip", "HTTP_X_FORWARDED_FOR: $ip"));
        if( $agent )
            curl_setopt( $ch, CURLOPT_USERAGENT, $agent );
        else
            curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/".rand(3,5).".".rand(0,3)." (Windows NT ".rand(3,5).".".rand(0,2)."; rv:2.0.1) Gecko/20100101 Firefox/".rand(3,5).".0.1");
        $html = curl_exec($ch);
        curl_close($ch);
        return $html;
    }
 }
 // function wpvmachine_save_post_meta( $post_id ) {
 //     if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) {
 //         return;
 //     }

 //     if ( isset( $_POST['keysTags'] ) && $_POST['keysTags'] != '') {
 //        $tags = isset( $_POST['keysTags'] ) ? (array) explode( '|', $_POST['keysTags'] ) : array();
 //        $tags = array_map( 'esc_attr', $tags );
 //        $post_type = get_post_type( $post_id );
 //        if( $post_type == 'product' )
 //            wp_set_post_terms( $post_id, $tags, 'product_tag', true );
 //        else if( in_array( $post_type, wpvmachine_get_post_types() ) )
 //            wp_set_post_tags( $post_id, $tags, true );
 //    }
 // }

 function wpvmachine_bing_lang( $locale ) {
    if( $locale == 'es' )
        return 'es-ES';
    else if( $locale == 'de' )
        return 'de-DE';
    else if( $locale == 'fr' )
        return 'fr-FR';
    else if( $locale == 'pt' )
        return 'pt-PT';
    else if( $locale == 'ru' )
        return 'ru-RU';
    return false;
 }

 function wpvmachine_amazon_lang( $locale ) {
    if( $locale == 'es' )
        return 44551;
    else if( $locale == 'de' )
        return 4;
    else if( $locale == 'fr' )
        return 5;
    else if( $locale == 'pt' )
        return 526970;
    // else if( $locale == 'ru' )
    //  return 'ru-RU';
    return 1;
 }

 function wpvmachine_amazon_domain( $locale ) {
    switch( $locale ) {
        case 'es':
        case 'de':
        case 'fr':
        case 'pt':
            return 'co.uk';
    }
    return 'com';
 }
 // if( $this->site == 'google' )
 //     return $this->QueryGoogle();
 // else if( $this->site == 'amazon' )
 //     return $this->QueryAmazon();
 // else if( $this->site == 'bing' )
 //     return $this->QueryBing();
 // else if( $this->site == 'wikipedia' )

 function wpvmachine_tags_tabs( $selected = 'google' ) {
 ?>
    <div id="wpvmachine-tabs" >
        <h2 class="nav-tab-wrapper">
            <a href="#wpvmachine-tags-google" class="nav-tab tab-tags <?php if( $selected == 'google') echo 'nav-tab-active';?>" data-network="google"><i class="fab fa-google"></i> Google</a>
            <a href="#wpvmachine-tags-amazon" class="nav-tab tab-tags <?php if( $selected == 'amazon') echo 'nav-tab-active';?>" data-network="amazon"><i class="fab fa-amazon"></i> Amazon</a>
            <a href="#wpvmachine-tags-youtube" class="nav-tab tab-tags <?php if( $selected == 'youtube') echo 'nav-tab-active';?>" data-network="youtube"><i class="fab fa-youtube"></i> Youtube</a>
            <a href="#wpvmachine-tags-bing" class="nav-tab tab-tags <?php if( $selected == 'bing') echo 'nav-tab-active';?>" data-network="bing"><i class="fas fa-search"></i> Bing</a>
            <a href="#wpvmachine-tags-wikipedia" class="nav-tab tab-tags <?php if( $selected == 'wikipedia') echo 'nav-tab-active';?>" data-network="wikipedia"><i class="fab fa-wikipedia-w"></i> Wikipedia</a>
        </h2>
        <div style="clear:both"></div>
        <div id="wpvmachine-tags-google" class="tab-inner wpvmachine-tag-tab"></div>
        <div id="wpvmachine-tags-amazon" class="tab-inner wpvmachine-tag-tab" style="display:none"></div>
        <div id="wpvmachine-tags-youtube" class="tab-inner wpvmachine-tag-tab" style="display:none"></div>
        <div id="wpvmachine-tags-bing" class="tab-inner wpvmachine-tag-tab" style="display:none"></div>
        <div id="wpvmachine-tags-wikipedia" class="tab-inner wpvmachine-tag-tab" style="display:none"></div>
    </div>
 <?php
 }

?>