<?php
function wpvmachine_traffic_buffer( $url, $title ) {
	$res = wpvmachine_share_buffer( $title, '', $url );
	if( $res )
		wpvmachine_log_traffic( $post_id, WPVMACHINE_TRAFFIC_BUFFER );
}

function wpvmachine_share_buffer( $title, $text, $post_url, $image_url = false ) {
	require_once WPVMACHINE_DIR.'/lib/libs/buffer/buffer.php';
	$buffer_settings = wpvmachine_get_settings( array( 'social', 'buffer' ) );
	// var_dump($buffer_settings);
	if ( ! isset( $buffer_settings['client_id'] ) || empty( $buffer_settings['client_id'] ) || ! isset( $buffer_settings['client_secret'] ) || empty( $buffer_settings['client_secret'] ) || ! isset( $buffer_settings['token'] ) || empty( $buffer_settings['token'] ) ) {
		wpvmachine_debug( 'Error with Buffer Credentials', 'error' );
		return false;
	}

	$buffer = new WVMBufferApp( $buffer_settings['client_id'], $buffer_settings['client_secret'], admin_url('/admin.php?page=wp-video-machine-settings&buffer_auth=true'), $buffer_settings['token'] );

	$profiles = $buffer->go('/profiles');
	if ( is_array($profiles ) ) {
	    foreach ($profiles as $profile) {
	        //this creates a status on each one
	        $update_post = array(
	            'text' => wpvmachine_before_upload( $title ).' '.$post_url,
	            'profile_ids[]' => $profile->id,
	            'shorten'=>true,
	            'now'=>true,
	            'top'=>true
	        );

	        if( $image_url ) {
	        	$update_post['media[picture]'] = $image_url;
	        	$update_post['media[thumbnail]'] = $image_url;
	        	$update_post['media[title]'] = $title;
	        	$update_post['media[link]'] = $post_url;
	        }
	        $buffer->go('/updates/create', $update_post );
	    }
	    return true;
    }
	wpvmachine_debug( 'Error Sharing on Buffer', 'error' );
	return false;
}

add_action( 'init', 'wpvmachine_try_buffer_auth' );

function wpvmachine_try_buffer_auth() {
    require_once WPVMACHINE_DIR.'/lib/libs/buffer/buffer.php';
    $buffer_settings = wpvmachine_get_settings( array( 'social', 'buffer' ) );
    // var_dump($buffer_settings);
    if ( ! isset( $buffer_settings['client_id'] ) || empty( $buffer_settings['client_id'] ) || ! isset( $buffer_settings['client_secret'] ) || empty( $buffer_settings['client_secret'] ) )
        return false;

	if( isset( $_GET['buffer_auth'] ) ) {
        $buffer = new WVMBufferApp( $buffer_settings['client_id'], $buffer_settings['client_secret'], admin_url('/admin.php?page=wp-video-machine-settings&buffer_auth=true') );
        if ( !$buffer->ok ) {
            echo 'Error with Buffer Login.';
        } else {
            $settings = wpvmachine_get_plugin_settings();
            // $buffer_settings = wpvmachine_get_settings( array( 'social', 'buffer' ) );
            $token = $buffer->get_access_token();
            $settings['social']['buffer']['token'] = $token;
            wpvmachine_save_plugin_settings( $settings );
        }
    }
}
?>