<?php
function wpvmachine_traffic_medium( $url, $title ) {
	$res = wpvmachine_share_medium( $title, '', $url );
	if( $res )
		wpvmachine_log_traffic( $post_id, WPVMACHINE_TRAFFIC_MEDIUM );
}

// TO-DO tags, imagen
function wpvmachine_share_medium( $title, $text, $post_url, $image_url = false ) {
	require_once WPVMACHINE_DIR.'/lib/libs/medium/MediumClient.php';
	require_once WPVMACHINE_DIR.'/lib/libs/medium/Medium.php';
	$medium_settings = wpvmachine_get_settings( array( 'social', 'medium' ) );

	if ( ! isset( $medium_settings['token'] ) || empty( $medium_settings['token'] ) ) {
		wpvmachine_debug( 'Error with Medium Credentials', 'error' );
		return false;
	}
	$medium = new Medium( $medium_settings['token'] );

	$user = $medium->getAuthenticatedUser();

    $data = array(
        'title' => $title,
        'contentFormat' => 'html',
        'content' => $text.'<br/>Read more at: <a href="'.$post_url.'">'.$post_url.'</a>',
        'publishStatus' => 'public',
        'canonicalUrl' => $post_url,
        'notifyFollowers' => true
    );

    $post = false;
    if( $medium && $user)
    	$post = $medium->createPost( $user->id, $data );
    if( $post )
    	return true;
    return false;
}
?>