<?php
// require_once WPVMACHINE_DIR.'/lib/libs/pinterest/nxs-api/nxs-api.php';
// require_once WPVMACHINE_DIR.'/lib/libs/pinterest/nxs-api/nxs-http.php';
// require_once WPVMACHINE_DIR.'/lib/libs/pinterest/inc/nxs-functions.php';

function wpvmachine_traffic_pinterest( $post_id, $traffic, $settings ) {
	$board_id = $settings->board;
	if( !$board_id ) {
		wpvmachine_debug( 'Error with Pinterest: no Bord Selected', 'error' );
		return false;
	}
	$res = wpvmachine_share_pinterest( $board_id, wpvmachine_get_the_excerpt( $post_id ), get_permalink( $post_id ), wpvmachine_get_thumbnail( $post_id ) );
	if( $res )
		wpvmachine_log_traffic( $post_id, WPVMACHINE_TRAFFIC_PINTEREST );
}

function wpvmachine_share_pinterest( $board_id, $text, $post_url, $image_url = false ) {

	$pinterest_settings = wpvmachine_get_settings( array( 'social', 'pinterest' ) );

	if ( ! isset( $pinterest_settings['email'] ) || empty( $pinterest_settings['email'] ) || ! isset( $pinterest_settings['pass'] ) || empty( $pinterest_settings['pass'] ) ) {
		wpvmachine_debug( 'Error with Pinterest Credentials', 'error' );
		return false;
	}
	wpvmachine_include_nextgen();

	// var_dump($pinterest_settings);
	$email = $pinterest_settings['email'];
	$password = $pinterest_settings['pass'];

	$nxs_gCookiesArr = wpvmachine_get_saved_pinterest_login();

	$nt         = new nxsAPI_PN();
	$nt->ck     = $nxs_gCookiesArr;
	$loginError = $nt->connect($email, $password);

	if ( !$loginError ) {
	  wpvmachine_save_pinterest_login($nt->ck);
	  $return = $nt->post($text, $image_url, $post_url, $board_id );
	  if( $return ) {
		wpvmachine_debug( 'Shared on Pinterest', 'notice' );
		return true;
		}
	}
	else
		wpvmachine_debug( 'Error connecting with Pinterest', 'error' );
	return false;
}

function wpvmachine_get_pinterest_boards( $for_select = false ) {
	// require_once WPVMACHINE_DIR.'/lib/libs/pinterest/PinnerException.php';
	// require_once WPVMACHINE_DIR.'/lib/libs/pinterest/Pinner.php';
	if ( false === ( $boards = get_transient( 'wpvmachine_pinterest_boards' ) ) ) {
	$pinterest_settings = wpvmachine_get_settings( array( 'social', 'pinterest' ) );

	// var_dump($settings);
	if ( ! isset( $pinterest_settings['email'] ) || empty( $pinterest_settings['email'] ) || ! isset( $pinterest_settings['pass'] ) || empty( $pinterest_settings['pass'] ) )
		return false;
// function wpvmachine_GetPinterestBoard( $email, $password ) {

	$email = $pinterest_settings['email'];
	$password = $pinterest_settings['pass'];
	  $nxs_gCookiesArr = wpvmachine_get_saved_pinterest_login();

	  $nt         = new nxsAPI_PN();
	  $nt->ck     = $nxs_gCookiesArr;
	  $loginError = $nt->connect($email, $password);

	  if (!$loginError) {
	    wpvmachine_save_pinterest_login($nt->ck);
	    $boards = wpvmachine_ParseBoards( $nt->getBoards(), $for_select );
	    set_transient( 'wpvmachine_pinterest_boards', $boards, 12 * HOUR_IN_SECONDS );
	    return $boards;
	  }
	  else {
	    return $loginError;
	  }
	}
	return $boards;
}

function wpvmachine_get_saved_pinterest_login() {
  $pnTempLogin = get_option( 'wpvmachine_pint_temp_login' );
  // $pnTempLogin = get_post_meta('111111113', 'wpvmachine_pint_temp_login', true);
  if (empty($pnTempLogin)) return null;
  return unserialize($pnTempLogin);
}

function wpvmachine_save_pinterest_login($obj) {
	update_option( 'wpvmachine_pint_temp_login', serialize($obj) );
  // update_post_meta('111111113', 'wpvmachine_pint_temp_login', serialize($obj));
}

function wpvmachine_ParseBoards( $str, $for_select ) {
  $matches = array();
  preg_match_all("/<option[^>]*value=\"(\d+)\">([^<]*)<\/option>/", $str, $matches);

  $out = array();

  if (!empty($matches)) {
    foreach($matches[1] as $key => $val) {
    	if( $for_select )
    		$out[] = array( 'value' => $val, 'label' => $matches[2][$key]);
    	else
      		$out[$val] = $matches[2][$key];
    }
  }

  return $out;
}

?>