<?php

include WPVMACHINE_DIR.'lib/traffic/backlinkmachine.php';
include WPVMACHINE_DIR.'lib/traffic/linkindexers.php';
include WPVMACHINE_DIR.'lib/traffic/twitter.php';
include WPVMACHINE_DIR.'lib/traffic/facebook.php';
// include WPVMACHINE_DIR.'lib/traffic/pinterest.php';
// include WPVMACHINE_DIR.'lib/traffic/instagram.php';
// include WPVMACHINE_DIR.'lib/traffic/googleplus.php';
// include WPVMACHINE_DIR.'lib/traffic/reddit.php';
// include WPVMACHINE_DIR.'lib/traffic/stumbleupon.php';
include WPVMACHINE_DIR.'lib/traffic/medium.php';
include WPVMACHINE_DIR.'lib/traffic/tumblr.php';
include WPVMACHINE_DIR.'lib/traffic/linkedin.php';
include WPVMACHINE_DIR.'lib/traffic/buffer.php';


add_action( 'wpvmachine_insert_post' , 'wpvmachine_new_post', 10 , 2 );
function wpvmachine_new_post( $post_id , $campaign_id )
{
	if ( !wpvmachine_is_traffic() )
		return;

	if( get_post_type( $post_id ) != 'post' )
		return;

	if ( wp_is_post_revision( $post_id ) )
		return;

	// if ( $post->post_date == $post->post_modified )
	// {

	$campaign_id = get_post_meta( $post_id, '_wpac_cid', true );
	if( !$campaign_id )
		return;
	// New post, get traffic!

	$traffics = wpvmachine_get_traffic_elements( $campaign_id );
	if( !$traffics )
		return $post_id;
	$i = 0;
// $settings = json_decode( $content->settings );

	foreach( $traffics as $traffic ) {
		if( !isset( $traffic->settings ) )
			continue;
		$settings = wpvmachine_json_decode_nice( $traffic->settings );
		switch ( $traffic->type ) {
			case WPVMACHINE_TRAFFIC_BACKLINKMACHINE:
				$done = wpvmachine_traffic_backlinkmachine( $post_id, $traffic, $settings );
				break;
			case WPVMACHINE_TRAFFIC_ILI:
				$done = wpvmachine_traffic_ili( $post_id, $traffic, $settings );
				break;
			case WPVMACHINE_TRAFFIC_BLI:
				$done = wpvmachine_traffic_bli( $post_id, $traffic, $settings );
				break;
			case WPVMACHINE_TRAFFIC_TWITTER:
				$done = wpvmachine_traffic_twitter( $post_id, $traffic, $settings );
				break;
			case WPVMACHINE_TRAFFIC_FACEBOOK:
				$done = wpvmachine_traffic_facebook( $post_id, $traffic, $settings );
				break;
			case WPVMACHINE_TRAFFIC_PINTEREST:
				$done = wpvmachine_traffic_pinterest( $post_id, $traffic, $settings );
				break;
			case WPVMACHINE_TRAFFIC_STUMBLEUPON:
				$done = wpvmachine_traffic_stumbleupon( $post_id, $traffic, $settings );
				break;
			case WPVMACHINE_TRAFFIC_MEDIUM:
				$done = wpvmachine_traffic_medium( $post_id, $traffic, $settings );
				break;
			case WPVMACHINE_TRAFFIC_TUMBLR:
				$done = wpvmachine_traffic_tumblr( $post_id, $traffic, $settings );
				break;
			case WPVMACHINE_TRAFFIC_LINKEDIN:
				$done = wpvmachine_traffic_linkedin( $post_id, $traffic, $settings );
				break;
			case WPVMACHINE_TRAFFIC_BUFFER:
				$done = wpvmachine_traffic_buffer( $post_id, $traffic, $settings );
				break;
			case WPVMACHINE_TRAFFIC_REDDIT:
				$done = wpvmachine_traffic_reddit( $post_id, $traffic, $settings );
				break;
			case WPVMACHINE_TRAFFIC_INSTAGRAM:
				$done = wpvmachine_traffic_instagram( $post_id, $traffic, $settings );
				break;
			case WPVMACHINE_TRAFFIC_GOOGLEPLUS:
				$done = wpvmachine_traffic_googleplus( $post_id, $traffic, $settings );
				break;
			default:
				break;
		}
	}
	// }
	return;
}

function wpvmachine_log_traffic( $post_id, $type ) {
	add_post_meta( $post_id, 'wpac_traf', $type, false );
}

function wpvmachine_get_traffic( $post_id ) {
	return get_post_meta( $post_id, 'wpac_traf', false );
}
?>