<?php
define( 'WPVMACHINE_TRENDS_URL', 'https://trends.google.com/trends/api/dailytrends' );
function wpvmachine_search_trends_ajax() {
	$language = isset( $_POST['lang'] ) ? trim( $_POST['lang'] ) : 'en-US';
	$geo = isset( $_POST['geo'] ) ? trim( $_POST['geo'] ) : 'US';
	$trends = wpvmachine_trends( $language, $geo );
	if( !empty( $trends ) ) {
		wpvmachine_print_trends( $trends );
	}
	// var_dump($trends);
	// echo "hola";
	exit();
}

function wpvmachine_trends( $lang = 'en-US', $geo = 'US' ) {
	$url = WPVMACHINE_TRENDS_URL.'?hl='.$lang.'&tz=360&geo='.$geo.'&ns=15';
	// https://trends.google.com/trends/api/dailytrends?hl=en-US&tz=360&geo=US&ns=15
	// echo $url;return;
	$res = wp_remote_get( $url );
	// var_dump($res);return;
	if ( is_wp_error( $res ) ) {
		echo "Error, please try again";
		return array();
	}
	else {

	}
	$body = $res['body'];
	$body = substr( $body, 5 );
	$resp = json_decode( $body );
	// var_dump($resp);
	 $day0 = $resp->default->trendingSearchesDays[0];
	 $values = $day0->trendingSearches;
	 if( isset( $resp->default->trendingSearchesDays[1] ) ) {
	 	$day1 = $resp->default->trendingSearchesDays[1];
	 	$values = array_merge( $values, $day1->trendingSearches );
	 }

	// $values = $resp->default;
	 $ret = array();
	 // var_dump($values);
	foreach( $values as $num => $value ) {
		$result = array();
		$result['topic'] = $value->title->query;
		$result['image'] = $value->image->imageUrl;
		$arts = $value->articles;
		$articles = array();
		if( $arts ) {
			foreach( $arts as $art ) {
				$arr = array();
				$arr['title'] = $art->title;
				$arr['image'] = $art->image->imageUrl;
				$arr['content'] = $art->snippet;
				$articles[] = $arr;
			}
		}
		$result['articles'] = $articles;
		// if( !$num ) {
		// 	echo '<pre>';
		// 	print_r($value);
		// 	echo '</pre>';
		// }
		$ret[] = $result;
	}
	return $ret ;
}

function wpvmachine_print_trends( $trends ) {
	$str = '<table class="wp-list-table widefat fixed striped aff-table">';
	// var_dump($trends);
	foreach( $trends as $trend ) {
		$str .= '<tr><th scope="row"><img src="'.$trend['image'].'" class="wpvm-prod-img" /></th><th scope="row" ><span class="ttopic">'.$trend['topic'].'</span><div class="trend-contents" style="display:none">'.wpvmachine_trend_contents( $trend['articles'] ).'</div></th><td><button type="button" class="button button-secondary btn-create-video-trend"><i class="fas fa-video"></i> Create Video</button></td></tr>';
	}
	$str .= '</table>';
	echo $str;
}

function wpvmachine_trend_contents( $articles ) {
	$str = '';
	foreach( $articles as $num => $article ) {
		$str .= '<div class="wpvm-article-c"><input type="hidden" class="article_topic" value="'.$article['title'].'" />';
		$str .= '<input type="hidden" class="article_image" value="'.$article['image'].'" />';
		$str .= '<input type="hidden" class="article_content" value="'.$article['content'].'" /></div>';
	}
	return $str;
}
?>