<?php

	function wpvmachine_screen_log() {
		if (! current_user_can ( 'manage_options' ))
			wp_die ( 'You don\'t have access to this page.' );
		if (! user_can_access_admin_page ())
			wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-backlinks-machine' ) );
			$page = isset( $_GET['pagenum'] ) ? intval( $_GET['pagenum'] ) : 1;
			$per_page = 40;
		?>
			<div class="wrap">
			<?php wpvmachine_header(); ?>
			<h2>Videos <small>- <a href="https://wpvideomachine.com/support/knowledgebase/how-to-get-started/" target="_blank">Tutorial: How to get started</a></small> - <small> <a href="https://wpvideomachine.com/support/knowledgebase/what-do-do-if-you-are-getting-errors-when-creating-a-video/" target="_blank">Check this if you are getting errors</a></small><a class="button button-primary" href="<?php echo admin_url( 'admin.php?page=wp-video-machine-log');?>" style="float:right;margin: 0 10px"><i class="far fa-file-alt"></i> New Video from Post</a>
      <a class="button button-primary" href="<?php echo admin_url( 'admin.php?page=wp-video-machine-newvid');?>" style="float:right;margin: 0 10px"><i class="far fa-plus-square"></i> New Video from Scratch</a></h2>
			<br/>
			<?php wpvmachine_print_log( $page, $per_page ); ?>
			</div>
			<div id="avmshare-modal" class="bmmodal" style="display:none">
				<h3>Share Youtube video on: </h3>
				<div style="padding-left:18px;">
				<?php wpvmachine_share_list(); ?>
				</div>
				<br/>
				<button type="button" class="button button-primary" id="btn-do-share-video"><i class="fas fa-share"></i> Share</button>
			</div>

			<div id="avmsyndicate-modal" class="bmmodal" style="display:none">
				<h3>Syndicate Youtube video on: </h3>
				<div style="padding-left:18px;">
				<?php wpvmachine_syndicate_list(); ?>
				</div>
				<br/>
				<button type="button" class="button button-primary" id="btn-do-syndicate-video"><i class="fas fa-retweet"></i> Syndicate Video</button>
			</div>
			<div id="avmsyndicate-success-modal" class="bmmodal" style="display:none">
				<h3><i class="fas fa-check"></i> Success! A campaign to syndicate your video accross your selected networks has been submitted. </h3>
				  <button type="button" class="button button-primary btn-close-vmmodal"><i class="fas fa-times"></i> Close</button>
			</div>

			<div id="avmcreatepost-modal" class="bmmodal" style="display:none">
				<h3>Create new post with Youtube Video: </h3>
				<div style="padding-left:18px;">
					<label for="newpost_name">Post Name</label><br/>
			      <input type="text" name="newpost_name" value="" id="newpost_name" style="width: 90%">
				</div>
				<br/>
				<button type="button" class="button button-primary" id="btn-do-create-video-post"><i class="fas fa-thumbtack"></i> Create post</button>
				  <button type="button" class="button button-secondary btn-close-vmmodal"><i class="fas fa-times"></i> Cancel</button>
			</div>
			<div id="avmcreatepost-success-modal" class="bmmodal" style="display:none">
				<h3><i class="fas fa-check"></i> Success! The post has been created. </h3>
				  <a class="button button-primary" href="#" id="btn-edit-new-post" target="_blank"><i class="fas fa-edit"></i> Edit</a>
				  <a class="button button-primary" href="#" id="btn-view-new-post" target="_blank"><i class="fas fa-eye"></i> View</a>
					<br/>
					<br/>
				  <button type="button" class="button button-primary btn-close-vmmodal"><i class="fas fa-times"></i> Close</button>
			</div>
			<div id="avmaddtopost-modal" class="bmmodal" style="display:none">
				<h3>Create new post with Youtube Video: </h3>
				<div style="padding-left:18px;">
					<label for="newpost_name">Add video to the <select id="wherepost"><option value="0">beginning</option><option value="1">end</option></select> of post</label><br/><br/><br/>
				<button type="button" class="button button-primary" id="btn-do-addvideo-post"><i class="far fa-plus-square"></i> Add video to post</button>
				  <button type="button" class="button button-secondary btn-close-vmmodal"><i class="fas fa-times"></i> Cancel</button>
			</div>
			<div id="avmaddtopost-success-modal" class="bmmodal" style="display:none">
				<h3><i class="fas fa-check"></i> Success! The post has been updated. </h3>
				  <a class="button button-primary" href="#" id="btn-edit-new-post2" target="_blank"><i class="fas fa-edit"></i> Edit</a>
				  <a class="button button-primary" href="#" id="btn-view-new-post2" target="_blank"><i class="fas fa-eye"></i> View</a>
					<br/>
					<br/>
				  <button type="button" class="button button-primary btn-close-vmmodal"><i class="fas fa-times"></i> Close</button>
			</div>
		<?php
		global $wpdb;
		$total = $wpdb->get_var( "SELECT COUNT(*) FROM ".$wpdb->prefix."wpvmachine_requests" );
		$num_of_pages = ceil( $total / $per_page );
		$page_links = paginate_links( array(
			'base' => add_query_arg( /*'pagenum', '%#%'*/ array(
				    'pagenum' => '%#%'
				)
			),
			'format' => '',
			'end_size' => 4,
			'mid_size' => 3,
			'prev_text' => __( '«', 'text-domain' ),
			'next_text' => __( '»', 'text-domain' ),
			'total' => $num_of_pages,
			'current' => $page
		) );
		if ( $page_links ) {
		echo '<div class="tablenav" style="margin-right:24px"><div class="tablenav-pages" style="margin: 1em 0;">' . $page_links . '</div></div>';
		}
	}

	function wpvmachine_print_log( $page = 0, $per_page = 50 ) {
		$args = array();
		$log = wpvmachine_get_log( $page, $per_page );
		$str_ret = '<table class="widefat">';
		$str_ret .= '<thead><tr><th scope="col">#</th><th scope="col">Video</th><th scope="col">Date</th><th scope="col">Status</th><th scope="col">&nbsp;</th></tr></thead><tbody>';
		if( $log ) {
			$i = ( ($page-1) * $per_page ) + 1;
			foreach( $log as $entry ) {
				$status = $entry->state;
				if( !$status ) {
					$status = wpvmachine_get_vstatus( $entry->job_id );
				// var_dump($status);
				// var_dump($entry);
					if( $status[0] )
						update_log_status( $entry->id, $status[0], $status[1] );
					$status = $status[0];
				}
				// wpvmachine_get_vstatus
				// if( $entry->post_id )
				// 	$video_name = '<a href="'.get_permalink( $entry->post_id ).'"  target="_blank">'.$entry->title.'</a>';
				// else
					$video_name = $entry->title;

				$add_post_button = '';
				$yt_button = '';
				$share_button = '';
				if( $entry->youtube_id ) {
					$yt_button = ' <a href="https://www.youtube.com/watch?v='.$entry->youtube_id.'" target="_blank" class="button button-secondary" title="View on Youtube"><i class="fab fa-youtube"></i></a> ';
					$share_button = ' <a class="button button-secondary btn-share-video" href="#" data-video-id="'.$entry->id.'" data-youtube-url="https://www.youtube.com/watch?v='.$entry->youtube_id.'" title="Share Youtube Video"><i class="fas fa-share-alt"></i></a> ';
           			if( wpvmachine_is_pro() ) {
           				$share_button .= ' <a class="button button-secondary btn-syndicate-video" href="#" data-video-id="'.$entry->id.'" data-youtube-url="https://www.youtube.com/watch?v='.$entry->youtube_id.'" title="Syndicate Youtube Video"><i class="fas fa-retweet"></i></a> ';
           			}
           			if( $entry->post_id )
           				$share_button .= '<a class="button button-secondary btn-add-video-post" href="#" data-post-id="'.$entry->post_id.'" data-video-id="'.$entry->id.'" data-youtube-url="https://www.youtube.com/watch?v='.$entry->youtube_id.'" title="Add Video to Original Post"><i class="far fa-plus-square"></i></a>';
           			if( wpvmachine_is_pro() )
       					$share_button .= '<a class="button button-secondary btn-create-video-post" href="#" data-video-id="'.$entry->id.'" data-youtube-url="https://www.youtube.com/watch?v='.$entry->youtube_id.'" title="Create New Post"><i class="fas fa-thumbtack"></i></a>';
				}


				$str_ret .= '<tr><td>'.$i++.'</td><td class="vname">'.$video_name.'</td><td>'.$entry->requested_at_f.'</td><td>'.wpvmachine_status_text( $status ).'</td>
				<td>
				<a class="button button-primary" href="'.wpvmachine_report_url( $entry->job_id ).'" target="_blank"><i class="fas fa-info"></i> Video Info</a>
				<a class="button button-secondary" href="'.admin_url('/admin.php?page=wp-video-machine-newvid&vid='.$entry->id).'" target="_blank"><i class="fas fa-edit"></i> Edit</a>';
				if( $status == 1 ) {
					$str_ret .= ' <a class="button button-secondary" href="'.wpvmachine_download_url( $entry->job_id ).'" title="Download" target="_blank"><i class="fas fa-download"></i></a>'.$yt_button.$share_button;
				}
				$str_ret .= ' <a class="button button-secondary btn-del-video" href="#" data-video-id="'.$entry->id.'"><i class="fas fa-times"></i> Delete</a>';
				$str_ret .= '</td></tr>';
			}
		}
		$str_ret .= '</tbody></table>';
		echo $str_ret;
	}

	function wpvmachine_report_url( $job_id ) {
		$settings = wpvmachine_get_plugin_settings();
		// return 'https://azonvideomaker.com/app/request.php?lin=0&api='.wpvmachine_generate_api_key( $settings['email'] ).'&jobid='.$job_id;
		return WPVMACHINE_REPORTS_URL.'?lin=0&api='.wpvmachine_generate_api_key( $settings['email'] ).'&jobid='.$job_id;
	}

	function wpvmachine_download_url( $job_id ) {
		$settings = wpvmachine_get_plugin_settings();
		// return 'https://azonvideomaker.com/app/request.php?lin=0&api='.wpvmachine_generate_api_key( $settings['email'] ).'&jobid='.$job_id;
		return WPVMACHINE_DOWNLOAD_URL.'?api='.wpvmachine_generate_api_key( $settings['email'] ).'&jobid='.$job_id;
	}

  function wpvmachine_syndicate_list( $name = 'wpvmachine_syndicate', $values = array( 0, 0, 0, 0, 0, 0, 0, 0, 0 )  ) {
    $i = 0;
  ?>
  <label class="shr-link"><input type="checkbox" class="wpvmachine_syndicate_nw" value="1" name="<?php echo $name.'_facebook';?>" <?php checked( $values[$i++]);?> /> <i class="fab fa-blogger"></i> Blogger</label>
  <label class="shr-link"><input type="checkbox" class="wpvmachine_syndicate_nw" value="1" name="<?php echo $name.'_tumblr';?>" <?php checked( $values[$i++]);?> /> <i class="fas fa-book-open"></i> Livejournal</label>
  <label class="shr-link"><input type="checkbox" class="wpvmachine_syndicate_nw" value="1" name="<?php echo $name.'_tumblr';?>" <?php checked( $values[$i++]);?> /> <i class="fab fa-tumblr"></i> Tumblr</label>
  <label class="shr-link"><input type="checkbox" class="wpvmachine_syndicate_nw" value="1" name="<?php echo $name.'_twitter';?>" <?php checked( $values[$i++]);?> /> <i class="fas fa-paperclip"></i> Instapaper</label>
  <label class="shr-link"><input type="checkbox" class="wpvmachine_syndicate_nw" value="1" name="<?php echo $name.'_medium';?>" <?php checked( $values[$i++]);?> /> <i class="fab fa-vimeo"></i> Vimeo</label>
  <label class="shr-link"><input type="checkbox" class="wpvmachine_syndicate_nw" value="1" name="<?php echo $name.'_linkedin';?>" <?php checked( $values[$i++]);?> /> <i class="far fa-play-circle"></i> Dailymotion</label>
  <label class="shr-link"><input type="checkbox" class="wpvmachine_syndicate_nw" value="1" name="<?php echo $name.'_buffer';?>" <?php checked( $values[$i++]);?> /> <i class="fab fa-instagram"></i> Instagram</label>
  <?php
}

function wpvmachine_create_post_ajax() {
	$video_url = trim( $_POST['url'] );
	$title = trim( $_POST['title'] );

	// Create post object
	$my_post = array(
	  'post_title'    => wp_strip_all_tags( $title ),
	  'post_content'  => $video_url,
	  'post_status'   => 'publish'
	);

	// Insert the post into the database
	$post_id = wp_insert_post( $my_post );
	$post_permalink = get_permalink( $post_id );
	$post_edit = admin_url( 'post.php?post='.$post_id.'&action=edit' );
	$ret = array( 'id' => $post_id, 'link' => $post_permalink, 'edit' => $post_edit );
	echo json_encode( $ret );
	exit();
}

function wpvmachine_addto_post_ajax() {
	$video_url = trim( $_POST['url'] );
	$post_id = trim( $_POST['post_id'] );
	$position = intval( $_POST['position'] );

	global $wpdb;
	$kv_post = $wpdb->get_row("SELECT post_content,post_title FROM $wpdb->posts WHERE ID = ".$post_id );

	$orig_content = $kv_post->post_content;
	if( !$position )
		$content = '<p>'.$video_url.'</p>'.$orig_content;
	else
		$content = $orig_content.'<p>'.$video_url.'</p>';

	$kv_edited_post = array(
	      'ID'           => $post_id,
	      'post_content' => $content
	  );
	  wp_update_post( $kv_edited_post);

	$post_permalink = get_permalink( $post_id );
	$post_edit = admin_url( 'post.php?post='.$post_id.'&action=edit' );
	$ret = array( 'id' => $post_id, 'link' => $post_permalink, 'edit' => $post_edit );
	echo json_encode( $ret );
	exit();
}
?>