<?php
/**
 * Plugin Name: WP Video Machine
 * Plugin URI: https://wpvideomachine.com/
 * Description: Create great videos from your posts in one click to get maximum traffic and sales
 * Author: Ankur Shukla
   Version: 1.13
 * Author URI: https://ankurshukla.com
*/

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

define( 'WPVMACHINE_VERSION', '1.13' );

define( 'WPVMACHINE_DEBUG_MODE', 0 );

define( 'WPVMACHINE_PLUGIN_NAME', dirname( plugin_basename( __FILE__ ) ) );
define( 'WPVMACHINE_DIR', plugin_dir_path( __FILE__ ) );
define( 'WPVMACHINE_URL', plugins_url( WPVMACHINE_PLUGIN_NAME ) );

include WPVMACHINE_DIR.'/lib/common.php';
include WPVMACHINE_DIR.'/lib/utils.php';
include WPVMACHINE_DIR.'/lib/api.php';
if ( is_admin() ) {
	include WPVMACHINE_DIR.'/lib/view.php';
	include WPVMACHINE_DIR.'/lib/post-list.php';
	include WPVMACHINE_DIR.'/lib/fields.php';
	include WPVMACHINE_DIR.'/lib/settings.php';
	include WPVMACHINE_DIR.'/lib/videos.php';
	include WPVMACHINE_DIR.'/lib/video-creator.php';
	include WPVMACHINE_DIR.'/lib/help.php';
	include WPVMACHINE_DIR.'/lib/images.php';
	include WPVMACHINE_DIR.'/lib/ui.php';
	include WPVMACHINE_DIR.'/lib/styles/dashboard.php';
	include WPVMACHINE_DIR.'/lib/spinners.php';
	include WPVMACHINE_DIR.'/lib/affiliate.php';
	include WPVMACHINE_DIR.'/lib/translation.php';
	include WPVMACHINE_DIR.'/lib/tags.php';
	include WPVMACHINE_DIR.'/lib/content.php';
	include WPVMACHINE_DIR.'/lib/trends.php';
	include WPVMACHINE_DIR.'/lib/syndicate.php';
	include_once WPVMACHINE_DIR.'lib/traffic.php';
	include_once WPVMACHINE_DIR.'lib/traffic/traffic.php';
}

register_activation_hook ( __FILE__, 'wpvmachine_activation' );

add_action( 'wp_ajax_wpvmachine_get_tags', 'wpvmachine_do_get_tags' );
add_action( 'wp_ajax_wpvmachine_search_images', 'wpvmachine_do_search_images' );
add_action( 'wp_ajax_wpvmachine_delete_video', 'wpvmachine_do_delete_video' );
add_action( 'wp_ajax_wpvmachine_share_link', 'wpvmachine_share_link_ajax' );
add_action( 'wp_ajax_wpvmachine_spin_text', 'wpvmachine_spin_text_ajax' );
add_action( 'wp_ajax_wpvmachine_aff_links', 'wpvmachine_aff_links_ajax' );
add_action( 'wp_ajax_wpvmachine_translate_text', 'wpvmachine_translate_text_ajax' );
add_action( 'wp_ajax_wpvmachine_search_tags', 'wpvmachine_search_tags_ajax' );
add_action( 'wp_ajax_wpvmachine_search_content', 'wpvmachine_search_content_ajax' );
add_action( 'wp_ajax_wpvmachine_search_trends', 'wpvmachine_search_trends_ajax' );
add_action( 'wp_ajax_wpvmachine_syndicate_link', 'wpvmachine_syndicate_ajax' );
add_action( 'wp_ajax_wpvmachine_create_post', 'wpvmachine_create_post_ajax' );
add_action( 'wp_ajax_wpvmachine_addto_post', 'wpvmachine_addto_post_ajax' );

/* Automatic Updates */
require WPVMACHINE_DIR.'/lib/plugin-updates/plugin-update-checker.php';
$avm_update_checker = new Puc_v4p10_Plugin_UpdateChecker(
	( wpvmachine_is_pro() ? 'https://knighterrant.s3.us-west-2.amazonaws.com/software/wp-video-machine/2-pro/info_wpvm2.json' :
	'https://knighterrant.s3.us-west-2.amazonaws.com/software/wp-video-machine/1-std/info_wpvm1.json' ),
    WPVMACHINE_DIR.WPVMACHINE_PLUGIN_NAME.'.php'
);
?>